/*
 *	Scheduler defintions
 *	Copyright (C) 1998 Jim Moores
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef SCHED_H
#define SCHED_H

#include "sched_types.h"

#include "timer.h"

#ifdef ENABLE_CPU_TIMERS
extern unsigned long long glob_cpumhz;
#endif

/* PUBLIC variables that are used elsewhere in the run time system. */
extern sync_type sf;
extern word STATUS;

extern word* Wptr;
extern word* Tptr;

/* paramter passing variables */
extern word** channel_address;
extern word return_address;
extern byte* source_address;
extern byte* destination_address;
extern word count;
extern Time wait_time;
extern int test_time;
extern word start_address;
extern word guard;
extern word process_address;
extern word code_offset;
extern word precondition;
extern word *usage;
extern Time timeout;
extern word result;

/* pseudo private variables (there names are externally visible, but they */
/* should not be used. */
extern Time now;
extern word temp1;
extern word *temp_ptr;
extern word *other_workspace;
extern word *current;
extern word *previous;
extern word fired;
extern bool isexternal;
extern word trapval_A;
extern word trapval_B;
extern word trapval_C;
extern word overflow_info2;
extern word overflow_info;
extern word filename_addr;
extern word procedure_addr;
extern word zerodiv_info2;
extern word zerodiv_info;
extern word range_info1;
extern word range_info2;
extern word seterr_info1;
extern word seterr_info2;
extern word b_param;
extern word b_func;
extern word res_ptr;

extern word *sp_aptr;
extern word *sp_bptr;
extern word *sp_cptr;

extern word *occam_table;

void dead(int status);
void kernel_panic();
int c_enter(void);

#endif /* sched.h */
