/*
 *	Portable timer interface definitions
 *	Copyright (C) 1996-1999 Jim Moores
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef TIMER_HEADER
#define TIMER_HEADER

#include "csptime.h"

#include "rts.h"

#include "sched.h"

/* BEGIN UNIX IMPLEMENTATION */
#warning UNIX Timer Implmentation
#define GetTimeField(X) ((Time)((X)[Time_f]))

extern sync_type sf;

#ifdef INLINE_TIMERS
#define Time_GetTime() rtime()
#define Time_SetAlarm(t) ualarm(t,0)
#define Time_ResetAlarm() ualarm(0,0)
#define Time_PLUS(t1,t2) ((t1)+(t2))
#define Time_MINUS(t1,t2) ((t1)-(t2))
#define Time_AFTER(t1,t2) (((t1)-(t2))>0)
#define Time_PollAlarm() (sf.s.tim_sync)
#else
Time Time_GetTime(void);
bool Time_PollAlarm();
void Time_SetAlarm(Time);
void Time_ResetAlarm(void);
Time Time_PLUS(Time, Time);
Time Time_MINUS(Time, Time);
bool Time_AFTER(Time, Time);
#endif
/* END UNIX TIMER IMPLEMENTATION */

#endif /* timer.h */
