--
--	filelib.inc - include file for file library
--	Copyright (C) 2000 Fred Barnes <frmb2@ukc.ac.uk>
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

--{{{  constants for file.check.access
VAL R.OK IS 4:
VAL W.OK IS 2:
VAL X.OK IS 1:
VAL F.OK IS 0:
--}}}  

--{{{  constants for open
VAL O.RDONLY IS #0000:
VAL O.WRONLY IS #0001:
VAL O.RDWR IS #0002:
VAL O.CREAT IS #0040:
VAL O.EXCL IS #0080:
VAL O.NOCTTY IS #0100:
VAL O.TRUNC IS #0200:
VAL O.APPEND IS #0400:
--}}}  

--{{{  constants for seek
VAL SEEK.SET IS 0:
VAL SEEK.CUR IS 1:
VAL SEEK.END IS 2:
--}}}  

--{{{  constants for file permissions
VAL S.IRWXU IS #1C0:
VAL S.IRUSR IS #100:
VAL S.IWUSR IS #80:
VAL S.IXUSR IS #40:
VAL S.IRWXG IS #38:
VAL S.IRGRP IS #20:
VAL S.IWGRP IS #10:
VAL S.IXGRP IS #8:
VAL S.IRWXO IS #7:
VAL S.IROTH IS #4:
VAL S.IWOTH IS #2:
VAL S.IXOTH IS #1:
VAL S.I644 IS #1A4:
VAL S.I755 IS #1ED:
--}}}  

--{{{  external declarations for killable blocking calls
#PRAGMA EXTERNAL "PROC BX.fl.read (CHAN OF INT c, VAL INT fd, []BYTE buffer, INT result) = 2"
#PRAGMA EXTERNAL "PROC BX.fl.write (CHAN OF INT c, VAL INT fd, VAL []BYTE buffer, INT result) = 2"
#PRAGMA EXTERNAL "PROC BX.fl.fd.fd.copy (CHAN OF INT c, VAL INT src.fd, dst.fd, count, INT result) = 2"
--}}}  

