/*
 * KROC C configuration header file
 *
 * $Source: /extra/play/cvs/kroc/src/host/config.h,v $
 * 
 * $Id: config.h,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 * 
 * (C) Copyright 1996,1997 Dave Beckett <D.J.Beckett@ukc.ac.uk>,
 * University of Kent at Canterbury, England
 * 
 * If this file has the name "config.h.in" then it is a template for a
 * config.h; to generate the actual file, run "../configure", which is a
 * configuration script generated by hand (constructs like "@foo@" will get
 * replaced in the actual config.h.
 * 
 */


/* Written by configure */

#define HOST_CPU_I386 1
#define HOST_VENDOR_UNKNOWN 1
#define HOST_OS_UNIX 1

#define TARGET_CPU_ARM 1
#define TARGET_OS_UNKNOWN 1

#define HOST_STRING "--"
#define TARGET_STRING "@target_canonical@"

#define KROC_VERSION_STR "KROC Version 0.1"
#define KROC_VERSION_NUM "0.1"


/* Defaults */
#undef HAVE_BASENAME
#undef HAVE_GETRUSAGE
#undef HAVE_TIMES
#undef HAVE_UALARM
#undef HAVE_C_NO_LEADING_UNDERSCORE

#undef SIGNAL_TYPE_BSD
#undef SIGNAL_TYPE_SYSV
#undef CPP_PATH


/* CPU, vendor and OS dependencies */

/* sparc-sun-sunos4.1.3 and sparc-sun-sunos4.1.3_U1 */
#if defined(HOST_OS_SUNOS413) || defined(HOST_OS_SUNOS413U1)

#define HAVE_GETRUSAGE
#define HAVE_TIMES
#define HAVE_UALARM

#define SIGNAL_TYPE_BSD 1

#define CPP_PATH "/usr/lib/cpp"

#endif


/* sparc-sun-solaris2.3, 2.4 and 2.5 */
#if defined(HOST_OS_SOLARIS23) || defined(HOST_OS_SOLARIS24) || defined(HOST_OS_SOLARIS25)

#define HAVE_GETRUSAGE

#define HAVE_C_NO_LEADING_UNDERSCORE

#define SIGNAL_TYPE_SYSV 1

#define CPP_PATH "/usr/ccs/lib/cpp"

#endif


/* alpha-dec-osf3.0 */
#if defined(HOST_OS_OSF30)

#define SIGNAL_TYPE_SYSV 1

#define HAVE_BASENAME
#define HAVE_TIMES
#define HAVE_GETRUSAGE
#define HAVE_UALARM
#define HAVE_C_NO_LEADING_UNDERSCORE

#define CPP_PATH "/usr/lib/cpp"

#endif


/* powerpc-parsytec-parix */
#if defined (HOST_OS_PARIX)

#define HAVE_UALARM

#endif
