/*
 * KROC translator: The .BYTE/byte directive.
 *
 * $Source: /extra/play/cvs/kroc/src/host/f_byte.c,v $
 *
 * $Id: f_byte.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 *
 * Derived from f_byte.c:
 * (C) Copyright 1995,1996,1997 D.C. Wood <D.C.Wood@ukc.ac.uk>
 *   /proj/kroc/develop/src/RCS/f_byte.c,v
 *   f_byte.c,v 1.9 1997/01/08 17:23:26 djb1 Exp
 *
 * f_byte.c:
 * (C) Copyright 1999 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 * Mostly independent of target, except for generating output.
 */

static char f_byte_c_rcsid[] = "$Id: f_byte.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

int hex1 (int i)                    /* one hex. digit */
{
    char ch;
    ch = buffer[i];
    if (ch >= '0' && ch <= '9')
        return ch - '0';
    if (ch >= 'A' && ch <= 'F')
        return ch - 'A' + 0xA;
    if (ch >= 'a' && ch <= 'f')
        return ch - 'a' + 0xa;
    else
        return 0;       /* ??? */
}

int hex2 (int i)                    /* two hex. digits */
{
    int j;
    j = hex1 (++i);
    return (j << 4) + hex1 (++i);
}

int word (char *buff)                 /* convert .BYTEs to reversed .WORD */
{
    int i, w;
    w = 0;
    for (i = BytesPerWord - 1; i >= 0; --i)
        w = (w << 8) + (buff[i] & 0xff);
    return w;
}

void BYTE (void)                    /* process .BYTE/byte data */
{
    int i, j;
    char bytebuff[BYTE_SIZE];

    j = 0;
    for (i = B_BYTE; i < BUF_SIZE; ++i)
    {
        switch (buffer[i])
        {
            case ' ':
            case ',':       /* (for "byte" only) */
                continue;
            case '#':
                bytebuff[j] = hex2 (i);
                i += 2;
                j += 1;
                continue;
            default:
                break;
        }
        break;
    }

    if (o_reverse)
    {
        while ((j & (BytesPerWord - 1)) != 0)       /* pack last word */
            bytebuff[j++] = 0;

        for (i = 0; i < j; i += BytesPerWord)
        {
#if defined(TARGET_CPU_SPARC)
            mnem(".word");                              /* target-dependent */
#elif defined(TARGET_CPU_ALPHA)
            mnem(".long");                              /* target-dependent */
#elif defined(TARGET_CPU_ARM)
            mnem("DCD");                                /* target-dependent */
#endif
            sep ();
            fprintf (out, "0x%08x", word (&bytebuff[i]));
            nl;
        }
    }
    else
    {                             /* target-dependent */
#if defined(TARGET_CPU_ALPHA)
        while ((j & 3) != 0)   /* pack last lword */
            bytebuff[j++] = 0;
#endif
#if defined(TARGET_CPU_SPARC) || defined(TARGET_CPU_ALPHA)
        mnem(".byte");                              /* target-dependent */
#elif defined(TARGET_CPU_ARM)
        mnem("DCD");                                /* target-dependent */
#endif
        for (i = 0; i < j; ++i)
        {
            sep ();
            fprintf (out, "0x%02x", bytebuff[i] & 0xff);
            nl;
        }
    } /* if (o_reverse) */
  
    istackp = 0;
    ishuff = 0;
}
