/*
 * Occam for All project occam / C interface tool
 *
 * $Source: /extra/play/cvs/kroc/src/host/ocinf.h,v $
 *
 * $Id: ocinf.h,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 Carl Lewis
 * University of Kent at Canterbury
 */

#define MAX_TYPEDEFS  1000
#define MAX_PROTOTYPES 1000
#define MAX_IDENTIFIERS 10000
#define MAX_NODE_MATCHES 100

typedef int BOOLEAN;

/* Bad choice of names */
#undef TRUE
#define TRUE   (0==0)
#undef FALSE
#define FALSE  (!TRUE)

typedef enum {
  abstract_declarator, additive_expression, and_expression,
  argument_expression_list, assignment_expression, assignment_operator,
  cast_expression, compound_statement, conditional_expression,
  constant_expression, declaration, declaration_list,
  declaration_specifiers, declarator, direct_abstract_declarator,
  direct_declarator, enum_specifier, enumerator,
  enumerator_list, equality_expression, exclusive_or_expression,
  expression, expression_statement, external_declaration,
  function_definition, identifier_list, inclusive_or_expression,
  init_declarator, init_declarator_list, initializer,
  initializer_list, iteration_statement, jump_statement,
  labeled_statement, logical_and_expression, logical_or_expression,
  multiplicative_expression, parameter_declaration, parameter_list,
  parameter_type_list, pointer, postfix_expression,
  primary_expression, relational_expression, selection_statement,
  shift_expression, specifier_qualifier_list, statement,
  statement_list, storage_class_specifier, struct_declaration,
  struct_declaration_list, struct_declarator, struct_declarator_list,
  struct_or_union, struct_or_union_specifier, translation_unit,
  type_name, type_qualifier, type_qualifier_list,
  type_specifier, unary_expression, unary_operator 
} node_types;


typedef enum {
  IDENTIFIER, CONSTANT, STRING_LITERAL, SIZEOF,
  PTR_OP, INC_OP, DEC_OP, LEFT_OP, RIGHT_OP, LE_OP, GE_OP, EQ_OP, NE_OP,
  AND_OP, OR_OP, MUL_ASSIGN, DIV_ASSIGN, MOD_ASSIGN, ADD_ASSIGN,
  SUB_ASSIGN, LEFT_ASSIGN, RIGHT_ASSIGN, AND_ASSIGN,
  XOR_ASSIGN, OR_ASSIGN, TYPE_NAME,
  TYPEDEF, EXTERN, STATIC, AUTO, REGISTER,
  CHAR, SHORT, INT, LONG, SIGNED, UNSIGNED, FLOAT, DOUBLE, CONST, VOLATILE, VOID,
  STRUCT, UNION, ENUM, ELIPSIS, RANGE,
  CASE, DEFAULT, IF, ELSE, SWITCH, WHILE, DO, FOR, GOTO, CONTINUE, BREAK, RETURN
} leaf_types;


typedef int leaf_value;
#define NULL_LV (leaf_value)0


struct NODE {
  BOOLEAN       leaf;
  
  node_types    ntype;
  int           ncase;
  
  struct NODE  *ptr1;
  struct NODE  *ptr2;
  struct NODE  *ptr3;
  
  leaf_types    ltype;
  leaf_value    lvalue;
};


 
struct LEAF {
  BOOLEAN       leaf;
  leaf_types    ltype;
  leaf_value    lvalue;
};


struct CON {
  int C_type;
  union C_val {int ival; float fval; } C_val;
};

/* Identifier name structure */
struct Iname {
  char *name;
  int  index;
};

/* Typedef name structure */
struct Tname {
  char *name;
  int  tindex;
};


typedef struct NODE *node_ptr;
typedef struct LEAF *leaf_ptr;


#define   ILLEGAL(str)              { fprintf(stderr, "%s: Illegal: ", program_name); fprintf(stderr, str); fputs("\n", stderr); exit(1); }  
#define   ASSERT(expr,str)          { if (!(expr)) { fprintf(stderr, "%s: Assertion failed: ", program_name); fprintf(stderr, str); fputs("\n", stderr); exit(1); };} 
#define   WARNING(str)              { fprintf(stderr, "%s: Warning: ", program_name); fprintf(stderr, str); fputs("\n", stderr); T_Warnings++; }
#define   COMMENT(str)              { printf(str); }
#define   COMMENT2(str, v1)         { printf(str,v1); }
#define   COMMENT3(str, v1, v2)     { printf(str,v1,v2); }
#define   COMMENT4(str, v1, v2, v3) { printf(str,v1,v2,v3); }
#define   ENTRY2(str,tree)          { if (DEBUG_TRACE) { fprintf(stderr, "%s: ENTRY: ", program_name); fputs(str, stderr); fprintf(stderr, " (%d)\n", NODE_CASE(tree)); } }
#define   ENTRY(str)                { if (DEBUG_TRACE) { fprintf(stderr, "%s: ENTRY: ", program_name); fputs(str, stderr); fprintf(stderr, "\n"); } }
#define   ENTRY_(str)               { if (DEBUG_TRACE_LEVEL>0)  ENTRY(str)  }
#define   ENTRY__(str)              { if (DEBUG_TRACE_LEVEL>1)  ENTRY(str)  }
#define   ENTRY___(str)             { if (DEBUG_TRACE_LEVEL>2)  ENTRY(str)  }
#define   WATCH_POINT(str)          { if (DEBUG_WATCH) { fprintf(stderr, "%s: WATCH_POINT: ", program_name); fprintf(stderr, str); fprintf(stderr, "\n"); } }

typedef enum {VAR, ARR, PRO, TYP, UNKNOWN} DECL_TYPE;

