
%{

#define NULL_Node  ((struct NODE *) NULL)
#define NULL_Leaf  ((struct LEAF *) NULL)


#include <stdio.h>
#include <string.h>

#include "config.h"
#include "ocinf.h"
#include "common.h"

static char ocinf_y_rcsid[] = "$Id: ocinf.y,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

int no_typedefs = 0;
char *typedef_names[MAX_TYPEDEFS+2];
struct NODE *typedef_type_info[MAX_TYPEDEFS+2];
BOOLEAN      typedef_type_pointer[MAX_TYPEDEFS+2];
int          typedef_type_sizes[MAX_TYPEDEFS+2];
int          typedef_pointer_level[MAX_TYPEDEFS+2];

int no_prototypes = 0;
char *prototype_names[MAX_PROTOTYPES+2];
int   parameter_count[MAX_PROTOTYPES+2];
struct NODE *prototype_type_info[MAX_PROTOTYPES+2];
struct NODE *prototype_parameter_ptr[MAX_PROTOTYPES+2];
BOOLEAN prototype_returns_pointer[MAX_PROTOTYPES+2];
BOOLEAN prototypes_check_status_passed[MAX_PROTOTYPES+2];
int     prototype_return_pointer_level[MAX_PROTOTYPES+2];

int no_identifiers = 0;
char *identifier_names[MAX_IDENTIFIERS+2];


int typedef_level = 0;
int struct_or_union_level = 0;

struct NODE *parse_tree;

struct NODE *Node_Matches[MAX_NODE_MATCHES+2];
int          Node_Matches_Count = 0;

extern char kroc_version_message[];	/* In version.c */

const char *program_name;


/* Function prototypes */

char *tmpnam (char *s);
int system (const char *cmd);
int atoi (const char *s);

extern int yyparse (void);
extern FILE *yyin;
char *MAKESTR (const char *s1, const char *s2);
void DOT_TO_UNDERSCORE (char *str);
int main (int argc, char *argv[]);
void PREPROCESS (const char *input_file_name, const char *output_file_name, const char *cpp_command, const char *cppflags);
void enter_typedef (void);
void leave_typedef (void);
void enter_struct_or_union (void);
void leave_struct_or_union (void);
void yyerror (char *s);
void fatal (const char *s);
struct NODE *MAKENODE (node_types node_type, int rule_case, struct NODE *ptr1, struct NODE *ptr2, struct NODE *ptr3);
struct NODE *NULLNODE (node_types node_type, int rule_case, struct NODE *ptr1, struct NODE *ptr2, struct NODE *ptr3);
struct NODE *MAKELEAF (leaf_types leaf_type, leaf_value lv);
char *lookup_node_name (int node_no);
char *lookup_leaf_name (int leaf_no);
BOOLEAN typedef_symbol_table_find (char *name);
int typedef_symbol_table_index (char *name);
void typedef_symbol_table_add (char *name);
void typedef_symbol_table_add_typeinfo (struct NODE *tree, int index);
void typedef_symbol_table_add_type_pointer (BOOLEAN flag, int index);
void typedef_symbol_table_add_pointer_level (int level, int index);
void typedef_symbol_table_print (void);
char *typedef_symbol_table_ptr (int index));
char *LOOKUP_TYPE_NAME (struct NODE *tree);
int LOOKUP_TYPE_INDEX (struct NODE *tree);
int EXTRACT_TYPE_INDEX (struct NODE *tree);
int identifier_symbol_table_add (char *name);
char *identifier_symbol_table_ptr (int index);
void prototype_symbol_table_add (char *name);
void prototype_symbol_table_add_params (int count);
void prototype_symbol_table_add_typeinfo (struct NODE *tree);
void prototype_symbol_table_add_param_ptr (struct NODE *tree);
void prototype_symbol_table_add_returns_pointer (BOOLEAN flag);
void prototype_symbol_table_add_pointer_level (int level);
void print_prototype_table (void);
void SCAN_input (struct NODE *tree);
void SCAN_ (struct NODE *tree);
void SCAN_translation_unit (struct NODE *tree);
void SCAN_external_declaration (struct NODE *tree);
void SCAN_declaration (struct NODE *tree);
void SCAN_init_declarator_list (struct NODE *tree);
void SCAN_init_declarator (struct NODE *tree);
void SCAN_declarator (struct NODE *tree);
void SCAN_direct_declarator (struct NODE *tree);
void SCAN_identifier (struct NODE *tree);
void EXTRACT_ (struct NODE *tree);
DECL_TYPE DETERMINE_TYPE (struct NODE *tree);
node_types NODE_TYPE (struct NODE *ptr);
int NODE_CASE (struct NODE *ptr);
struct NODE *NODE_PTR (struct NODE *ptr, int ptr_no);
struct NODE *RIGHTMOST_NON_NULL_PTR (struct NODE *ptr, int index);
struct NODE *RIGHTMOST_PTR (struct NODE *ptr);
int COUNT_LIST_ENTRIES (struct NODE *ptr);
void SCAN_typedef_sizes (const char *c_compiler_command, const char *cpp_command, const char *cppflags);
void PRINT_PARAM_INFO (struct NODE *tree);
void PRINT_declaration_specifiers (struct NODE *tree);
void PRINT_storage_class_specifier (struct NODE *tree);
void PRINT_type_specifier (struct NODE *tree);
void PRINT_type_qualifier (struct NODE *tree);
void PRINT_declarator (struct NODE *tree);
void PRINT_pointer (struct NODE *tree);
void PRINT_type_qualifier_list (struct NODE *tree);
void PRINT_direct_declarator (struct NODE *tree);
void PRINT_parameter_type_list (struct NODE *tree);
void PRINT_parameter_list (struct NODE *tree);
void PRINT_parameter_declaration (struct NODE *tree);
void PRINT_identifier_list (struct NODE *tree);
void PRINT_identifier_name (struct NODE *tree);
void PRINT_typedef_name (struct NODE *tree);
const char *TOP_LEVEL_TYPE (struct NODE *tree);
void PRINT_abstract_declarator (struct NODE *tree);
void PRINT_direct_abstract_declarator (struct NODE *tree);
void TYPE_CHECK (void);
void TYPE_CHECK_prototype (int index);
BOOLEAN ENDIAN_MANIPULATION (struct NODE *tree);
BOOLEAN IS_STRUCTURE_TYPEDEF (int index);
void TRANSLATE_C (void);
void TRANSLATE_OCC (void);
void GET_prototype_info (int index);
void SHOW_proto_info (int index);
struct NODE *GET_param_type (struct NODE *tree);
char *GET_param_name (struct NODE *tree);
BOOLEAN DISALLOW (node_types ntype, int ncase, struct NODE *tree);
void SUBSTITUTE (char *str);
int TYPENAME_INDEX (char *name);
int TYPENAME_SIZE (char *name);
int POINTER_LEVEL (BOOLEAN flag, struct NODE *tree);
int TYPE_LEVEL (struct NODE *tree);
void TRANSLATE_OCC_prototype (void);
void TRANSLATE_OCC_output (const char *str);
void TRANSLATE_OCC_output_wrap (const char *str);
void TRANSLATE_OCC_output_comment (const char *str);
void TRANSLATE_OCC_output_number (int value);
void TRANSLATE_OCC_head (void);
void TRANSLATE_OCC_name (void);
void TRANSLATE_OCC_begin_parameters (void);
void TRANSLATE_OCC_return_value (void);
void TRANSLATE_OCC_parameters (void);
void TRANSLATE_OCC_parameter (int index);
void TRANSLATE_OCC_end_parameters (void);
void TRANSLATE_OCC_tail (void);
void TRANSLATE_OCC_typedef_sizes (void);
void TRANSLATE_C_prototype (void);
void TRANSLATE_C_output (const char *str);
void TRANSLATE_C_output_wrap (const char *str);
void TRANSLATE_C_output_comment (const char *str);
void TRANSLATE_C_output_number (int value);
void TRANSLATE_C_TYPE_declarations (void);
void TRANSLATE_C_include (void);
void TRANSLATE_C_return_value (void);
void TRANSLATE_C_name (void);
void TRANSLATE_C_begin_parameters (void);
void TRANSLATE_C_parameters (void);
void TRANSLATE_C_end_parameters (void);
void TRANSLATE_C_workspace (void);
void TRANSLATE_C_body (void);
void TRANSLATE_C_call_argument (int index);
void TRANSLATE_C_Declare_Double (int no);
void TRANSLATE_C_Declare_longlong (int no);
void TRANSLATE_C_Endian_declarations (void);
void TRANSLATE_C_Pre_Endian_Double (int no);
void TRANSLATE_C_Pre_Endian_longlong (int no);
void TRANSLATE_C_Pre_Endian (void);
void TRANSLATE_C_Post_Endian_Double (int no);
void TRANSLATE_C_Post_Endian_longlong (int no);
void TRANSLATE_C_Post_Endian (void);
void TRANSLATE_C_Restore_fp (void);
char *inttostr (int no);
char *REPLACE_HASH (const char *str, int no);
void BEGIN_CAST (int param);
void BEGIN_CAST_RETURN (void);
void END_CAST (int param);
void END_CAST_RETURN (void);
void BEGIN_REFERENCE_VALUE (void);
void END_REFERENCE_VALUE (void);
BOOLEAN IS_LEAF (struct NODE *tree);
leaf_types LEAF_TYPE (struct NODE *tree);
leaf_value LEAF_VALUE (struct NODE *tree);
leaf_types LEFTMOST_LEAF_TYPE (struct NODE *tree);
leaf_value LEFTMOST_LEAF_VALUE (struct NODE *tree);
leaf_types RIGHTMOST_LEAF_TYPE (struct NODE *tree);
leaf_value RIGHTMOST_LEAF_VALUE (struct NODE *tree);
struct NODE *SEARCH_FOR_NODE_CASE (node_types grule, int gcase, struct NODE *tree);
struct NODE *SEARCH_FOR_LEAF_TYPE (leaf_types ltype, struct NODE *tree);
int COUNT_NODE_CASE_MATCHES (node_types grule, int gcase, struct NODE *tree);
void ADD_MATCH (struct NODE *tree);
void ADD_NODE_MATCHES (node_types grule, int gcase, struct NODE *tree);
void EXTRACT_NODE_CASE_MATCHES (node_types grule, int gcase, struct NODE *tree);


%}

%union  {  
        struct NODE  *node; 
        struct LEAF  *leaf;
        struct CON   con;
        struct Tname tname;
        struct Iname iname;
	char none;
}


%token IDENTIFIER CONSTANT STRING_LITERAL SIZEOF
%token PTR_OP INC_OP DEC_OP LEFT_OP RIGHT_OP LE_OP GE_OP EQ_OP NE_OP
%token AND_OP OR_OP MUL_ASSIGN DIV_ASSIGN MOD_ASSIGN ADD_ASSIGN
%token SUB_ASSIGN LEFT_ASSIGN RIGHT_ASSIGN AND_ASSIGN
%token XOR_ASSIGN OR_ASSIGN TYPE_NAME

%token TYPEDEF EXTERN STATIC AUTO REGISTER
%token CHAR SHORT INT LONG SIGNED UNSIGNED FLOAT DOUBLE CONST VOLATILE VOID
%token STRUCT UNION ENUM ELIPSIS RANGE

%token CASE DEFAULT IF ELSE SWITCH WHILE DO FOR GOTO CONTINUE BREAK RETURN

%nonassoc ELSE
%nonassoc THEN
%right    '='

%start top_level 

%type <iname>  IDENTIFIER 
%type <con>    CONSTANT 
%type <tname>  TYPE_NAME
%type <none>  STRING_LITERAL 
%type <none>  SIZEOF
%type <none>  PTR_OP 
%type <none>  INC_OP 
%type <none>  DEC_OP 
%type <none>  LEFT_OP 
%type <none>  RIGHT_OP 
%type <none>  LE_OP 
%type <none>  GE_OP 
%type <none>  EQ_OP 
%type <none>  NE_OP
%type <none>  AND_OP 
%type <none>  OR_OP 
%type <none>  MUL_ASSIGN 
%type <none>  DIV_ASSIGN 
%type <none>  MOD_ASSIGN 
%type <none>  ADD_ASSIGN
%type <none>  SUB_ASSIGN 
%type <none>  LEFT_ASSIGN 
%type <none>  RIGHT_ASSIGN 
%type <none>  AND_ASSIGN
%type <none>  XOR_ASSIGN 
%type <none>  OR_ASSIGN 
%type <none>  TYPEDEF 
%type <none>  EXTERN 
%type <none>  STATIC 
%type <none>  AUTO 
%type <none>  REGISTER
%type <none>  CHAR 
%type <none>  SHORT 
%type <none>  INT 
%type <none>  LONG 
%type <none>  SIGNED 
%type <none>  UNSIGNED 
%type <none>  FLOAT 
%type <none>  DOUBLE 
%type <none>  CONST 
%type <none>  VOLATILE 
%type <none>  VOID
%type <none>  STRUCT 
%type <none>  UNION 
%type <none>  ENUM 
%type <none>  ELIPSIS 
%type <none>  RANGE
%type <none>  CASE 
%type <none>  DEFAULT 
%type <none>  IF 
%type <none>  ELSE 
%type <none>  SWITCH 
%type <none>  WHILE 
%type <none>  DO 
%type <none>  FOR 
%type <none>  GOTO 
%type <none>  CONTINUE 
%type <none>  BREAK 
%type <none>  RETURN
%type <none>  ELSE


%type <node>  abstract_declarator
%type <node>  additive_expression
%type <node>  and_expression
%type <node>  argument_expression_list
%type <node>  assignment_expression
%type <node>  assignment_operator
%type <node>  cast_expression
%type <node>  compound_statement
%type <node>  conditional_expression
%type <node>  constant_expression
%type <node>  declaration
%type <node>  declaration_list
%type <node>  declaration_specifiers
%type <node>  declarator
%type <node>  direct_abstract_declarator
%type <node>  direct_declarator
%type <node>  enum_specifier
%type <node>  enumerator
%type <node>  enumerator_list
%type <node>  equality_expression
%type <node>  exclusive_or_expression
%type <node>  expression
%type <node>  expression_statement
%type <node>  external_declaration
%type <node>  function_definition
%type <node>  identifier_list
%type <node>  inclusive_or_expression
%type <node>  init_declarator
%type <node>  init_declarator_list
%type <node>  initializer
%type <node>  initializer_list
%type <node>  iteration_statement
%type <node>  jump_statement
%type <node>  labeled_statement
%type <node>  logical_and_expression
%type <node>  logical_or_expression
%type <node>  multiplicative_expression
%type <node>  parameter_declaration
%type <node>  parameter_list
%type <node>  parameter_type_list
%type <node>  pointer
%type <node>  postfix_expression
%type <node>  primary_expression
%type <node>  relational_expression
%type <node>  selection_statement
%type <node>  shift_expression
%type <node>  specifier_qualifier_list
%type <node>  statement
%type <node>  statement_list
%type <node>  storage_class_specifier
%type <node>  struct_declaration
%type <node>  struct_declaration_list
%type <node>  struct_declarator
%type <node>  struct_declarator_list
%type <node>  struct_or_union
%type <node>  struct_or_union_specifier
%type <node>  translation_unit
%type <node>  type_name
%type <node>  type_qualifier
%type <node>  type_qualifier_list
%type <node>  type_specifier
%type <node>  unary_expression
%type <node>  unary_operator

%type <node>  top_level

%%

primary_expression
        : IDENTIFIER
             { $$ = NULLNODE(primary_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | CONSTANT
             { $$ = NULLNODE(primary_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | STRING_LITERAL
             { $$ = NULLNODE(primary_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        | '(' expression ')'
             { $$ = NULLNODE(primary_expression,4,NULL_Node,NULL_Node,NULL_Node); }
        ;

postfix_expression
        : primary_expression
             { $$ = NULLNODE(postfix_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression '[' expression ']'
             { $$ = NULLNODE(postfix_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression '(' ')'
             { $$ = NULLNODE(postfix_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression '(' argument_expression_list ')'
             { $$ = NULLNODE(postfix_expression,4,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression '.' IDENTIFIER
             { $$ = NULLNODE(postfix_expression,5,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression PTR_OP IDENTIFIER
             { $$ = NULLNODE(postfix_expression,6,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression INC_OP
             { $$ = NULLNODE(postfix_expression,7,NULL_Node,NULL_Node,NULL_Node); }
        | postfix_expression DEC_OP
             { $$ = NULLNODE(postfix_expression,8,NULL_Node,NULL_Node,NULL_Node); }
        ;

argument_expression_list
        : assignment_expression
             { $$ = NULLNODE(argument_expression_list,1,NULL_Node,NULL_Node,NULL_Node); }
        | argument_expression_list ',' assignment_expression
             { $$ = NULLNODE(argument_expression_list,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

unary_expression
        : postfix_expression
             { $$ = NULLNODE(unary_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | INC_OP unary_expression
             { $$ = NULLNODE(unary_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | DEC_OP unary_expression
             { $$ = NULLNODE(unary_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        | unary_operator cast_expression
             { $$ = NULLNODE(unary_expression,4,NULL_Node,NULL_Node,NULL_Node); }
        | SIZEOF unary_expression
             { $$ = NULLNODE(unary_expression,5,NULL_Node,NULL_Node,NULL_Node); }
        | SIZEOF '(' type_name ')'
             { $$ = NULLNODE(unary_expression,6,NULL_Node,NULL_Node,NULL_Node); }
        ;

unary_operator
        : '&'
             { $$ = NULLNODE(unary_operator,1,NULL_Node,NULL_Node,NULL_Node); }
        | '*'
             { $$ = NULLNODE(unary_operator,2,NULL_Node,NULL_Node,NULL_Node); }
        | '+'
             { $$ = NULLNODE(unary_operator,3,NULL_Node,NULL_Node,NULL_Node); }
        | '-'
             { $$ = NULLNODE(unary_operator,4,NULL_Node,NULL_Node,NULL_Node); }
        | '~'
             { $$ = NULLNODE(unary_operator,5,NULL_Node,NULL_Node,NULL_Node); }
        | '!'
             { $$ = NULLNODE(unary_operator,6,NULL_Node,NULL_Node,NULL_Node); }
        ;

cast_expression
        : unary_expression
             { $$ = NULLNODE(cast_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | '(' type_name ')' cast_expression
             { $$ = NULLNODE(cast_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;


multiplicative_expression
        : cast_expression
             { $$ = NULLNODE(multiplicative_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | multiplicative_expression '*' cast_expression
             { $$ = NULLNODE(multiplicative_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | multiplicative_expression '/' cast_expression
             { $$ = NULLNODE(multiplicative_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        | multiplicative_expression '%' cast_expression
             { $$ = NULLNODE(multiplicative_expression,4,NULL_Node,NULL_Node,NULL_Node); }
        ;

additive_expression
        : multiplicative_expression
             { $$ = NULLNODE(additive_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | additive_expression '+' multiplicative_expression
             { $$ = NULLNODE(additive_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | additive_expression '-' multiplicative_expression
             { $$ = NULLNODE(additive_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        ;

shift_expression
        : additive_expression
             { $$ = NULLNODE(shift_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | shift_expression LEFT_OP additive_expression
             { $$ = NULLNODE(shift_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | shift_expression RIGHT_OP additive_expression
             { $$ = NULLNODE(shift_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        ;

relational_expression
        : shift_expression
             { $$ = NULLNODE(relational_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | relational_expression '<' shift_expression
             { $$ = NULLNODE(relational_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | relational_expression '>' shift_expression
             { $$ = NULLNODE(relational_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        | relational_expression LE_OP shift_expression
             { $$ = NULLNODE(relational_expression,4,NULL_Node,NULL_Node,NULL_Node); }
        | relational_expression GE_OP shift_expression
             { $$ = NULLNODE(relational_expression,5,NULL_Node,NULL_Node,NULL_Node); }
        ;

equality_expression
        : relational_expression
             { $$ = NULLNODE(equality_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | equality_expression EQ_OP relational_expression
             { $$ = NULLNODE(equality_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        | equality_expression NE_OP relational_expression
             { $$ = NULLNODE(equality_expression,3,NULL_Node,NULL_Node,NULL_Node); }
        ;

and_expression
        : equality_expression
             { $$ = NULLNODE(and_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | and_expression '&' equality_expression
             { $$ = NULLNODE(and_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

exclusive_or_expression
        : and_expression
             { $$ = NULLNODE(exclusive_or_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | exclusive_or_expression '^' and_expression
             { $$ = NULLNODE(exclusive_or_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

inclusive_or_expression
        : exclusive_or_expression
             { $$ = NULLNODE(inclusive_or_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | inclusive_or_expression '|' exclusive_or_expression
             { $$ = NULLNODE(inclusive_or_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

logical_and_expression
        : inclusive_or_expression
             { $$ = NULLNODE(logical_and_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | logical_and_expression AND_OP inclusive_or_expression
             { $$ = NULLNODE(logical_and_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

logical_or_expression
        : logical_and_expression
             { $$ = NULLNODE(logical_or_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | logical_or_expression OR_OP logical_and_expression
             { $$ = NULLNODE(logical_or_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

conditional_expression
        : logical_or_expression
             { $$ = NULLNODE(conditional_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | logical_or_expression '?' expression ':' conditional_expression
             { $$ = NULLNODE(conditional_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

assignment_expression
        : conditional_expression
             { $$ = NULLNODE(assignment_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | unary_expression assignment_operator assignment_expression
             { $$ = NULLNODE(assignment_expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

assignment_operator
        : '='
             { $$ = NULLNODE(assignment_operator,1,NULL_Node,NULL_Node,NULL_Node); }
        | MUL_ASSIGN
             { $$ = NULLNODE(assignment_operator,2,NULL_Node,NULL_Node,NULL_Node); }
        | DIV_ASSIGN
             { $$ = NULLNODE(assignment_operator,3,NULL_Node,NULL_Node,NULL_Node); }
        | MOD_ASSIGN
             { $$ = NULLNODE(assignment_operator,4,NULL_Node,NULL_Node,NULL_Node); }
        | ADD_ASSIGN
             { $$ = NULLNODE(assignment_operator,5,NULL_Node,NULL_Node,NULL_Node); }
        | SUB_ASSIGN
             { $$ = NULLNODE(assignment_operator,6,NULL_Node,NULL_Node,NULL_Node); }
        | LEFT_ASSIGN
             { $$ = NULLNODE(assignment_operator,7,NULL_Node,NULL_Node,NULL_Node); }
        | RIGHT_ASSIGN
             { $$ = NULLNODE(assignment_operator,8,NULL_Node,NULL_Node,NULL_Node); }
        | AND_ASSIGN
             { $$ = NULLNODE(assignment_operator,9,NULL_Node,NULL_Node,NULL_Node); }
        | XOR_ASSIGN
             { $$ = NULLNODE(assignment_operator,10,NULL_Node,NULL_Node,NULL_Node); }
        | OR_ASSIGN
             { $$ = NULLNODE(assignment_operator,11,NULL_Node,NULL_Node,NULL_Node); }
        ;

expression
        : assignment_expression
             { $$ = NULLNODE(expression,1,NULL_Node,NULL_Node,NULL_Node); }
        | expression ',' assignment_expression
             { $$ = NULLNODE(expression,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

constant_expression
        : conditional_expression
             { $$ = NULLNODE(constant_expression,1,NULL_Node,NULL_Node,NULL_Node); }
        ;


declaration
        : declaration_specifiers ';'
            { leave_typedef();  
              $$ = MAKENODE(declaration,1,$1,NULL_Node,NULL_Node); }
        | declaration_specifiers init_declarator_list ';'
            { leave_typedef(); 
              $$ = MAKENODE(declaration,2,$1,$2,NULL_Node); }
       ;

declaration_specifiers
        : storage_class_specifier
            { $$ = MAKENODE(declaration_specifiers,1,$1,NULL_Node,NULL_Node); }
        | storage_class_specifier declaration_specifiers
            { $$ = MAKENODE(declaration_specifiers,2,$1,$2,NULL_Node); }
        | type_specifier
            { $$ = MAKENODE(declaration_specifiers,3,$1,NULL_Node,NULL_Node); }
        | type_specifier declaration_specifiers
            { $$ = MAKENODE(declaration_specifiers,4,$1,$2,NULL_Node); }
        | type_qualifier
            { $$ = MAKENODE(declaration_specifiers,5,$1,NULL_Node,NULL_Node); }
        | type_qualifier declaration_specifiers
            { $$ = MAKENODE(declaration_specifiers,6,$1,$2,NULL_Node); }
        ;

init_declarator_list
        : init_declarator
            { $$ = MAKENODE(init_declarator_list,1,$1,NULL_Node,NULL_Node); }
        | init_declarator_list ',' init_declarator
            { $$ = MAKENODE(init_declarator_list,2,$1,$3,NULL_Node); }
        ;


init_declarator
        : declarator
            { $$ = MAKENODE(init_declarator,1,$1,NULL_Node,NULL_Node); }
        | declarator '=' initializer
            { $$ = MAKENODE(init_declarator,2,$1,$3,NULL_Node); }
        ;

storage_class_specifier
        : TYPEDEF
            { enter_typedef(); 
              $$ = MAKENODE(storage_class_specifier,1,MAKELEAF(TYPEDEF,NULL_LV),NULL_Node,NULL_Node); }
        | EXTERN
            { $$ = MAKENODE(storage_class_specifier,2,MAKELEAF(EXTERN,NULL_LV),NULL_Node,NULL_Node); }
        | STATIC
            { $$ = MAKENODE(storage_class_specifier,3,MAKELEAF(STATIC,NULL_LV),NULL_Node,NULL_Node); }
        | AUTO
            { $$ = MAKENODE(storage_class_specifier,4,MAKELEAF(AUTO,NULL_LV),NULL_Node,NULL_Node); }
        | REGISTER
            { $$ = MAKENODE(storage_class_specifier,5,MAKELEAF(REGISTER,NULL_LV),NULL_Node,NULL_Node); }
        ;

type_specifier
        : VOID
            { $$ = MAKENODE(type_specifier,1,MAKELEAF(VOID,NULL_LV),NULL_Node,NULL_Node); }
        | CHAR
            { $$ = MAKENODE(type_specifier,2,MAKELEAF(CHAR,NULL_LV),NULL_Node,NULL_Node); }
        | SHORT
            { $$ = MAKENODE(type_specifier,3,MAKELEAF(SHORT,NULL_LV),NULL_Node,NULL_Node); }
        | INT
            { $$ = MAKENODE(type_specifier,4,MAKELEAF(INT,NULL_LV),NULL_Node,NULL_Node); }
        | LONG
            { $$ = MAKENODE(type_specifier,5,MAKELEAF(LONG,NULL_LV),NULL_Node,NULL_Node); }
        | FLOAT
            { $$ = MAKENODE(type_specifier,6,MAKELEAF(FLOAT,NULL_LV),NULL_Node,NULL_Node); }
        | DOUBLE
            { $$ = MAKENODE(type_specifier,7,MAKELEAF(DOUBLE,NULL_LV),NULL_Node,NULL_Node); }
        | SIGNED
            { $$ = MAKENODE(type_specifier,8,MAKELEAF(SIGNED,NULL_LV),NULL_Node,NULL_Node); }
        | UNSIGNED
            { $$ = MAKENODE(type_specifier,9,MAKELEAF(UNSIGNED,NULL_LV),NULL_Node,NULL_Node); }
        | struct_or_union_specifier
            { leave_struct_or_union(); 
              $$ = MAKENODE(type_specifier,10,$1,NULL_Node,NULL_Node); }
        | enum_specifier
            { $$ = MAKENODE(type_specifier,11,$1,NULL_Node,NULL_Node); }
        | TYPE_NAME
            { $$ = MAKENODE(type_specifier,12,MAKELEAF(TYPE_NAME,$1.tindex),NULL_Node,NULL_Node); }
        ;

struct_or_union_specifier
        : struct_or_union IDENTIFIER '{' struct_declaration_list '}' 
            { $$ = MAKENODE(struct_or_union_specifier,1,$1,MAKELEAF(IDENTIFIER,$2.index),$4); }
        | struct_or_union '{' struct_declaration_list '}'
            { $$ = MAKENODE(struct_or_union_specifier,2,$1,$3,NULL_Node); }
        | struct_or_union IDENTIFIER
            { $$ = MAKENODE(struct_or_union_specifier,3,$1,MAKELEAF(IDENTIFIER,$2.index),NULL_Node); }
        ;

struct_or_union
        : STRUCT
            { enter_struct_or_union(); 
              $$ = MAKENODE(struct_or_union,1,MAKELEAF(STRUCT,NULL_LV),NULL_Node,NULL_Node); }
        | UNION
            { enter_struct_or_union(); 
              $$ = MAKENODE(struct_or_union,2,MAKELEAF(UNION,NULL_LV),NULL_Node,NULL_Node); }
        ;

struct_declaration_list
        : struct_declaration
            { $$ = MAKENODE(struct_declaration_list,1,$1,NULL_Node,NULL_Node); }
        | struct_declaration_list struct_declaration
            { $$ = MAKENODE(struct_declaration_list,2,$1,$2,NULL_Node); }
        ;

struct_declaration
        : specifier_qualifier_list struct_declarator_list ';'
            { $$ = MAKENODE(struct_declaration,1,$1,$2,NULL_Node); }
        ;

specifier_qualifier_list
        : type_specifier specifier_qualifier_list
            { $$ = MAKENODE(specifier_qualifier_list,1,$1,$2,NULL_Node); }
        | type_specifier
            { $$ = MAKENODE(specifier_qualifier_list,2,$1,NULL_Node,NULL_Node); }
        | type_qualifier specifier_qualifier_list
            { $$ = MAKENODE(specifier_qualifier_list,3,$1,$2,NULL_Node); }
        | type_qualifier
            { $$ = MAKENODE(specifier_qualifier_list,4,$1,NULL_Node,NULL_Node); }
        ;

struct_declarator_list
        : struct_declarator
            { $$ = MAKENODE(struct_declarator_list,1,$1,NULL_Node,NULL_Node); }
        | struct_declarator_list ',' struct_declarator
            { $$ = MAKENODE(struct_declarator_list,2,$1,$3,NULL_Node); }
        ;

struct_declarator
        : declarator
            { $$ = MAKENODE(struct_declarator,1,$1,NULL_Node,NULL_Node); }
        | ':' constant_expression
            { $$ = MAKENODE(struct_declarator,2,$2,NULL_Node,NULL_Node); }
        | declarator ':' constant_expression
            { $$ = MAKENODE(struct_declarator,3,$1,$3,NULL_Node); }
        ;

enum_specifier
        : ENUM '{' enumerator_list '}'
            { $$ = MAKENODE(enum_specifier,1,MAKELEAF(ENUM,NULL_LV),$3,NULL_Node); }
        | ENUM IDENTIFIER '{' enumerator_list '}'
            { $$ = MAKENODE(enum_specifier,2,MAKELEAF(ENUM,NULL_LV),MAKELEAF(IDENTIFIER,$2.index),$4); }
        | ENUM IDENTIFIER
            { $$ = MAKENODE(enum_specifier,3,MAKELEAF(ENUM,NULL_LV),MAKELEAF(IDENTIFIER,$2.index),NULL_Node); }
        ;

enumerator_list
        : enumerator
            { $$ = MAKENODE(enumerator_list,1,$1,NULL_Node,NULL_Node); }
        | enumerator_list ',' enumerator
            { $$ = MAKENODE(enumerator_list,2,$1,$3,NULL_Node); }
        ;

enumerator
        : IDENTIFIER
            { $$ = MAKENODE(enumerator,1,MAKELEAF(IDENTIFIER,$1.index),NULL_Node,NULL_Node); }
        | IDENTIFIER '=' constant_expression
            { $$ = MAKENODE(enumerator,2,MAKELEAF(IDENTIFIER,$1.index),$3,NULL_Node); }
        ;

type_qualifier
        : CONST
            { $$ = MAKENODE(type_qualifier,1,MAKELEAF(CONST,NULL_LV),NULL_Node,NULL_Node); }
        | VOLATILE
            { $$ = MAKENODE(type_qualifier,2,MAKELEAF(VOLATILE,NULL_LV),NULL_Node,NULL_Node); }
        ;

declarator
        : pointer direct_declarator
            { $$ = MAKENODE(declarator,1,$1,$2,NULL_Node); }
        | direct_declarator
            { $$ = MAKENODE(declarator,2,$1,NULL_Node,NULL_Node); }
        ;

direct_declarator
        : IDENTIFIER
            { /* FOUND TYPEDEF name? */ 
              if ((typedef_level > 0) && (struct_or_union_level == 0)) {
                  typedef_symbol_table_add(yytext); leave_typedef(); }
              $$ = MAKENODE(direct_declarator,1,MAKELEAF(IDENTIFIER,$1.index),NULL_Node,NULL_Node); 
            }
        | '(' declarator ')'
            { $$ = MAKENODE(direct_declarator,2,$2,NULL_Node,NULL_Node); }
        | direct_declarator '[' constant_expression ']'
            { $$ = MAKENODE(direct_declarator,3,$1,$3,NULL_Node); }
        | direct_declarator '[' ']'
            { $$ = MAKENODE(direct_declarator,4,$1,NULL_Node,NULL_Node); }
        | direct_declarator '(' parameter_type_list ')'
            { $$ = MAKENODE(direct_declarator,5,$1,$3,NULL_Node); }
        | direct_declarator '(' identifier_list ')'
            { $$ = MAKENODE(direct_declarator,6,$1,$3,NULL_Node); }
        | direct_declarator '(' ')'
            { $$ = MAKENODE(direct_declarator,7,$1,NULL_Node,NULL_Node); }
        ;

pointer
        : '*'
            { $$ = MAKENODE(pointer,1,NULL_Node,NULL_Node,NULL_Node); }
        | '*' type_qualifier_list
            { $$ = MAKENODE(pointer,2,$2,NULL_Node,NULL_Node); }
        | '*' pointer
            { $$ = MAKENODE(pointer,3,$2,NULL_Node,NULL_Node); }
        | '*' type_qualifier_list pointer
            { $$ = MAKENODE(pointer,4,$2,$3,NULL_Node); }
        ;

type_qualifier_list
        : type_qualifier
            { $$ = MAKENODE(type_qualifier_list,1,$1,NULL_Node,NULL_Node); }
        | type_qualifier_list type_qualifier
            { $$ = MAKENODE(type_qualifier_list,2,$1,$2,NULL_Node); }
        ;


parameter_type_list
        : parameter_list
            { $$ = MAKENODE(parameter_type_list,1,$1,NULL_Node,NULL_Node); }
        | parameter_list ',' ELIPSIS
            { $$ = MAKENODE(parameter_type_list,2,$1,NULL_Node,NULL_Node); }
        ;

parameter_list
        : parameter_declaration
            { $$ = MAKENODE(parameter_list,1,$1,NULL_Node,NULL_Node); }
        | parameter_list ',' parameter_declaration
            { $$ = MAKENODE(parameter_list,2,$1,$3,NULL_Node); }

parameter_declaration
        : declaration_specifiers declarator
            { $$ = MAKENODE(parameter_declaration,1,$1,$2,NULL_Node); }
        | declaration_specifiers abstract_declarator
            { $$ = MAKENODE(parameter_declaration,2,$1,$2,NULL_Node); }
        | declaration_specifiers
            { $$ = MAKENODE(parameter_declaration,3,$1,NULL_Node,NULL_Node); }
        ;

identifier_list
        : IDENTIFIER
            { $$ = MAKENODE(identifier_list,1,MAKELEAF(IDENTIFIER,$1.index),NULL_Node,NULL_Node); }
        | identifier_list ',' IDENTIFIER
            { $$ = MAKENODE(identifier_list,2,$1,MAKELEAF(IDENTIFIER,$3.index),NULL_Node); }
        ;

type_name
        : specifier_qualifier_list
            { $$ = MAKENODE(type_name,1,$1,NULL_Node,NULL_Node); }
        | specifier_qualifier_list abstract_declarator
            { $$ = MAKENODE(type_name,2,$1,$2,NULL_Node); }
        ;

abstract_declarator
        : pointer
            { $$ = MAKENODE(abstract_declarator,1,$1,NULL_Node,NULL_Node); }
        | direct_abstract_declarator
            { $$ = MAKENODE(abstract_declarator,2,$1,NULL_Node,NULL_Node); }
        | pointer direct_abstract_declarator
            { $$ = MAKENODE(abstract_declarator,3,$1,$2,NULL_Node); }
        ;

direct_abstract_declarator
        : '(' abstract_declarator ')'
            { $$ = MAKENODE(direct_abstract_declarator,1,$2,NULL_Node,NULL_Node); }
        | '[' ']'
            { $$ = MAKENODE(direct_abstract_declarator,2,NULL_Node,NULL_Node,NULL_Node); }
        | '[' constant_expression ']'
            { $$ = MAKENODE(direct_abstract_declarator,3,$2,NULL_Node,NULL_Node); }
        | direct_abstract_declarator '[' ']'
            { $$ = MAKENODE(direct_abstract_declarator,4,$1,NULL_Node,NULL_Node); }
        | direct_abstract_declarator '[' constant_expression ']'
            { $$ = MAKENODE(direct_abstract_declarator,5,$1,$3,NULL_Node); }
        | '(' ')'
            { $$ = MAKENODE(direct_abstract_declarator,6,NULL_Node,NULL_Node,NULL_Node); }
        | '(' parameter_type_list ')'
            { $$ = MAKENODE(direct_abstract_declarator,7,$2,NULL_Node,NULL_Node); }
        | direct_abstract_declarator '(' ')'
            { $$ = MAKENODE(direct_abstract_declarator,8,$1,NULL_Node,NULL_Node); }
        | direct_abstract_declarator '(' parameter_type_list ')'
            { $$ = MAKENODE(direct_abstract_declarator,9,$1,$3,NULL_Node); }
        ;

initializer
        : assignment_expression
            { $$ = NULLNODE(initializer,1,$1,NULL_Node,NULL_Node); }
        | '{' initializer_list '}'
            { $$ = NULLNODE(initializer,2,$2,NULL_Node,NULL_Node); }
        | '{' initializer_list ',' '}'
            { $$ = NULLNODE(initializer,3,$2,NULL_Node,NULL_Node); }
        ;

initializer_list
        : initializer
            { $$ = NULLNODE(initializer_list,1,$1,NULL_Node,NULL_Node); }
        | initializer_list ',' initializer
            { $$ = NULLNODE(initializer_list,2,$1,$3,NULL_Node); }
        ;

statement
        : labeled_statement
            { $$ = NULLNODE(statement,1,$1,NULL_Node,NULL_Node); }
        | compound_statement
            { $$ = NULLNODE(statement,2,$1,NULL_Node,NULL_Node); }
        | expression_statement
            { $$ = NULLNODE(statement,3,$1,NULL_Node,NULL_Node); }
        | selection_statement
            { $$ = NULLNODE(statement,4,$1,NULL_Node,NULL_Node); }
        | iteration_statement
            { $$ = NULLNODE(statement,5,$1,NULL_Node,NULL_Node); }
        | jump_statement
            { $$ = NULLNODE(statement,6,$1,NULL_Node,NULL_Node); }
        ;

labeled_statement
        : IDENTIFIER ':' statement
            { $$ = NULLNODE(labeled_statement,1,NULL_Node,NULL_Node,NULL_Node); }
        | CASE constant_expression ':' statement
            { $$ = NULLNODE(labeled_statement,2,NULL_Node,NULL_Node,NULL_Node); }
        | DEFAULT ':' statement
            { $$ = NULLNODE(labeled_statement,3,NULL_Node,NULL_Node,NULL_Node); }
        ;

compound_statement
        : '{' '}'
            { $$ = NULLNODE(compound_statement,1,NULL_Node,NULL_Node,NULL_Node); }
        | '{' statement_list '}'
            { $$ = NULLNODE(compound_statement,2,NULL_Node,NULL_Node,NULL_Node); }
        | '{' declaration_list '}'
            { $$ = NULLNODE(compound_statement,3,NULL_Node,NULL_Node,NULL_Node); }
        | '{' declaration_list statement_list '}'
            { $$ = NULLNODE(compound_statement,4,NULL_Node,NULL_Node,NULL_Node); }
        ;

declaration_list
        : declaration
            { $$ = NULLNODE(declaration_list,1,NULL_Node,NULL_Node,NULL_Node); }
        | declaration_list declaration
            { $$ = NULLNODE(declaration_list,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

statement_list
        : statement
            { $$ = NULLNODE(statement_list,1,NULL_Node,NULL_Node,NULL_Node); }
        | statement_list statement
            { $$ = NULLNODE(statement_list,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

expression_statement
        : ';'
            { $$ = NULLNODE(expression_statement,1,NULL_Node,NULL_Node,NULL_Node); }
        | expression ';'
            { $$ = NULLNODE(expression_statement,2,NULL_Node,NULL_Node,NULL_Node); }
        ;

selection_statement
        : IF '(' expression ')' statement
            { $$ = NULLNODE(selection_statement,1,NULL_Node,NULL_Node,NULL_Node); }
        | IF '(' expression ')' statement ELSE statement
            { $$ = NULLNODE(selection_statement,2,NULL_Node,NULL_Node,NULL_Node); }
        | SWITCH '(' expression ')' statement
            { $$ = NULLNODE(selection_statement,3,NULL_Node,NULL_Node,NULL_Node); }
        ;

iteration_statement
        : WHILE '(' expression ')' statement
            { $$ = NULLNODE(iteration_statement,1,NULL_Node,NULL_Node,NULL_Node); }
        | DO statement WHILE '(' expression ')' ';'
            { $$ = NULLNODE(iteration_statement,2,NULL_Node,NULL_Node,NULL_Node); }
        | FOR '(' expression_statement expression_statement ')' statement
            { $$ = NULLNODE(iteration_statement,3,NULL_Node,NULL_Node,NULL_Node); }
        | FOR '(' expression_statement expression_statement expression ')' statement
            { $$ = NULLNODE(iteration_statement,4,NULL_Node,NULL_Node,NULL_Node); }
        ;

jump_statement
        : GOTO IDENTIFIER ';'
            { $$ = NULLNODE(jump_statement,1,NULL_Node,NULL_Node,NULL_Node); }
        | CONTINUE ';'
            { $$ = NULLNODE(jump_statement,2,NULL_Node,NULL_Node,NULL_Node); }
        | BREAK ';'
            { $$ = NULLNODE(jump_statement,3,NULL_Node,NULL_Node,NULL_Node); }
        | RETURN ';'
            { $$ = NULLNODE(jump_statement,4,NULL_Node,NULL_Node,NULL_Node); }
        | RETURN expression ';'
            { $$ = NULLNODE(jump_statement,5,NULL_Node,NULL_Node,NULL_Node); }
        ;

translation_unit
        : external_declaration
            { $$ = MAKENODE(translation_unit,1,$1,NULL_Node,NULL_Node); }
        | translation_unit external_declaration
            { $$ = MAKENODE(translation_unit,2,$1,$2,NULL_Node); }
        ;

external_declaration
        : function_definition
            { $$ = MAKENODE(external_declaration,1,$1,NULL_Node,NULL_Node); }
        | declaration
            { $$ = MAKENODE(external_declaration,2,$1,NULL_Node,NULL_Node); }
        ;

function_definition
        : declaration_specifiers declarator declaration_list compound_statement
            { $$ = MAKENODE(function_definition,1,NULL_Node,NULL_Node,NULL_Node); }
        | declaration_specifiers declarator compound_statement
            { $$ = MAKENODE(function_definition,2,NULL_Node,NULL_Node,NULL_Node); }
        | declarator declaration_list compound_statement
            { $$ = MAKENODE(function_definition,3,NULL_Node,NULL_Node,NULL_Node); }
        | declarator compound_statement
            { $$ = MAKENODE(function_definition,4,NULL_Node,NULL_Node,NULL_Node); }
        ;

top_level
        : translation_unit
        { parse_tree =  $1; }
        ;


%%


extern char yytext[];
extern int sourceline;
extern int column;

const char *node_names[63] = {
  "abstract_declarator", "additive_expression", "and_expression",
  "argument_expression_list", "assignment_expression", "assignment_operator",
  "cast_expression", "compound_statement", "conditional_expression",
  "constant_expression", "declaration", "declaration_list",
  "declaration_specifiers", "declarator", "direct_abstract_declarator",
  "direct_declarator", "enum_specifier", "enumerator",
  "enumerator_list", "equality_expression", "exclusive_or_expression",
  "expression", "expression_statement", "external_declaration",
  "function_definition", "identifier_list", "inclusive_or_expression",
  "init_declarator", "init_declarator_list", "initializer",
  "initializer_list", "iteration_statement", "jump_statement",
  "labeled_statement", "logical_and_expression", "logical_or_expression",
  "multiplicative_expression", "parameter_declaration", "parameter_list",
  "parameter_type_list", "pointer", "postfix_expression",
  "primary_expression", "relational_expression", "selection_statement",
  "shift_expression", "specifier_qualifier_list", "statement",
  "statement_list", "storage_class_specifier", "struct_declaration",
  "struct_declaration_list", "struct_declarator", "struct_declarator_list",
  "struct_or_union", "struct_or_union_specifier", "translation_unit",
  "type_name", "type_qualifier", "type_qualifier_list",
  "type_specifier", "unary_expression", "unary_operator"
};

int node_numbers[63] = {
  abstract_declarator, additive_expression, and_expression,
       argument_expression_list, assignment_expression, assignment_operator,
       cast_expression, compound_statement, conditional_expression,
       constant_expression, declaration, declaration_list,
       declaration_specifiers, declarator, direct_abstract_declarator,
       direct_declarator, enum_specifier, enumerator,
       enumerator_list, equality_expression, exclusive_or_expression,
       expression, expression_statement, external_declaration,
       function_definition, identifier_list, inclusive_or_expression,
       init_declarator, init_declarator_list, initializer,
       initializer_list, iteration_statement, jump_statement,
       labeled_statement, logical_and_expression, logical_or_expression,
       multiplicative_expression, parameter_declaration, parameter_list,
       parameter_type_list, pointer, postfix_expression,
       primary_expression, relational_expression, selection_statement,
       shift_expression, specifier_qualifier_list, statement,
       statement_list, storage_class_specifier, struct_declaration,
       struct_declaration_list, struct_declarator, struct_declarator_list,
       struct_or_union, struct_or_union_specifier, translation_unit,
       type_name, type_qualifier, type_qualifier_list,
       type_specifier, unary_expression, unary_operator};

  const char *leaf_names[59] = {
       "IDENTIFIER", "CONSTANT", "STRING_LITERAL", "SIZEOF",
       "PTR_OP", "INC_OP", "DEC_OP", "LEFT_OP", "RIGHT_OP", "LE_OP", "GE_OP", "EQ_OP", "NE_OP",
       "AND_OP", "OR_OP", "MUL_ASSIGN", "DIV_ASSIGN", "MOD_ASSIGN", "ADD_ASSIGN",
       "SUB_ASSIGN", "LEFT_ASSIGN", "RIGHT_ASSIGN", "AND_ASSIGN",
       "XOR_ASSIGN", "OR_ASSIGN", "TYPE_NAME",
       "TYPEDEF", "EXTERN", "STATIC", "AUTO", "REGISTER",
       "CHAR", "SHORT", "INT", "LONG", "SIGNED", "UNSIGNED", "FLOAT", "DOUBLE", "CONST", "VOLATILE", "VOID",
       "STRUCT", "UNION", "ENUM", "ELIPSIS", "RANGE",
       "CASE", "DEFAULT", "IF", "ELSE", "SWITCH", "WHILE", "DO", "FOR", "GOTO", "CONTINUE", "BREAK", "RETURN" };

  int leaf_numbers[59] = {
       IDENTIFIER, CONSTANT, STRING_LITERAL, SIZEOF,
       PTR_OP, INC_OP, DEC_OP, LEFT_OP, RIGHT_OP, LE_OP, GE_OP, EQ_OP, NE_OP,
       AND_OP, OR_OP, MUL_ASSIGN, DIV_ASSIGN, MOD_ASSIGN, ADD_ASSIGN,
       SUB_ASSIGN, LEFT_ASSIGN, RIGHT_ASSIGN, AND_ASSIGN,
       XOR_ASSIGN, OR_ASSIGN, TYPE_NAME,
       TYPEDEF, EXTERN, STATIC, AUTO, REGISTER,
       CHAR, SHORT, INT, LONG, SIGNED, UNSIGNED, FLOAT, DOUBLE, CONST, VOLATILE, VOID,
       STRUCT, UNION, ENUM, ELIPSIS, RANGE,
       CASE, DEFAULT, IF, ELSE, SWITCH, WHILE, DO, FOR, GOTO, CONTINUE, BREAK, RETURN };


/*  ======================
 *  ANCHOR  stage routines
 *  ======================
 */


/*    VARIABLES    */

int A_no_external_defs = 0;
int A_no_typedefs      = 0;
int A_no_prototypes    = 0;
int A_no_variables     = 0;
int A_no_arrays        = 0;

int A_pointer_level;

int T_Warnings      = 0;
int T_Interfaces, T_Percent;


BOOLEAN  pointer_flag = FALSE;

char  *original_input_file_name;
char  *original_input_base_name;
char  *input_file_name;
char  *C_interface_name;
char  *OCC_interface_name;

FILE  *C_interface_file;
FILE  *OCC_interface_file;

BOOLEAN  DEBUG_TABLES=FALSE;
BOOLEAN  DEBUG_PARSE=FALSE;
BOOLEAN  DEBUG_TRACE=FALSE;
BOOLEAN  DEBUG_WATCH=FALSE;
BOOLEAN  ECHO_SOURCE=FALSE;
int      DEBUG_TRACE_LEVEL=0;


#ifdef ANSI_FUNC

char *
MAKESTR (const char *s1, const char *s2)
#else

char *MAKESTR(s1, s2)
  const char *s1;
  const char *s2;
#endif
{
    char *s0;

    s0 = (char*) malloc( strlen(s1) + strlen(s2) + 1);
    (*s0) = '\0';

    strcpy(s0, s1);
    strcat(s0, s2);

    return(s0);
}


#ifdef ANSI_FUNC

void 
DOT_TO_UNDERSCORE (char *str)
#else

void DOT_TO_UNDERSCORE (str)
  char *str;
#endif
{
  char *temp_ptr;
  
  ASSERT((str != NULL), "DOT_TO_UNDERSCORE: null pointer.");

   temp_ptr   = str;
   while ((*temp_ptr) != '\0')
       { if (*temp_ptr == '.') (*temp_ptr) = '_'; 
         temp_ptr++;
       }
}


#ifdef ANSI_FUNC

int 
main (int argc, char *argv[])
#else

int
main(argc, argv)
  int argc;
  char *argv[];
#endif
{
  int i;
  char *output_base_name;
  BOOLEAN no_cpp=FALSE;
  char *c_compiler_command=(char*)"cc";
  char *cpp_command=(char*)CPP_PATH;
  char *cppflags=NULL;
  
  program_name = basename (argv[0]);

  fprintf(stderr, "%s: KROC Occam-C Interface Generation Tool for %s\n",
	  program_name, kroc_version_message);
  fprintf(stderr, "%s: Author: Carl Lewis, Occam for All group\n\n", program_name);

  /* ...Command Line */

  original_input_file_name = NULL;

  for (i=1; i<argc; i++)
  {
     if (argv[i][0] == '-')
     {
        switch (argv[i][1])
	{ 
          case 'c':
	    c_compiler_command=argv[++i];
	    break;
	    
          case 'D':
          case 'I':
	    if (cppflags) {
	      int len = strlen(cppflags) + 1 + strlen(argv[i]);
	      char *newcppflags = (char*)malloc(len + 1);
	      sprintf(newcppflags,"%s %s", cppflags, argv[i]);
	      free(cppflags);
	      cppflags = newcppflags;
	    } else {
	      cppflags = (char*)malloc(strlen(argv[i] + 1));
	      strcpy(cppflags, argv[i]);
	    }
	    break;
	    
 	  case 'P':
            no_cpp = TRUE;
            break;

          case 'd':
	    cpp_command=argv[++i];
	    break;
	    
 	  case 'p':
            DEBUG_PARSE = TRUE;
            break;

 	  case 't':
            DEBUG_TABLES = TRUE;
            break;

 	  case 'e':
            DEBUG_TRACE = TRUE;
            if (argv[i][2] == '1') DEBUG_TRACE_LEVEL=1;
            if (argv[i][2] == '2') DEBUG_TRACE_LEVEL=2;
            if (argv[i][2] == '3') DEBUG_TRACE_LEVEL=3;
            break;

 	  case 's':
            ECHO_SOURCE = TRUE;
            break;

 	  case 'w':
            DEBUG_WATCH = TRUE;
            break;

 	  default:
            fprintf(stderr, "%s: Unrecognised flag '%s'\n",
		    program_name, argv[i]);
            break;
        }
     }
     else
     {
        if (freopen(argv[i], "r", stdin) == NULL) { perror(argv[i]); exit(1); }
        else original_input_file_name = argv[i];
     }
  }

  if (original_input_file_name == NULL)
  {
     fprintf(stderr, "Usage: %s [options] <C header file>\n\n", program_name);
     fprintf(stderr, "Options:\n");
     fprintf(stderr, "     -c cc       Set compiler to use (default %s).\n",
	     c_compiler_command);
     fprintf(stderr, "     -d cpp      Set cpp to use (default %s).\n",
	     cpp_command);
     fprintf(stderr, "     -P          Do not run cpp on source.\n");
     fprintf(stderr, "     -Ddefs      Pass definitions to cpp.\n");
     fprintf(stderr, "     -Iinclude   Pass include directory to cpp.\n");
     fprintf(stderr, "\nDebug options.\n");
     fprintf(stderr, "     -e<0|1|2|3> Show routine entries.\n");
     fprintf(stderr, "     -p          Show parse tree.\n");
     fprintf(stderr, "     -s          Show input source.\n");
     fprintf(stderr, "     -t          Show symbol tables.\n");
     fprintf(stderr, "     -w          Show watch points.\n");
     exit(0);
  }
  
  original_input_base_name = (char*)malloc(strlen(basename(original_input_file_name))+1);
  strcpy(original_input_base_name, basename(original_input_file_name));

  output_base_name = (char*)malloc(strlen(original_input_base_name)+1);
  strcpy(output_base_name, original_input_base_name);
  DOT_TO_UNDERSCORE (output_base_name);
  
  C_interface_name      = MAKESTR(output_base_name, "_if.c" );
  OCC_interface_name    = MAKESTR(output_base_name, "_if.oif");

  C_interface_file      = fopen(C_interface_name, "w");
  if (!C_interface_file) {
    fprintf(stderr, "%s: Could not create file %s - ", program_name,
	    C_interface_name);
    perror(NULL);
    exit(1);
  }
  OCC_interface_file    = fopen(OCC_interface_name, "w");
  if (!OCC_interface_file) {
    fprintf(stderr, "%s: Could not create file %s - ", program_name,
	    OCC_interface_name);
    perror(NULL);
    exit(1);
  }

  /* CPP: Pre process header file to produce 'cooked C' */
  if(!no_cpp) {
    input_file_name=(char*)malloc(L_tmpnam+3);
    strcat(tmpnam (input_file_name), ".h");
    PREPROCESS(original_input_file_name, input_file_name, cpp_command, cppflags);
  } else {
    input_file_name=original_input_file_name;
  }


  /* FE: Parse input file producing a parse_tree. */  
  fprintf(stderr, "%s: Parsing C header file %s ...\n",
	  program_name, input_file_name);
  yyin=fopen(input_file_name, "r");
  if (!yyin) {
    fprintf(stderr, "%s: Could not open file %s - ", program_name,
	    input_file_name);
    perror(NULL);
    exit(1);
  }
  (void) yyparse();


  /* Anchor stage: complete the symbol tables */
  printf("%s: Anchor stage ...\n", program_name);
  SCAN_input(parse_tree);
  if(no_typedefs)
    SCAN_typedef_sizes(c_compiler_command, cpp_command, cppflags);

  if (DEBUG_TABLES)
  {
    typedef_symbol_table_print();
    print_prototype_table();
    printf("\n\n");
  }

  /* BE: Generate the Output files */
  printf("%s: Type checking ...\n", program_name);
  TYPE_CHECK();

  /* Delete temporary file */  
  if (input_file_name != original_input_file_name)
    remove(input_file_name);


  printf("%s: Generating C interface ...\n", program_name);
  TRANSLATE_C();

  printf("%s: Generating occam interface ...\n", program_name);
  TRANSLATE_OCC();
  
  /* Tidy up files */ 
  fclose(C_interface_file);
  fclose(OCC_interface_file);

  printf("\n%s: Generation finished.\n", program_name);

  T_Interfaces = (A_no_prototypes - T_Warnings);
  if (T_Interfaces != 0) T_Percent = (T_Interfaces*100) / A_no_prototypes;
  else T_Percent = 100;

  printf("%s: SCAN extern_definitions : %d\n", program_name, A_no_external_defs);
  printf("%s: SCAN typedefs           : %d\n", program_name, A_no_typedefs);
  printf("%s: SCAN variables          : %d\n", program_name, A_no_variables);
  printf("%s: SCAN arrays             : %d\n", program_name, A_no_arrays);
  printf("%s: SCAN prototypes         : %d\n", program_name, A_no_prototypes);

  printf("%s: TRANSLATE Warnings      : %d\n", program_name, T_Warnings);
  printf("%s: TRANSLATE Interfaces    : %d/%d (%d%%)\n", program_name, T_Interfaces, A_no_prototypes, T_Percent);
  

  printf("%s: Wrote output files:\n", program_name);
  printf("  occam interface header file  : %s\n", OCC_interface_name);
  printf("  C interface header file      : %s\n", C_interface_name);
  
  return 0;
}



/* PREPROCESS routine
 * ----------
 *
 * Used to remove all the '#defines' and other cpp macros from the header
 * file.
 */

#ifdef ANSI_FUNC

void PREPROCESS (const char *input_file_name, const char *output_file_name, const char *cpp_command, const char *cppflags)
#else

void
PREPROCESS (input_file_name, output_file_name, cppflags)
const char *input_file_name;
const char *output_file_name;
const char *cpp_command;
const char *cppflags;
#endif
{
  int len; 
  char *cmd; 
  int status;

  len = strlen(cpp_command) + 4 + (L_tmpnam+2) + 3 + L_tmpnam;
  if (cppflags)
    len += strlen(cppflags) + 2;
  cmd = (char*) malloc(len+1);
  if (cmd == NULL) fatal("PREPROCESS: Out of heap space");
  if (cppflags)
    sprintf(cmd, "%s -P %s %s > %s", cpp_command, cppflags,
	    input_file_name, output_file_name);
  else
    sprintf(cmd, "%s -P %s > %s", cpp_command,
	    input_file_name, output_file_name);
  printf("%s: Running command to remove CPP lines:\n  '%s'\n",
	  program_name, cmd);
  status = system(cmd);
  if (status) {
    fprintf(stderr, "%s: Failed to run CPP: '%s'\n", program_name, cmd);
    exit(1);
  }  
  free(cmd);
}


/*  ====================
 *  FE: PARSER  routines
 *  ====================
 */


/* ENTER_TYPEDEF & LEAVE_TYPEDEF
 * -----------------------------
 *   
 *   Used by FE to keep track of typedef nesting level.
 *   
 */
#ifdef ANSI_FUNC

void 
enter_typedef (void)
#else

void enter_typedef ()
#endif
{
  typedef_level++;
}

#ifdef ANSI_FUNC

void 
leave_typedef (void)
#else

void leave_typedef ()
#endif
{
  if (typedef_level > 0) typedef_level--;
}


/* ENTER_STRUCT_OR_UNION  LEAVE_STRUCT_OR_UNION
 * --------------------------------------------
 *   
 *   Used by FE to keep track of struct/union nesting level.
 *   
 */
#ifdef ANSI_FUNC

void 
enter_struct_or_union (void)
#else

void enter_struct_or_union ()
#endif
{
  struct_or_union_level++;
}

#ifdef ANSI_FUNC

void 
leave_struct_or_union (void)
#else

void leave_struct_or_union ()
#endif
{
  if (struct_or_union_level > 0) struct_or_union_level--;
}


/* YYERROR
 * -------
 *   
 *   Called from FE when an error is detected in the input file.
 *   
 */
#ifdef ANSI_FUNC

void 
yyerror (char *s)
#else

void
yyerror(s)
char *s;
#endif
{
        fflush(stdout);
        printf("\n%*s\n%*s\n", column, "^", column, s);
	fprintf(stderr, "%s: Error found in %s, line %d\n", program_name,
		input_file_name, sourceline);
        exit(1);
}


/* FATAL
 * ----
 *   
 *   Called from routines when an error occurs.
 *   
 */
#ifdef ANSI_FUNC

void 
fatal (const char *s)
#else

void fatal(s)
  const char *s;
#endif
{
  fflush(stdout);
  printf("\n%s\n", s);
  exit(1);
}



/* MAKENODE
 * -------
 *   
 *   
 */
#ifdef ANSI_FUNC

struct NODE *
MAKENODE (node_types node_type, int rule_case, struct NODE *ptr1, struct NODE *ptr2, struct NODE *ptr3)
#else

struct NODE *MAKENODE (node_type, rule_case, ptr1, ptr2, ptr3)
  node_types node_type;
  int rule_case;
  struct NODE *ptr1, *ptr2, *ptr3;
#endif
{
  struct NODE *temp;

  if (DEBUG_PARSE) printf("\n---> MAKENODE: %s.%d", lookup_node_name(node_type), rule_case); 

  temp = (struct NODE *) malloc(sizeof(struct NODE));
  if (temp == NULL) fatal("MAKENODE: Out of heap space");
  
  temp->leaf  = FALSE;
  temp->ntype = node_type;
  temp->ncase = rule_case;
  temp->ptr1  = ptr1;
  temp->ptr2  = ptr2;
  temp->ptr3  = ptr3;

  if (DEBUG_PARSE) printf(" <---\n");

  return (temp);
}


/* NULLNODE
 * --------
 *   
 */
#ifdef ANSI_FUNC

struct NODE *
NULLNODE (node_types node_type, int rule_case, struct NODE *ptr1, struct NODE *ptr2, struct NODE *ptr3)
#else

struct NODE *
NULLNODE (node_type, rule_case, ptr1, ptr2, ptr3)
node_types node_type;
int rule_case;
struct NODE *ptr1;
struct NODE *ptr2;
struct NODE *ptr3;
#endif
{

  if (DEBUG_PARSE) printf("\n---> NULLNODE: %s.%d\n", lookup_node_name(node_type), rule_case); 

  return ((struct NODE *) NULL);
}


/* MAKELEAF
 * --------
 * 
 */
#ifdef ANSI_FUNC

struct NODE *
MAKELEAF (leaf_types leaf_type, leaf_value lv)
#else

struct NODE *
MAKELEAF (leaf_type, lv)
  leaf_types leaf_type;
  leaf_value lv;
#endif
{
  struct NODE *temp;

  if (DEBUG_PARSE)
  {
    printf("\n---> MAKELEAF: %s", lookup_leaf_name(leaf_type)); 
    if ((leaf_type == IDENTIFIER) && (lv != NULL_LV)) printf(" (%s)",identifier_names[lv]);
    if ((leaf_type == TYPE_NAME)  && (lv != NULL_LV)) printf(" (%s)",typedef_names[lv]);
  }

  temp = (struct NODE *) malloc(sizeof(struct NODE));
  if (temp == NULL) fatal("MAKELEAF: Out of heap space");
  
  temp->leaf    = TRUE;
  temp->ltype   = leaf_type;
  temp->lvalue  = lv;

  ASSERT ((  !( ((leaf_type == IDENTIFIER) || (leaf_type == TYPE_NAME)) && (lv == NULL_LV)) ), "MAKE_LEAF: null type_name/identifier.")


  if (DEBUG_PARSE)  printf(" <---\n");

  return (temp);
}



/* LOOKUP_NODE_NAME
 * ----------------
 *   
 *   Given a node_type enum element, returns its string representation.
 *   
 */
#ifdef ANSI_FUNC

char *
lookup_node_name (int node_no)
#else

char *
lookup_node_name (node_no)
  int node_no;
#endif
{
  char *ret_val;
  int i;

  ret_val = NULL;
  for (i=0;i<63;i++) if (node_numbers[i] == node_no) ret_val = (char*)node_names[i];

  return (ret_val);
}


/* LOOKUP_LEAF_NAME
 * ----------------
 *   
 *   Given a leaf_type enum element, returns its string representation.
 *   
 */
#ifdef ANSI_FUNC

char *
lookup_leaf_name (int leaf_no)
#else

char *
lookup_leaf_name (leaf_no)
  int leaf_no;
#endif
{
  char *ret_val;
  int i;

  ret_val = NULL;
  for (i=0;i<59;i++) if (leaf_numbers[i] == leaf_no) ret_val = (char*)leaf_names[i];

  return (ret_val);
}




/*  ================================
 *  TYPEDEF  table handling routines
 *  ================================
 */


/* TYPEDEF_SYMBOL_TABLE_FIND
 * -------------------------
 */
#ifdef ANSI_FUNC

BOOLEAN 
typedef_symbol_table_find (char *name)
#else

BOOLEAN 
typedef_symbol_table_find (name)
  char *name;
#endif
{
  BOOLEAN found = FALSE;
  int i = 1;

  while ((i <= no_typedefs) && (! found)) {
      found = (strcmp(name, typedef_names[i]) == 0);
      i++;
  }
  return (found);  
}


/* TYPEDEF_SYMBOL_TABLE_INDEX
 * --------------------------
 */
#ifdef ANSI_FUNC

int 
typedef_symbol_table_index (char *name)
#else

int
typedef_symbol_table_index (name)
  char *name;
#endif
{
  BOOLEAN found = FALSE;
  int i = 1;

  while ((i <= no_typedefs) && (! found)) {
      found = (strcmp(name, typedef_names[i]) == 0);
      i++;
  }
  if (found) return(i-1); else return(0);
}


/* TYPEDEF_SYMBOL_TABLE_ADD 
 * ------------------------
 */
#ifdef ANSI_FUNC

void 
typedef_symbol_table_add (char *name)
#else

void
typedef_symbol_table_add (name)
  char *name;
#endif
{
  char *temp;

  if (no_typedefs > MAX_TYPEDEFS) fatal("Out of typedef symbol table space");

  temp = (char *) malloc(strlen(name) +1);
  if (temp == NULL) fatal("Out of heap space");

  strcpy(temp, name);

  no_typedefs++;
  typedef_names[no_typedefs] = temp;


  if (DEBUG_PARSE) printf("ADDING (typedef): %s ", temp);
}


/* TYPEDEF_SYMBOL_TABLE_ADD_TYPEINFO 
 * ---------------------------------
 */
#ifdef ANSI_FUNC

void 
typedef_symbol_table_add_typeinfo (struct NODE *tree, int index)
#else

void 
typedef_symbol_table_add_typeinfo (tree, index)
  struct NODE *tree;
  int index;
#endif
{
  ASSERT (tree  != NULL, "typedef_symbol_table_add_typeinfo: Given null tree.");
  ASSERT (index != 0, "typedef_symbol_table_add_typeinfo: Given zero index.");
  typedef_type_info[index] = tree;
}


/* TYPEDEF_SYMBOL_TABLE_ADD_TYPE_POINTER 
 * -------------------------------------
 */
#ifdef ANSI_FUNC

void 
typedef_symbol_table_add_type_pointer (BOOLEAN flag, int index)
#else

void 
typedef_symbol_table_add_type_pointer (flag, index)
BOOLEAN flag;
int index;
#endif
{
  typedef_type_pointer[index] = flag;
}


#ifdef ANSI_FUNC

void 
typedef_symbol_table_add_pointer_level (int level, int index)
#else

void 
typedef_symbol_table_add_pointer_level (level, index)
int level;
int index;
#endif
{
  typedef_pointer_level[index] = level;
}


/* TYPEDEF_SYMBOL_TABLE_PRINT 
 * --------------------------
 */
#ifdef ANSI_FUNC

void 
typedef_symbol_table_print (void)
#else

void typedef_symbol_table_print ()
#endif
{
  int i;

  printf("\n\nTYPEDEF SYMBOL TABLE (%d)\n\n", no_typedefs);
  for (i=1; i<=no_typedefs; i++) {
    printf("[%s] %s  (size = %d)  pointer_level:%d \n", TOP_LEVEL_TYPE(typedef_type_info[i]), typedef_names[i], typedef_type_sizes[i], typedef_pointer_level[i]);
  }
  printf("\n");
}



/* TYPEDEF_SYMBOL_TABLE_PTR
 * ------------------------
 */
#ifdef ANSI_FUNC

char *
typedef_symbol_table_ptr (int index)
#else

char *
typedef_symbol_table_ptr (index)
  int index;
#endif
{
  return typedef_names[index];
}


/* LOOKUP_TYPE_NAME
 * ----------------
 *   
 *   Given a pointer to a NODE of type (declaration_specifiers).
 *   Search for the corresponding typename, returning a pointer
 *   to the name if found, otherwise return NULL.
 */
#ifdef ANSI_FUNC

char *
LOOKUP_TYPE_NAME (struct NODE *tree)
#else

char *
LOOKUP_TYPE_NAME (tree)
  struct NODE *tree;
#endif
{
  int index=1;

  ASSERT (tree != NULL, "LOOKUP_TYPE_NAME: given null tree.");
  ASSERT((NODE_TYPE(tree)) == declaration_specifiers, "LOOKUP_TYPE_NAME: Incorrect node type.")

  while ((index <= no_typedefs) && (typedef_type_info[index] != tree) ) index++;
 
  if (typedef_type_info[index] == tree) return(typedef_names[index]);

  WARNING("LOOKUP_TYPE_NAME: Did not locate type index for given tree.")
  return(NULL);

}


/* LOOKUP_TYPE_INDEX
 * -----------------
 *   
 *   Given a pointer to a NODE of type (declaration_specifiers).
 *   Search for the corresponding type, returning the index
 *   to the typename if found, otherwise return 0.
 */
#ifdef ANSI_FUNC

int 
LOOKUP_TYPE_INDEX (struct NODE *tree)
#else

int 
LOOKUP_TYPE_INDEX (tree)
  struct NODE *tree;
#endif
{
  int index=1;

  ASSERT (tree != NULL, "LOOKUP_TYPE_INDEX: given null tree.");
  ASSERT((NODE_TYPE(tree)) == declaration_specifiers, "LOOKUP_TYPE_INDEX: Incorrect node type.")

  while ((index <= no_typedefs) && (typedef_type_info[index] != tree) ) index++;

  if (typedef_type_info[index] == tree) return(index);

  WARNING("LOOKUP_TYPE_INDEX: Did not locate type index for given tree.")
  return(0);

}

/* EXTRACT_TYPE_INDEX
 * -----------------
 *   
 *   Given a pointer to a NODE,
 *   Search for the enclosed type name, and return its index.
 *   Otherwise returning 0, if not found.
 */
#ifdef ANSI_FUNC

int 
EXTRACT_TYPE_INDEX (struct NODE *tree)
#else

int 
EXTRACT_TYPE_INDEX (tree)
  struct NODE *tree;
#endif
{
  struct NODE *ptr;

  ASSERT (tree != NULL, "EXTRACT_TYPE_INDEX: given null tree.");
  ASSERT((NODE_TYPE(tree)) == declaration_specifiers, "EXTRACT_TYPE_INDEX: Incorrect node type.")

  ptr = SEARCH_FOR_LEAF_TYPE(TYPE_NAME, tree);

  if (ptr==NULL)
  {
     WARNING("EXTRACT_TYPE_INDEX: Did not locate type index for given tree.")
     return(0);
  }

  return LEAF_VALUE(ptr);
}




/*  ===================================
 *  IDENTIFIER  table handling routines
 *  ===================================
 */


/* IDENTIFIER_SYMBOL_TABLE_ADD
 * ---------------------------
 */
#ifdef ANSI_FUNC

int 
identifier_symbol_table_add (char *name)
#else

int 
identifier_symbol_table_add (name)
  char *name;
#endif
{
  char *temp;

  if (no_identifiers > MAX_IDENTIFIERS) fatal("Out of identifier symbol table space");

  temp = (char *) malloc(strlen(name) +1);
  if (temp == NULL) fatal("Out of heap space");

  strcpy(temp, name);

  no_identifiers++;
  identifier_names[no_identifiers] = temp;

  if (DEBUG_PARSE) printf("ADDING (identifier): %s ", temp);

  return (no_identifiers);
}


/* IDENTIFIER_SYMBOL_TABLE_PTR
 * ---------------------------
 */
#ifdef ANSI_FUNC

char *identifier_symbol_table_ptr(int index)
#else

char *
identifier_symbol_table_ptr (index)
int index;
#endif
{
  return identifier_names[index];
}




/*  ============================
 *  PROTOTYPE  handling routines
 *  ============================
 */


/* PROTOTYPE_SYMBOL_TABLE_ADD
 * --------------------------
 */
#ifdef ANSI_FUNC

void prototype_symbol_table_add (char *name)
#else

void 
prototype_symbol_table_add (name)
char *name;
#endif
{
  char *temp;

  if (no_prototypes > MAX_PROTOTYPES) fatal("Out of prototype symbol table space");

  temp = (char *) malloc(strlen(name) +1);
  if (temp == NULL) fatal("Out of heap space");

  strcpy(temp, name);

  no_prototypes++;
  prototype_names[no_prototypes] = temp;

  if (DEBUG_PARSE) printf("ADDING (proto): %s ", temp);
}



/* PROTOTYPE_SYMBOL_TABLE_ADD_PARAMS
 * ---------------------------------
 */
#ifdef ANSI_FUNC

void prototype_symbol_table_add_params(int count)
#else

void 
prototype_symbol_table_add_params (count)
int count;
#endif
{
  parameter_count[no_prototypes] = count;
}


/* PROTOTYPE_SYMBOL_TABLE_ADD_TYPEINFO
 * -----------------------------------
 */
#ifdef ANSI_FUNC

void prototype_symbol_table_add_typeinfo(struct NODE *tree)
#else

void 
prototype_symbol_table_add_typeinfo (tree)
struct NODE *tree;
#endif
{
  ASSERT (tree != NULL, "prototype_symbol_table_add_typeinfo: Given null tree.");
  prototype_type_info[no_prototypes] = tree;
}

/* PROTOTYPE_SYMBOL_TABLE_ADD_PARAM_PTR
 * ------------------------------------
 */
#ifdef ANSI_FUNC

void prototype_symbol_table_add_param_ptr(struct NODE *tree)
#else

void 
prototype_symbol_table_add_param_ptr (tree)
struct NODE *tree;
#endif
{
  prototype_parameter_ptr[no_prototypes] = tree;
}


/* PROTOTYPE_SYMBOL_TABLE_ADD_RETURNS_POINTER
 * ------------------------------------------
 */
#ifdef ANSI_FUNC

void prototype_symbol_table_add_returns_pointer (BOOLEAN flag)
#else

void 
prototype_symbol_table_add_returns_pointer (flag)
BOOLEAN flag;
#endif
{
  prototype_returns_pointer[no_prototypes] = flag;
}


#ifdef ANSI_FUNC

void  prototype_symbol_table_add_pointer_level (int level)
#else

void 
prototype_symbol_table_add_pointer_level (level)
int level;
#endif
{
  prototype_return_pointer_level[no_prototypes] = level;
}


/* PRINT_PROTOTYPE_TABLE
 * ---------------------
 */
#ifdef ANSI_FUNC

void 
print_prototype_table (void)
#else

void print_prototype_table ()
#endif
{
  int i;
  char chr;

  printf("\n\nPROTOTYPE SYMBOL TABLE (%d)\n\n", no_prototypes);
  for (i=1; i<=no_prototypes; i++) {
    if (prototype_returns_pointer[i]) chr='*'; else chr=' ';
    printf("[");
    PRINT_declaration_specifiers(prototype_type_info[i]);

    /* Case to hadle default return type (INT) */
    if  (COUNT_NODE_CASE_MATCHES (type_specifier, 0, prototype_type_info[i]) == 0) printf(" INT");

    printf("] %c%s (%d)\t(", chr, prototype_names[i], parameter_count[i]);
    PRINT_PARAM_INFO(prototype_parameter_ptr[i]);
    printf(")\n");
    (void) SHOW_proto_info(i);
  }
  printf("\n");
}





/* Used to pass information between rtns */

BOOLEAN      Typedef_Tree = FALSE;
BOOLEAN      Parsing_function = FALSE;
struct NODE *Current_Type_Tree;
char        *Typedef_Name_Ptr;
int          Typedef_Name_Index;
int          Param_count;
struct NODE *Param_ptr;






/*  ===============
 *  SCAN   routines
 *  ===============
 *
 *  These Routines belong to the Anchor stage.
 *     
 *     They walk the FE parse tree building up
 *     the symbol tables (prototype, typedef)
 *
 */


#ifdef ANSI_FUNC

void  SCAN_input(struct NODE *tree)
#else

void 
SCAN_input (tree)
struct NODE *tree;
#endif
{
  ENTRY2("SCAN_input",tree)
  SCAN_translation_unit(tree);
}


#ifdef ANSI_FUNC

void  SCAN_(struct NODE *tree)
#else

void 
SCAN_ (tree)
struct NODE *tree;
#endif
{
  ENTRY2("SCAN_",tree)
    /* EMPTY */
}


#ifdef ANSI_FUNC

void  SCAN_translation_unit(struct NODE *tree)
#else

void 
SCAN_translation_unit (tree)
struct NODE *tree;
#endif
{

  ASSERT(NODE_TYPE(tree) == translation_unit, "translation_unit")
  ENTRY2("SCAN_translation_unit",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  SCAN_external_declaration(NODE_PTR(tree,1)); 
               break;

      case 2:  SCAN_translation_unit(NODE_PTR(tree,1)); 
               SCAN_external_declaration(NODE_PTR(tree,2)); 
               break;

      default:  ILLEGAL("SCAN_translation_unit: Unknown grammar rule case.")
      }

}


#ifdef ANSI_FUNC

void  SCAN_external_declaration(struct NODE *tree)
#else

void 
SCAN_external_declaration (tree)
struct NODE *tree;
#endif
{

  A_no_external_defs++;

  ASSERT((NODE_TYPE(tree)) == external_declaration, "external_declaration")
  ENTRY2("SCAN_external_declaration",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  /*  IGNORE: (function_definition) tree */
               SCAN_(NODE_PTR(tree,1)); 
               break;

      case 2:  /*  HANDLE: (declaration) tree */
               SCAN_declaration(NODE_PTR(tree,1));
               break;

      default:  ILLEGAL("SCAN_external_declaration: Unknown grammar rule case.")
      }
}


#ifdef ANSI_FUNC

void SCAN_declaration(struct NODE *tree)
#else

void 
SCAN_declaration (tree)
struct NODE *tree;
#endif
{

  ASSERT((NODE_TYPE(tree)) == declaration, "declaration")
  ENTRY2("SCAN_declaration",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  /*  IGNORE: (declaration_specifiers) tree */
               SCAN_(NODE_PTR(tree,1)); 
               break;

      case 2:  /*  HANDLE: (declaration_specifiers init_declarator_list) tree */
               Current_Type_Tree = NODE_PTR(tree,1); 
	       if (LEFTMOST_LEAF_TYPE(NODE_PTR(tree,1)) == TYPEDEF)
               {
                    Typedef_Tree     = TRUE; 
                    Typedef_Name_Ptr = identifier_names[LEAF_VALUE(SEARCH_FOR_LEAF_TYPE(IDENTIFIER, NODE_PTR(tree,2)))];
                    ASSERT(Typedef_Name_Ptr != NULL, "SCAN_declaration: null name pointer.");
                    Typedef_Name_Index = typedef_symbol_table_index(Typedef_Name_Ptr);
                    ASSERT(Typedef_Name_Index != 0, "SCAN_declaration: null name index.");
               }
               SCAN_init_declarator_list(NODE_PTR(tree,2));
               Typedef_Tree = FALSE;
               Typedef_Name_Ptr = NULL;
               Typedef_Name_Index = 0;
               break;

      default:  ILLEGAL("SCAN_declaration: Unknown grammar rule case.")
      }
}


#ifdef ANSI_FUNC

void SCAN_init_declarator_list(struct NODE *tree)
#else

void 
SCAN_init_declarator_list (tree)
struct NODE *tree;
#endif
{

  ASSERT((NODE_TYPE(tree)) == init_declarator_list, "init_declarator_list")
  ENTRY2("SCAN_init_declarator_list",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  /*  HANDLE: (init_declarator) tree */
               SCAN_init_declarator(NODE_PTR(tree,1)); 
               break;

      case 2:  /*  HANDLE: (init_declarator_list init_declarator) tree */
               SCAN_init_declarator_list(NODE_PTR(tree,1));
               SCAN_init_declarator(NODE_PTR(tree,2));
               break;

      default:  ILLEGAL("SCAN_init_declarator_list: Unknown grammar rule case.")
      }
}


#ifdef ANSI_FUNC

void SCAN_init_declarator(struct NODE *tree)
#else

void 
SCAN_init_declarator (tree)
struct NODE *tree;
#endif
{

  ASSERT((NODE_TYPE(tree)) == init_declarator, "init_declarator")
  ENTRY2("SCAN_init_declarator",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  /*  HANDLE: (declarator) tree */
               SCAN_declarator(NODE_PTR(tree,1)); 
               break;

      case 2:  /*  IGNORE: (declarator  initializer) tree */
               SCAN_(NODE_PTR(tree,1));
               SCAN_(NODE_PTR(tree,2));
               break;

      default:  ILLEGAL("SCAN_init_declarator: Unknown grammar rule case.")
      }
}


/* NOTE:  Should not jump into EXTRACT_ directly,
 *        should call SCAN_direct_declarator, SCAN_declarator, SCAN_pointer etc...
 *        so that tree is processed correctly!
 *        
 *        Current method does not handle the following:
 *        
 *          typedef void (*void_pointer) ();
 *        
 *        the wrong pointer level (0) is assigned to "void_pointer",
 *        the correct pointer level is 1.
 */
#ifdef ANSI_FUNC

void SCAN_declarator(struct NODE *tree)
#else

void 
SCAN_declarator (tree)
struct NODE *tree;
#endif
{

  ASSERT((NODE_TYPE(tree)) == declarator, "declarator")
  ENTRY2("SCAN_declarator",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  /*  HANDLE: (pointer direct_declarator) tree */
               pointer_flag = TRUE;
               A_pointer_level = COUNT_NODE_CASE_MATCHES(pointer, 0, NODE_PTR(tree,1));
               SCAN_direct_declarator(NODE_PTR(tree,2)); 
               break;

      case 2:  /*  HANDLE: (direct_declarator) tree */
               pointer_flag = FALSE;
               A_pointer_level = 0;
               SCAN_direct_declarator(NODE_PTR(tree,1));
               break;

      default:  ILLEGAL("SCAN_declarator: Unknown grammar rule case.")
      }
      pointer_flag = FALSE;
 }


#ifdef ANSI_FUNC

void SCAN_direct_declarator(struct NODE *tree)
#else

void 
SCAN_direct_declarator (tree)
struct NODE *tree;
#endif
{

  ASSERT((NODE_TYPE(tree)) == direct_declarator, "direct_declarator")
  ENTRY2("SCAN_direct_declarator",tree)

  switch (NODE_CASE(tree))
      {
      case 1:  /*  HANDLE: (identifier) tree */
               SCAN_identifier(NODE_PTR(tree,1));
               break;

      case 2:  /*  HANDLE: (declarator) tree */
               SCAN_declarator(NODE_PTR(tree,1)); 
               break;

      case 3:  /*  IGNORE: (direct_declarator [n]) tree */
      case 4:  /*  IGNORE: (direct_declarator []) tree */
               A_no_arrays++;
               break;


      case 5:  /*  HANDLE: (direct_declarator parameter_type_list) tree */
               Param_ptr   = NODE_PTR(NODE_PTR(tree, 2),1);
               Param_count = COUNT_LIST_ENTRIES(Param_ptr);
               Parsing_function = TRUE;
               SCAN_direct_declarator(NODE_PTR(tree,1));
               Parsing_function = FALSE;
               break;

      case 6:  /*  HANDLE: (direct_declarator identifier_list) tree */
               Param_ptr   = NODE_PTR(tree, 2);
               Param_count = COUNT_LIST_ENTRIES(Param_ptr);
               Parsing_function = TRUE;
               SCAN_direct_declarator(NODE_PTR(tree,1));
               Parsing_function = FALSE;
               break;

      case 7:  /*  HANDLE: (direct_declarator () ) tree */
               Param_ptr   = NULL_Node;
               Param_count = 0;
               Parsing_function = TRUE;
               SCAN_direct_declarator(NODE_PTR(tree,1));
               Parsing_function = FALSE;
               break;

      default:  ILLEGAL("SCAN_direct_declarator: Unknown grammar rule case.")
               break;
      }

 }


#ifdef ANSI_FUNC

void SCAN_identifier(struct NODE *tree)
#else

void 
SCAN_identifier (tree)
struct NODE *tree;
#endif
{

  ENTRY("SCAN_identifier")

  /* Found an identifier, determine whether it is:   */
  /*    o  For a typedef name.                       */
  /*    o  For a function prototype name.            */
  /*    o  A variable name.                          */

  switch (Typedef_Tree)
  {
    case TRUE:
    /* TYPEDEF */
	         /* ACTION:  Extract (type, name) */
                  A_no_typedefs++;
                
                 /* Add pointer to Typedef type tree */
                 typedef_symbol_table_add_typeinfo(Current_Type_Tree, Typedef_Name_Index);

                 /* Add pointer information for Typedef type */
                 typedef_symbol_table_add_type_pointer(pointer_flag, Typedef_Name_Index);
 
                 /* Record pointer level for this typedef */
                 typedef_symbol_table_add_pointer_level(A_pointer_level, Typedef_Name_Index);
                 break;

    case FALSE:
       switch (Parsing_function)
       {
         case TRUE:
	     /* FUNCTION PROTOTYPE */

	         /* ACTION:  Extract (type, name, parameter info) */
                 A_no_prototypes++;

                 /* Add prototype name to prototype symbol table */
                 prototype_symbol_table_add(identifier_symbol_table_ptr(LEAF_VALUE(tree)));
                 prototype_symbol_table_add_returns_pointer (pointer_flag);
                 prototype_symbol_table_add_params(Param_count);
                 prototype_symbol_table_add_param_ptr(Param_ptr);

                 /* Add pointer to prototype return type tree */
                 prototype_symbol_table_add_typeinfo(Current_Type_Tree);

                 /* Record return pointer level for this prototype, accouning for pointer level of return type. */
                 prototype_symbol_table_add_pointer_level(A_pointer_level + TYPE_LEVEL(Current_Type_Tree));

                 break;

         case FALSE:
         /* VARIABLE:  IGNORE */
                 A_no_variables++;
                 break;
       }
       break;

    default:
                 ILLEGAL("SCAN_identifier: Unrecognised tree type.");
                 break;
  }
}



#ifdef ANSI_FUNC

void EXTRACT_(struct NODE *tree)
#else

void 
EXTRACT_ (tree)
struct NODE *tree;
#endif
{
  struct NODE *temp_ptr, *name_ptr, *param_ptr;
  int          temp_case, index, param_count;

  ASSERT((NODE_TYPE(tree)) == direct_declarator, "direct_declarator")
  ENTRY("SCAN_extract_")

      /*  Examine tree to determine what is declared. */
      switch (DETERMINE_TYPE(tree))
          {
          case VAR:
	         /* IGNORE: */
                 A_no_variables++;
                 break;

          case ARR:
	         /* IGNORE: */
                 A_no_arrays++;
                 break;

          case PRO:
	         /* ACTION:  Extract (type, name, parameter info) */
                 A_no_prototypes++;

                 /* Get pointer to prototype tree */
                 temp_ptr = SEARCH_FOR_NODE_CASE(direct_declarator, 5, tree);
                 if (temp_ptr == NULL) temp_ptr = SEARCH_FOR_NODE_CASE(direct_declarator, 6, tree);
                 if (temp_ptr == NULL) temp_ptr = SEARCH_FOR_NODE_CASE(direct_declarator, 7, tree);
                 ASSERT (temp_ptr != NULL, "EXTRACT_: Can't retrieve prototype pointer.")

                 /* Get node case */
                 temp_case = NODE_CASE(temp_ptr);
                 ASSERT( ((temp_case > 4) && (temp_case < 8)), "EXTRACT_: Unexpected node case.");


                 /* Retrieve prototype name  */
                 name_ptr = SEARCH_FOR_NODE_CASE(direct_declarator, 1, temp_ptr);
                 ASSERT (name_ptr != NULL, "EXTRACT_: Can't find prototype name.")
                 ASSERT (LEAF_TYPE(NODE_PTR(name_ptr,1)) == IDENTIFIER, "EXTRACT_: Can't retrieve name.")

                 /* Add prototype name to prototype symbol table */
                 index = LEAF_VALUE(NODE_PTR(name_ptr,1));
                 prototype_symbol_table_add(identifier_symbol_table_ptr(index));

                 /* Add pointer to parameter structure to symbol table. */
                 /* Count prototype parameters, add to symbol table. */
                 switch (temp_case) 
                     {
		     case 5:
                        ASSERT((NODE_TYPE(temp_ptr) == direct_declarator), "EXTRACT_: Error in case 5, (temp_ptr) node type.");
                        ASSERT((NODE_CASE(temp_ptr) == 5), "EXTRACT_: Error in case 5, (temp_ptr) node case.");
                        param_ptr   = NODE_PTR(NODE_PTR(temp_ptr, 2), 1);
                        ASSERT(param_ptr != NULL, "EXTRACT_: null pointer to parameter_list.");
                        ASSERT((NODE_TYPE(param_ptr) == parameter_list), "EXTRACT_: Error in case 5, (param_ptr) type");
                        param_count = COUNT_LIST_ENTRIES(param_ptr);
                        break;
		     case 6:
                        param_ptr   = NODE_PTR(temp_ptr, 2);
                        ASSERT(param_ptr != NULL, "EXTRACT_: null pointer to identifier_list.");
                        ASSERT((NODE_TYPE(param_ptr) == identifier_list), "EXTRACT_: Error in case 6");
                        param_count = COUNT_LIST_ENTRIES(param_ptr);
                        break;
		     case 7:
                        param_ptr   = NULL_Node;
                        param_count = 0;
                        break;
                     default:
                        ILLEGAL("EXTRACT_: Illegal prototype case.")
                     }

                 prototype_symbol_table_add_returns_pointer (pointer_flag);
                 prototype_symbol_table_add_params(param_count);
                 prototype_symbol_table_add_param_ptr(param_ptr);

                 /* Add pointer to prototype return type tree */
                 prototype_symbol_table_add_typeinfo(Current_Type_Tree);

                 /* Record return pointer level for this prototype, accouning for pointer level of return type. */
                 prototype_symbol_table_add_pointer_level(A_pointer_level + POINTER_LEVEL(TRUE,Current_Type_Tree));

                break;

          case TYP:
                 ASSERT(Typedef_Tree, "EXTRACT_: Typedef flag not set!");

	         /* ACTION:  Extract (type, name) */
                  A_no_typedefs++;
                
                 /* Add pointer to Typedef type tree */
                 typedef_symbol_table_add_typeinfo(Current_Type_Tree, Typedef_Name_Index);

                 /* Add pointer information for Typedef type */
                 typedef_symbol_table_add_type_pointer(pointer_flag, Typedef_Name_Index);
 
                 /* Record pointer level for this typedef */
                 typedef_symbol_table_add_pointer_level(A_pointer_level, Typedef_Name_Index);

                 break;

          case UNKNOWN:
                 ILLEGAL("EXTRACT_: Unknown tree type.");
                 break;

	  default:
                 ILLEGAL("EXTRACT_: Unrecognised tree type.");
                 break;

          }
}


#ifdef ANSI_FUNC

DECL_TYPE DETERMINE_TYPE(struct NODE *tree)
#else

DECL_TYPE
DETERMINE_TYPE(tree)
struct NODE *tree;
#endif
{

  ENTRY_("DETERMINE_TYPE")
  ASSERT((NODE_TYPE(tree)) == direct_declarator, "direct_declarator")

  /*   Determine declaration type. 
   *     Cases: (TYPEDEF, VARIABLE, PROTOTYPE, ARRAY, UNKNOWN) 
   */

  /* Typedef ? */
  /* if (LEFTMOST_LEAF_TYPE(tree) == TYPEDEF) return (TYP); */
  if (Typedef_Tree) return  (TYP);

  /* Prototype ?  */
  if (SEARCH_FOR_NODE_CASE(direct_declarator, 5, tree) != NULL)  return(PRO);
  if (SEARCH_FOR_NODE_CASE(direct_declarator, 6, tree) != NULL)  return(PRO);
  if (SEARCH_FOR_NODE_CASE(direct_declarator, 7, tree) != NULL)  return(PRO);
 
  /* Otherwise */
  return (VAR);

}




#ifdef ANSI_FUNC

node_types   NODE_TYPE(struct NODE *ptr)
#else

node_types 
NODE_TYPE (ptr)
struct NODE *ptr;
#endif
{
  ENTRY__("NODE_TYPE")
  return (ptr->ntype);
}


#ifdef ANSI_FUNC

int          NODE_CASE(struct NODE *ptr)
#else

int 
NODE_CASE (ptr)
struct NODE *ptr;
#endif
{
  ENTRY__("NODE_CASE")
  return (ptr->ncase);
}


#ifdef ANSI_FUNC

struct NODE *NODE_PTR(struct NODE *ptr, int ptr_no)
#else

struct NODE *
NODE_PTR (ptr, ptr_no)
struct NODE *ptr;
int ptr_no;
#endif
{
  struct NODE *ret_val;

  ENTRY__("NODE_PTR")
  switch (ptr_no)
  {
      case 1:   ret_val = ptr->ptr1; break;
      case 2:   ret_val = ptr->ptr2; break;
      case 3:   ret_val = ptr->ptr3; break;
      default:  ret_val = (struct NODE *)NULL;
  }

  return (ret_val);
}


#ifdef ANSI_FUNC

struct NODE *RIGHTMOST_NON_NULL_PTR(struct NODE *ptr, int index)
#else

struct NODE *
RIGHTMOST_NON_NULL_PTR (ptr, index)
struct NODE *ptr;
int index;
#endif
{
  switch(index) {
  case 3: if (ptr->ptr3 != NULL) return (ptr->ptr3); break;
  case 2: if (ptr->ptr2 != NULL) return (ptr->ptr2); break;
  case 1: if (ptr->ptr1 != NULL) return (ptr->ptr1); break;
  case 0:   ILLEGAL("RIGHTMOST_PTR: All pointers null.");
  default:  ILLEGAL("RIGHTMOST_PTR: Unexpected case");
  }

  return (RIGHTMOST_NON_NULL_PTR(ptr, index-1)); 
}


#ifdef ANSI_FUNC

struct NODE *RIGHTMOST_PTR(struct NODE *ptr)
#else

struct NODE *
RIGHTMOST_PTR (ptr)
struct NODE *ptr;
#endif
{

  ENTRY__("RIGHTMOST_PTR")
  return (RIGHTMOST_NON_NULL_PTR(ptr, 3));
}



/*  Returns the length of the list.
 * 
 *  Assumes generic list format: 
 *    
 *   Grammar_rule_list
 *         : base_case
 *         | Grammar_rule_list  base_case
 */

#ifdef ANSI_FUNC

int  COUNT_LIST_ENTRIES(struct NODE *ptr)
#else

int 
COUNT_LIST_ENTRIES (ptr)
struct NODE *ptr;
#endif
{
   ENTRY___("COUNT_LIST_ENTRIES")
   ASSERT(ptr != NULL, "COUNT_LIST_ENTRIES: Null pointer passed.")

   if (NODE_CASE(ptr) == 1) return (1);
   
   return (1 + COUNT_LIST_ENTRIES(NODE_PTR(ptr,1)));
}




/*  SCAN_TYPEDEF_SIZES:
 *  ------------------
 *   
 *   Completes the symbol table for
 *   type name sizes.
 *   By getting the sizeof() for each type name.
 *  
 */
#ifdef ANSI_FUNC

void  SCAN_typedef_sizes (const char *c_compiler_command,
			  const char *cpp_command, const char *cppflags)
#else

void 
SCAN_typedef_sizes (c_compiler_command, cpp_command, cppflags)
const char *c_compiler_command;
const char *cpp_command;
const char *cppflags;
#endif
{

  FILE *fp;
  int count, status;
  char exe_file_name[L_tmpnam+1];
  char C_file_name[L_tmpnam+3];
  char sizes_file_name[L_tmpnam+1];
  int len;
  char *cmd;
  
  ENTRY_("SCAN_typedef_sizes")
    
  ASSERT(no_typedefs!=0, "SCAN_typedef_sizes: No typedefs defined.")

  /* Make temporary file names */
  (void)tmpnam (exe_file_name);
  sprintf(C_file_name, "%s.c", exe_file_name);
  (void)tmpnam (sizes_file_name);

  /* Create source file which will record the sizeof each typename */
  fp = fopen(C_file_name, "w");

  fprintf(fp,     "#include \"%s\"\n", original_input_base_name);
  fputs(  "#include <stdio.h>\n",fp  );
  fputs(  "int main(argc, argv)\n",fp  );
  fputs(  "  int argc;\n",fp  );
  fputs(  "  char *argv[];\n",fp  );
  fputs(  "{\n",fp  );
  fputs(  "#define INFO(str) { fprintf(fps,\"%d\\n\", sizeof(str)); }\n",fp);
  fputs(  "  FILE *fps;\n",fp  );
  fputs(  "\n",fp);

  /* generate file to capture sizes */
  fprintf(fp, "\tfps = fopen(\"%s\", \"w\");\n\n", sizes_file_name);

  for (count = 1; count <= no_typedefs; count++) 
    fprintf(fp, "\tINFO(%s);\n",typedef_names[count]); 

  fputs(  "\n",fp  );
  fputs(  "\tfclose(fps);\n",fp  );
  fputs(  "\texit(0);\n",fp  );
  fputs(  "}\n",fp  );

  fclose(fp);

  /* Compile and run the generated source file */
  len = strlen(c_compiler_command) + 1 + (L_tmpnam+2) + 4 + L_tmpnam;
  if (cppflags)
    len += strlen(cppflags) + 2;
  cmd = (char*) malloc(len+1);
  if (cmd == NULL) fatal("SCAN_typedef_sizes: Out of heap space");

  if (cppflags)
    sprintf(cmd, "%s %s %s -o %s", c_compiler_command, cppflags, C_file_name, exe_file_name);
  else
    sprintf(cmd, "%s %s -o %s", c_compiler_command, C_file_name, exe_file_name);
  printf("%s: Running command to put typedef sizes into %s:\n  '%s'\n",
	 program_name, sizes_file_name, cmd);
  status = system(cmd);
  if (status) {
    fprintf(stderr, "%s: Failed to compile generated file with '%s'\n", program_name, cmd);
    exit(1);
  }  
  remove(C_file_name);
  free(cmd);

  printf("%s: Running command to print typedef sizes:\n  '%s'\n",
	 program_name, exe_file_name);
  status = system(exe_file_name);
  if (status) {
    fprintf(stderr, "%s: Failed to execute generated file '%s'\n", program_name, exe_file_name);
    exit(1);
  }  
  remove(exe_file_name);

  /* Read back the size information into symbol table */
  fp = fopen(sizes_file_name, "r");
  if (fp) {
    for (count = 1; count <= no_typedefs; count++) 
      { int temp;
      fscanf(fp, "%d", &temp);
      typedef_type_sizes[count] = temp;
      }
  }
  else {
    fprintf(stderr, "%s: Could not open typedef sizes file %s - ", program_name,
	    sizes_file_name);
    perror(NULL);
  }
  
  fclose(fp);
  remove(sizes_file_name);

}





/*  ================
 *  PRINT   routines
 *  ================
 *
 *  These Routines belong to the Anchor stage.
 *     
 *     They walk the FE parse tree printing out
 *     prototype return type, and parameter types.
 *
 *     They are used when printing out the prototype symbol table.
 */


#ifdef ANSI_FUNC

void PRINT_PARAM_INFO(struct NODE *tree)
#else

void 
PRINT_PARAM_INFO (tree)
struct NODE *tree;
#endif
{
  if (tree == NULL) return;

  switch(NODE_TYPE(tree))
      {
      case identifier_list:   PRINT_identifier_list(tree);  break;
      case parameter_list:    PRINT_parameter_list(tree);   break;
      default:  printf("PRINT_PARAM_INFO: Unrecognised grammar type (%s).", lookup_node_name(NODE_CASE(tree)));  break;
      }
}


#ifdef ANSI_FUNC

void PRINT_declaration_specifiers(struct NODE *tree)
#else

void 
PRINT_declaration_specifiers (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_declaration_specifiers: given null tree.");
   ASSERT((NODE_TYPE(tree)) == declaration_specifiers, "PRINT_declaration_specifiers: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
         case 1:   PRINT_storage_class_specifier(NODE_PTR(tree,1));  break;
         case 2:   PRINT_storage_class_specifier(NODE_PTR(tree,1));  printf(" "); PRINT_declaration_specifiers(NODE_PTR(tree,2));  break;
         case 3:   PRINT_type_specifier(NODE_PTR(tree,1));  break;
         case 4:   PRINT_type_specifier(NODE_PTR(tree,1));  printf(" "); PRINT_declaration_specifiers(NODE_PTR(tree,2));  break;
         case 5:   PRINT_type_qualifier(NODE_PTR(tree,1));  break;
         case 6:   PRINT_type_qualifier(NODE_PTR(tree,1));  printf(" "); PRINT_declaration_specifiers(NODE_PTR(tree,2));  break;
         default:  ILLEGAL("PRINT_declaration_specifiers: Unrecognised grammar case.");                 break;
       }
}


#ifdef ANSI_FUNC

void PRINT_storage_class_specifier(struct NODE *tree)
#else

void 
PRINT_storage_class_specifier (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_storage_class_specifier: given null tree.");
   ASSERT((NODE_TYPE(tree)) == storage_class_specifier, "PRINT_storage_class_specifier: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
       case 1: printf("typedef");   break;
       case 2: printf("extern");    break;
       case 3: printf("static");    break;
       case 4: printf("auto");      break;
       case 5: printf("register");  break;
       default:  ILLEGAL("PRINT_declaration_specifiers: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_type_specifier(struct NODE *tree)
#else

void 
PRINT_type_specifier (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_type_specifier: given null tree.");
   ASSERT((NODE_TYPE(tree)) == type_specifier, "PRINT_type_specifier: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
       case 1:  printf("void");  break;
       case 2:  printf("char");  break;
       case 3:  printf("short");  break;
       case 4:  printf("int");  break;
       case 5:  printf("long");  break;
       case 6:  printf("float");  break;
       case 7:  printf("double");  break;
       case 8:  printf("signed");  break;
       case 9:  printf("unsigned");  break;
       case 10: printf("...struct/union");  break;
       case 11: printf("...enum");  break;
       case 12: printf(typedef_symbol_table_ptr(LEAF_VALUE(NODE_PTR(tree, 1))));  break;
       default:  ILLEGAL("PRINT_type_specifiers: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_type_qualifier(struct NODE *tree)
#else

void 
PRINT_type_qualifier (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_type_qualifier: given null tree.");
   ASSERT((NODE_TYPE(tree)) == type_qualifier, "PRINT_type_qualifier: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
       case 1:  printf("const");     break;
       case 2:  printf("volatile");  break;
       default:  ILLEGAL("PRINT_type_qualifier: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_declarator(struct NODE *tree)
#else

void 
PRINT_declarator (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_declarator: given null tree.");
   ASSERT((NODE_TYPE(tree)) == declarator, "PRINT_declarator: Incorrect node type.")

   switch(NODE_CASE(tree))
       {
       case 1:   PRINT_pointer(NODE_PTR(tree,1));  PRINT_direct_declarator(NODE_PTR(tree,2));   break;
       case 2:   PRINT_direct_declarator(NODE_PTR(tree,1)); break;
       default:  ILLEGAL("PRINT_declarator: Unrecognised grammar case.");  break;
       }
}

#ifdef ANSI_FUNC

void PRINT_pointer(struct NODE *tree)
#else

void 
PRINT_pointer (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_pointer: given null tree.");
   ASSERT((NODE_TYPE(tree)) == pointer, "PRINT_pointer: Incorrect node type.")

   switch(NODE_CASE(tree))
       {
       case 1:   printf("*");  break;
       case 2:   printf("*");  PRINT_type_qualifier_list(NODE_PTR(tree,1));  break;
       case 3:   printf("*");  PRINT_pointer(NODE_PTR(tree,1));  break;
       case 4:   printf("*");  PRINT_type_qualifier_list(NODE_PTR(tree,1)); PRINT_pointer(NODE_PTR(tree,2));  break;
       default:  ILLEGAL("PRINT_pointer: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_type_qualifier_list(struct NODE *tree)
#else

void 
PRINT_type_qualifier_list (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_type_qualifier_list: given null tree.");
   ASSERT((NODE_TYPE(tree)) == type_qualifier_list, "PRINT_type_qualifier_list: Incorrect node type.")

   switch(NODE_CASE(tree))
       {
       case 1:   PRINT_type_qualifier(NODE_PTR(tree,1));  break;
       case 2:   PRINT_type_qualifier_list(NODE_PTR(tree,1)); PRINT_type_qualifier(NODE_PTR(tree,2));  break;
       default:  ILLEGAL("PRINT_type_qualifier_list: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_direct_declarator(struct NODE *tree)
#else

void 
PRINT_direct_declarator (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_direct_declarator: given null tree.");
   ASSERT((NODE_TYPE(tree)) == direct_declarator, "PRINT_direct_declarator: Incorrect node type.")

   switch(NODE_CASE(tree))
       {
       case 1:   PRINT_identifier_name(NODE_PTR(tree,1));  break;
       case 2:   printf("("); PRINT_declarator(NODE_PTR(tree,1)); printf("(");  break; 
       case 3:   PRINT_declarator(NODE_PTR(tree,1)); printf("[...CONST_EXPR]");  break; 
       case 4:   PRINT_declarator(NODE_PTR(tree,1)); printf("[]");  break; 
       case 5:   PRINT_declarator(NODE_PTR(tree,1)); printf("(");  
                 PRINT_parameter_type_list(NODE_PTR(tree,2));   printf(")"); break; 
       case 6:   PRINT_declarator(NODE_PTR(tree,1)); printf("("); 
                 PRINT_identifier_list(NODE_PTR(tree,2));   printf(")"); break; 
       case 7:   PRINT_declarator(NODE_PTR(tree,1)); printf("()");  break; 
       default:  ILLEGAL("PRINT_direct_declarator: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_parameter_type_list(struct NODE *tree)
#else

void 
PRINT_parameter_type_list (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_parameter_type_list: given null tree.");
   ASSERT((NODE_TYPE(tree)) == parameter_type_list, "PRINT_parameter_type_list: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
        case 1:   PRINT_parameter_list(NODE_PTR(tree,1));  break;
        case 2:   PRINT_parameter_list(NODE_PTR(tree,1));  printf(",{}");  break;
        default:  ILLEGAL("PRINT_parameter_type_list: Unrecognised grammar case.");  break;
       }
}

#ifdef ANSI_FUNC

void PRINT_parameter_list(struct NODE *tree)
#else

void 
PRINT_parameter_list (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_parameter_list: given null tree.");
   ASSERT((NODE_TYPE(tree)) == parameter_list, "PRINT_parameter_list: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
        case 1:   PRINT_parameter_declaration(NODE_PTR(tree,1));  break;
        case 2:   PRINT_parameter_list(NODE_PTR(tree,1)); printf(", "); PRINT_parameter_declaration(NODE_PTR(tree,2));  break;
        default:  ILLEGAL("PRINT_parameter_list: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_parameter_declaration(struct NODE *tree)
#else

void 
PRINT_parameter_declaration (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_parameter_declaration: given null tree.");
   ASSERT((NODE_TYPE(tree)) == parameter_declaration, "PRINT_parameter_declaration: Incorrect node type.")

   switch(NODE_CASE(tree))
       {
        case 1:   PRINT_declaration_specifiers(NODE_PTR(tree,1));  printf(" "); PRINT_declarator(NODE_PTR(tree,2));  break;
        case 2:   PRINT_declaration_specifiers(NODE_PTR(tree,1));  printf(" "); PRINT_abstract_declarator(NODE_PTR(tree,2));  break;
        case 3:   PRINT_declaration_specifiers(NODE_PTR(tree,1));  break;
        default:  ILLEGAL("PRINT_parameter_decaration: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_identifier_list(struct NODE *tree)
#else

void 
PRINT_identifier_list (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_identifier_list: given null tree.");
   ASSERT((NODE_TYPE(tree)) == identifier_list, "PRINT_identifier_list: Incorrect node type.")

   switch(NODE_CASE(tree)) 
       {
        case 1:   PRINT_identifier_name(NODE_PTR(tree,1));  break;
        case 2:   PRINT_identifier_list(NODE_PTR(tree,1)); printf(", "); PRINT_identifier_name(NODE_PTR(tree,2));  break;
        default:  ILLEGAL("PRINT_identifier_list: Unrecognised grammar case.");  break;
       }
}


#ifdef ANSI_FUNC

void PRINT_identifier_name(struct NODE *tree)
#else

void 
PRINT_identifier_name (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_identifer_name: given null tree.");
   ASSERT ((IS_LEAF(tree)), "PRINT_identifer_name: given non-leaf node.");
   ASSERT((LEAF_TYPE(tree)) == IDENTIFIER, "PRINT_identifier_name: Incorrect leaf type.")

   printf(identifier_names[LEAF_VALUE(tree)]);
}


#ifdef ANSI_FUNC

void PRINT_typedef_name(struct NODE *tree)
#else

void 
PRINT_typedef_name (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_typedef_name: given null tree.");
   ASSERT ((IS_LEAF(tree)), "PRINT_typedef_name: given non-leaf node.");
   ASSERT((LEAF_TYPE(tree)) == TYPEDEF, "PRINT_typedef_name: Incorrect leaf type.")

   printf(typedef_names[LEAF_VALUE(tree)]);
}


#ifdef ANSI_FUNC

const char *TOP_LEVEL_TYPE (struct NODE *tree)
#else

const char *
TOP_LEVEL_TYPE (tree)
struct NODE *tree;
#endif
{
  struct NODE *temp_ptr;

   if (tree == NULL)  return(NULL);

   ASSERT (tree != NULL, "TOP_LEVEL_TYPE: given null tree.");
   ASSERT((NODE_TYPE(tree)) == declaration_specifiers, "TOP_LEVEL_TYPE: Incorrect node type.")

   temp_ptr = SEARCH_FOR_NODE_CASE(type_specifier, 0, tree);

   if (temp_ptr == NULL) return ("INT(default)");
   else 
   switch(NODE_CASE(temp_ptr)) 
       {
         case 1:   return("VOID");           break;
         case 2:   return("CHAR");           break;
         case 3:   return("SHORT");          break;
         case 4:   return("INT");            break;
         case 5:   return("LONG");           break;
         case 6:   return("FLOAT");          break;
         case 7:   return("DOUBLE");         break;
         case 8:   return("SIGNED");         break;
         case 9:   return("UNSIGNED");       break;
         case 10:  return("STRUCT/UNION");   break;
         case 11:  return("ENUM");           break;
         case 12:  return(typedef_symbol_table_ptr(LEAF_VALUE(NODE_PTR(temp_ptr, 1)))); break;
         default:  ILLEGAL("TOP_LEVEL_TYPE: Unrecognised grammar case."); break;
       }
}


#ifdef ANSI_FUNC

void PRINT_abstract_declarator (struct NODE *tree)
#else

void 
PRINT_abstract_declarator (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_abstract_declarator: given null tree.");
   ASSERT((NODE_TYPE(tree)) == abstract_declarator, "PRINT_abstract_declarator: Incorrect node type.")

   switch (NODE_CASE(tree))
       {
       case 1:  printf("*");  break;
       case 2:  PRINT_direct_abstract_declarator(NODE_PTR(tree,1));  break;
       case 3:  printf("*"); PRINT_direct_abstract_declarator(NODE_PTR(tree,2));  break;
       default:  ILLEGAL("PRINT_abstract_declarator: Unrecognised grammar case."); break;
       }
}


#ifdef ANSI_FUNC

void PRINT_direct_abstract_declarator (struct NODE *tree)
#else

void 
PRINT_direct_abstract_declarator (tree)
struct NODE *tree;
#endif
{
   ASSERT (tree != NULL, "PRINT_direct_abstract_declarator: given null tree.");
   ASSERT((NODE_TYPE(tree)) == direct_abstract_declarator, "PRINT_direct_abstract_declarator: Incorrect node type.")

   switch (NODE_CASE(tree))
       {
       case 1:  printf("(");  PRINT_abstract_declarator(NODE_PTR(tree,1));  printf(")"); break;
       case 2:  printf("[]"); break;
       case 3:  printf("[...CONST]"); break;
       case 4:  PRINT_direct_abstract_declarator(NODE_PTR(tree,1)); printf("[]");  break;
       case 5:  PRINT_direct_abstract_declarator(NODE_PTR(tree,1)); printf("[...CONST]");  break;
       case 6:  printf("()");  break;
       case 7:  printf("(...PARAM_TYPE_LIST)"); break;
       case 8:  PRINT_direct_abstract_declarator(NODE_PTR(tree,1)); printf("()");  break;
       case 9:  PRINT_direct_abstract_declarator(NODE_PTR(tree,1)); printf("(...PARAM_TYPE_LIST)");  break;
       default: ILLEGAL("PRINT_abstract_declarator: Unrecognised grammar case."); break;
       }
}



/*  =====================
 *  TRANSLATE_   routines
 *  =====================
 *
 *  These Routines belong to the BE stage.
 *
 *     They generate the Occam and C interface files from the
 *     FE parse tree and symbol tables.
 *
 */



/* Enumeration of C types */
typedef enum 
{ 
  C_int=0, C_short_int, C_long_int, C_long_long_int,
  C_signed_int, C_signed_short_int, C_signed_long_int, C_signed_long_long_int,
  C_unsigned_int, C_unsigned_short_int, C_unsigned_long_int, C_unsigned_long_long_int,

  C_char, C_float, C_double, C_typedef, C_struct, C_enum, C_union, 
  C_typename, C_void, C_UNKNOWN,

  C_unsigned_char, C_signed_char, C_function

} C_TYPES;



/* Warning messages to explain why prototype not translated */
const char *R_reasons[] =
{
  "int", "short int", "long int", "long long int",
  "signed int", "signed short int", "signed long int", "signed long long int",
  "unsigned int", "unsigned short int", "unsigned long int", "unsigned long long int",

  "char", "float", "double", "typedef", "struct", "enum", "union",
  "typename", "void", "UNKNOWN",

  "unsigned char", "signed char", "function"
};


/* Warning messages to explain why prototype not translated */
const char *P_reasons[] =
{
  "int", "short int", "long int", "long long int",
  "signed int", "signed short int", "signed long int", "signed long long int",
  "unsigned int", "unsigned short int", "unsigned long int", "unsigned long long int",

  "char", "float", "double", "typedef", "struct", "enum", "union",
  "typename", "void", "UNKNOWN",

  "unsigned char", "signed char", "function"
};


/* Correspondence patterns between C_TYPES and C parameters */
const char *C_pattern[] = 
{
  "int", "short int", "long int", "long long int",
  "signed int", "signed short int", "signed long int", "signed long long int",
  "unsigned int", "unsigned short int", "unsigned long int", "unsigned long long int",

  "char", "float", "double", "***NOT HANDLED***", "==Special==", "***NOT HANDLED***", "***NOT HANDLED***",
  "***NOT HANDLED***", "void", "***NOT HANDLED***",
  "unsigned char", "***NOT HANDLED***", "***NOT HANDLED***"
};


/* Correspondence patterns between C_TYPES and Occam parameters 
 *
 *   non-pointer parameters should be pre-fixed by "VAL "
 *   CHANGE:  Structures  FROM: [####]INT  TO: INT32  (Assume: Space allocated by 'C')
 *   CHANGE:  Unions      FROM: [####]INT  TO: INT32
 */
const char *OCC_pattern[] = 
{
  "INT",   "INT16", "INT32", "INT64",
  "INT",   "INT16", "INT32", "INT64",
  "INT",   "INT16", "INT32", "INT64",

  "[]BYTE", "REAL32", "REAL64", "***NOT HANDLED***", "INT32", "***NOT HANDLED***", "INT32",
  "***NOT HANDLED***", "INT32", "***NOT HANDLED***",
  "[]BYTE", "***NOT HANDLED***", "***NOT HANDLED***"
};


/* Correspondence patterns between C_TYPES and Occam parameters needed to pass that type.
 *
 */
int OCC_param_size[] =
{
  1, 1, 1, 1,
  1, 1, 1, 1,
  1, 1, 1, 1,

  2, 1, 1, 0, 1, 0, 1,
  0, 1, 0,
  2, 0, 0
};

/*  multi level 'C' pointers (** *** ...) are mapped to INT32 */
const char *OCC_pattern_ptr_ptr = "INT32";


/* Correspondence patterns between C_TYPES and Call arguments 
 *
 *   Note:  ##  will be substituted for the parameter number.
 */
const char *CALL_pattern[] = 
{
  "w[##].i",   "w[##].s[1]", "w[##].i", "L##.l",
  "w[##].i",   "w[##].s[1]", "w[##].i", "L##.l",
  "w[##].i",   "w[##].s[1]", "w[##].i", "L##.l",

  "w[##].c[3]", "w[##].f", "D##.d", "***NOT HANDLED***", "(*w[##].ip)", "***NOT HANDLED***", "(*w[##].ip)",
  "***NOT HANDLED***", "IGNORED", "***NOT HANDLED***",
  "w[##].c[3]", "***NOT HANDLED***", "***NOT HANDLED***"
};

/* Correspondence patterns between C_TYPES and Call arguments (pointers)
 *
 *   Note:  ##  will be substituted for the parameter number.
 */
const char *CALL_pattern_p[] = 
{
  "w[##].ip", "(short int *)(w[##].i^1)", "w[##].ip", "L##.l",
  "w[##].ip", "(short int *)(w[##].i^1)", "w[##].ip", "L##.l",
  "w[##].ip", "(short int *)(w[##].i^1)", "w[##].ip", "L##.l",

  "(w[##].cp)", "w[##].fp", "&D##.d", "***NOT HANDLED***", "(*w[##].ip)", "***NOT HANDLED***", "(*w[##].ip)",
  "***NOT HANDLED***", "(void *) (w[##].ip)", "***NOT HANDLED***",
  "(w[##].cp)", "***NOT HANDLED***", "***NOT HANDLED***"
};


/* Correspondence patterns between C_TYPES and RETURN arguments 
 *
 *   Note:  ##  will be substituted for the parameter number.
 */
const char *RETURN_pattern[] = 
{
  "(*w[##].ip)", "(*w[##].ip)", "(*w[##].ip)", "L##.l",
  "(*w[##].ip)", "(*w[##].ip)", "(*w[##].ip)", "L##.l",
  "(*w[##].ip)", "(*w[##].ip)", "(*w[##].ip)", "L##.l",

  "w[##].c[3]", "w[##].f", "D##.d", "***NOT HANDLED***", "(*w[##].ip)", "***NOT HANDLED***", "(*w[##].ip)",
  "***NOT HANDLED***", "(void *) (*w[##].ip)", "***NOT HANDLED***",
  "w[##].c[3]", "***NOT HANDLED***", "***NOT HANDLED***"
};


/* Correspondence patterns between C_TYPES and RETURN arguments (pointers)
 *
 *   Note:  ##  will be substituted for the parameter number.
 */
const char *RETURN_pattern_p[] = 
{
  "(*w[##].ip)", "(*w[##].ip)", "(*w[##].ip)", "L##.l",
  "(*w[##].ip)", "(*w[##].ip)", "(*w[##].ip)", "L##.l",
  "(*w[##].ip)", "(*w[##].ip)", "(*w[##].ip)", "L##.l",

  "(*w[##].ip)", "(*w[##].fp)", "D##.d", "***NOT HANDLED***", "(*w[##].ip)", "***NOT HANDLED***", "(*w[##].ip)",
  "***NOT HANDLED***", "(*w[##].ip)", "***NOT HANDLED***",
  "(*w[##].ip)", "***NOT HANDLED***", "***NOT HANDLED***"
};


const char *CAST_RETURN_pattern[] = 
{
  "(int)", "(short int)", "(int)", "(long long int)",
  "(int)", "(short int)", "(int)", "(long long int)",
  "(int)", "(short int)", "(int)", "(long long int)",

  "(char)", "(float)", "(double)", "***NOT HANDLED***", "(int *)", "***NOT HANDLED***", "(int *)",
  "***NOT HANDLED***", "(void)", "***NOT HANDLED***",
  "(char)", "***NOT HANDLED***", "***NOT HANDLED***"
};


const char *CAST_RETURN_pattern_p[] = 
{
  "(int *)", "(int *)", "(int *)", "(long long int *)",
  "(int *)", "(int *)", "(int *)", "(long long int *)",
  "(int *)", "(int *)", "(int *)", "(long long int *)",

  "(char *)", "(float *)", "(double *)", "***NOT HANDLED***", "(int *)", "***NOT HANDLED***", "(int *)",
  "***NOT HANDLED***", "(void *)", "***NOT HANDLED***",
  "(char *)", "***NOT HANDLED***", "***NOT HANDLED***"
};






/* Correspondence patterns between C_TYPES and Endian manipulations 
 *
 *   Note:  TRUE indicates endian manipulation is required.
 *          
 */
BOOLEAN Endian_Manipulation[] =
{
  FALSE, FALSE, FALSE, TRUE, 
  FALSE, FALSE, FALSE, TRUE, 
  FALSE, FALSE, FALSE, TRUE, 

  FALSE, FALSE, TRUE, FALSE, TRUE, FALSE, FALSE,
  FALSE, FALSE, FALSE,
  FALSE, FALSE, FALSE
};


/* Correspondence patterns between C_TYPES and types currently handled.
 *
 *   Note:  TRUE  indicates type is handled.
 *          FALSE indicates type not handled.
 */
BOOLEAN Type_handled[] =
{
  TRUE, TRUE, TRUE, TRUE, 
  TRUE, TRUE, TRUE, TRUE, 
  TRUE, TRUE, TRUE, TRUE, 

  TRUE, TRUE, TRUE, FALSE, TRUE, FALSE, TRUE,
  FALSE, TRUE, FALSE,
  TRUE, FALSE, FALSE
};


const char *TYPE_declarations[] = 
{
    "/*  Occam/C interface mechanism V3.0 (22/5/95)  */\n",
    "/*  Simple data types and arrays of words.      */\n",
    "/*  Arrays of BYTEs INT16s, REAL64s and INT64s  */\n",
    "/*  have to be converted separately before use. */\n",
    "\n\n",
    "                               /* for reversing endianism */\n",
    "typedef union\n",
    "    {    double d;\n",
    "         long long int l;\n",
    "         int i[2];\n",
    "    } pair;\n",
    "\n",
    "typedef union                  /* anything that can go into a single word  */\n",
    "    {\n",
    "      int             i;\n",
    "      float           f;\n",
    "      int            *ip;\n",
    "      int            **ipp;\n",
    "      float          *fp;\n",
    "      double         *dp;\n",
    "      pair           *pp;\n",
    "      short int       s[2];\n",
    "      short int      *sp;\n",
    "      char            c[4];\n",
    "      char           *cp;\n",
    "      long long int  *lp;\n",
    "    }  word;\n",
    "\n",
    "\n",
    "void fpconst(void);            /* Routine which restores kroc floating point constants. */\n",
    "\n",
    "\n",
};



#define  MAX_PARAMETERS  30

char        *proto_name;
char        *proto_return_type_name;
int          proto_no_params;
int          actual_proto_no_params;
int          proto_arrays;
struct NODE *proto_return_type;
struct NODE *P_type[MAX_PARAMETERS];  
struct NODE *proto_param_ptr;
char        *P_name[MAX_PARAMETERS];
char        *P_type_name[MAX_PARAMETERS];
int          P_param_size[MAX_PARAMETERS];
int          P_pointer_level[MAX_PARAMETERS];
int          proto_return_pointer_level;

int          T_pointer_level;

BOOLEAN      P_is_ptr[MAX_PARAMETERS];
BOOLEAN      proto_returns_pointer;
BOOLEAN      is_ptr;
BOOLEAN      proto_void_return_value;
BOOLEAN      proto_endian_manipulation;
BOOLEAN      proto_return_typename_is_pointer;
BOOLEAN      proto_uses_floating_pt;


int          C_posn=0;
int          OCC_posn=0;
BOOLEAN      C_wrap=TRUE;
BOOLEAN      OCC_wrap=TRUE;


const char *P_default_names[MAX_PARAMETERS] = {"P0",   "P1",  "P2",  "P3",  "P4",  "P5",  "P6",  "P7",  "P8",  "P9",
                                                "P10", "P11",  "P12",  "P13",  "P14",  "P15",  "P16",  "P17",  "P18",  "P19",
                                                "P20", "P21",  "P22",  "P23",  "P24",  "P25",  "P26",  "P27",  "P28",  "P29"};


C_TYPES TYPE_CATEGORY (BOOLEAN unwrap, struct NODE *tree);



/*  TYPE_CHECK
 *  ----------
 *
 *    Performs checks on the function prototypes
 *    to determine if the current interface mechanism
 *    and tool can cope with them.
 *
 *    The array prototypes_check_status_passed[] is initialised,
 *    it indicates which routines can be translated.
 *
 */
#ifdef ANSI_FUNC

void 
TYPE_CHECK (void)
#else

void  TYPE_CHECK ()
#endif
{
  int index;

  ENTRY("TYPE_CHECK")
  /* Type check each prototype */
  for (index = 1; index <= A_no_prototypes; index++)
  {   
      TYPE_CHECK_prototype(index);
/*      PROGRESS(index, A_no_prototypes);*/
  }
}



/*  TYPE_CHECK_prototype
 *  --------------------
 *    
 *    Performs type checking on the prototype to determine 
 *    if the [return type] or [parameter types] are too complex
 *    to be handled by the current interface.
 *    
 *    The current interface only handles integer only interfaces.
 *    
 *    
 *    The following information is available for the current prototype:
 *      
 *      proto_name                              - pointer to name of prototype.
 *      proto_no_params                         - number of parameters.
 *      actual_proto_no_params                  - actual parameters (excluding void parameters).
 *      proto_return_type                       - pointer to parse tree (declaration_specifiers) for return type.
 *      P_type[1]  .. P_type[MAX_PARAMETERS]    - pointer to parse tree (declaration_specifiers) for each parameter.
 *      P_name[1]  .. P_name[MAX_PARAMETERS]    - pointer to name of parameter (defaults to Pn).
 *
 *      P_is_ptr[1] .. P_is_ptr[MAX_PARAMETERS] - flags set if parameters are pointers to there value.
 *      proto_returns_pointer                   - flag set if prototype returns a pointer to its result.
 *      proto_uses_floating_pt                  - flag set if the routine needs to use floating point.
 */

#ifdef ANSI_FUNC

void  TYPE_CHECK_prototype(int index)
#else

void 
TYPE_CHECK_prototype (index)
int index;
#endif
{
  BOOLEAN       rstatus = FALSE, pstatus = FALSE;
  int count, P_no=0;
  C_TYPES category_found;
  BOOLEAN handled;
  char *P_n=NULL;

  ENTRY_("TYPE_CHECK_prototype");
  GET_prototype_info(index);

  /* Check return type 
   *
   *   Currently handled: {void, int}.
   *
   */

   category_found = TYPE_CATEGORY(TRUE, proto_return_type);
   handled = Type_handled[category_found];


   rstatus = (!handled);


  /* Check parameter types 
   *
   *   Currently unhandled: { "struct <uknown typename>", "functions"}.
   *
   */
   
   for (count = 1; count <= proto_no_params; count++)
       {
         category_found = TYPE_CATEGORY(TRUE, P_type[count]);
         handled = Type_handled[category_found];

         pstatus = pstatus || (!handled);
         if (!handled) { P_no = count; P_n = P_type_name[count]; }
       }


  if (pstatus || rstatus)
    {
      fprintf(stderr, "%s: Warning: function %s ", program_name, proto_name);
      
      if (rstatus)
	fprintf(stderr, "return type '%s' too complex.\n",
		proto_return_type_name);
      if (pstatus)
	fprintf(stderr, "parameter %d type  '%s' too complex.\n",
		P_no, P_n);
      }

  prototypes_check_status_passed[index] = (!(pstatus || rstatus));
}



/*  TYPE_CATEGORY
 *  -------------
 *    
 *    Given a pointer to [declaration_specifiers] parse tree,
 *    this routine determines which type category is represented by the
 *    parse tree and returns the appropriate enumeration in C_TYPES.
 *    
 *    returning C_UNKNOWN if the parse tree does not match one of the
 *    recognised types:
 *
 *      C_int,           C_short_int,          C_long_int,          C_long_long_int,
 *      C_signed_int,    C_signed_short_int,   C_signed_long_int,   C_signed_long_long_int,
 *      C_unsigned_int,  C_unsigned_short_int, C_unsigned_long_int, C_unsigned_long_long_int,
 *
 *      C_char,          C_float,              C_double,            C_typedef, 
 *      C_struct,        C_enum,               C_union,
 *      C_typename,      C_void,               C_UNKNOWN,
 *      C_unsigned_char, C_signed_char,        C_function
 */

#ifdef ANSI_FUNC

C_TYPES      TYPE_CATEGORY (BOOLEAN unwrap, struct NODE *tree)
#else

C_TYPES 
TYPE_CATEGORY (unwrap, tree)
BOOLEAN unwrap;
struct NODE *tree;
#endif
{
   int  no_short, no_long, no_signed, no_unsigned;
   int  no_int, no_char, no_float, no_double;
   int  no_void, no_struct_u, no_enum, no_typename;
   int  no_type_specifiers, no_functions;

   ENTRY__("TYPE_CATEGORY")
   ASSERT (tree != NULL, "TYPE_CATEGORY: given null tree.");
   ASSERT((NODE_TYPE(tree)) == declaration_specifiers, "TYPE_CATEGORY: Incorrect node type.")

   no_short    = COUNT_NODE_CASE_MATCHES(type_specifier, 3, tree);
   no_long     = COUNT_NODE_CASE_MATCHES(type_specifier, 5, tree);
   no_signed   = COUNT_NODE_CASE_MATCHES(type_specifier, 8, tree);
   no_unsigned = COUNT_NODE_CASE_MATCHES(type_specifier, 9, tree);
   no_int      = COUNT_NODE_CASE_MATCHES(type_specifier, 4, tree);
   no_char     = COUNT_NODE_CASE_MATCHES(type_specifier, 2, tree);
   no_float    = COUNT_NODE_CASE_MATCHES(type_specifier, 6, tree);
   no_double   = COUNT_NODE_CASE_MATCHES(type_specifier, 7, tree);
   no_void     = COUNT_NODE_CASE_MATCHES(type_specifier, 1, tree);
   no_struct_u = COUNT_NODE_CASE_MATCHES(type_specifier, 10, tree);
   no_enum     = COUNT_NODE_CASE_MATCHES(type_specifier, 11, tree);
   no_typename = COUNT_NODE_CASE_MATCHES(type_specifier, 12, tree);

   no_type_specifiers = COUNT_NODE_CASE_MATCHES(type_specifier, 0, tree);

   no_functions = COUNT_NODE_CASE_MATCHES(direct_declarator, 5, tree) +
                  COUNT_NODE_CASE_MATCHES(direct_declarator, 6, tree) +
                  COUNT_NODE_CASE_MATCHES(direct_declarator, 7, tree);


   /* Default INT if missing for SHORTs & LONGs */
   if ( (no_int == 0) && ((no_short > 0) || (no_long > 0)) )  no_int++;


   /* Default INT when no (type_specifier) */
   if (no_type_specifiers == 0) no_int++;

   /* check for INT */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_int);

   /* check for SHORT INT */
   if ( (no_short==1) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_short_int);

   /* check for LONG INT */
   if ( (no_short==0) && (no_long==1) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_long_int);

   /* check for  LONG LONG INT*/
   if ( (no_short==0) && (no_long==2) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_long_long_int);


   /* check for SIGNED INT */
   if ( (no_short==0) && (no_long==0) && (no_signed==1) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_signed_int);

   /* check for SIGNED SHORT INT */
   if ( (no_short==1) && (no_long==0) && (no_signed==1) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_signed_short_int);

   /* check for SIGNED LONG INT */
   if ( (no_short==0) && (no_long==1) && (no_signed==1) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_signed_long_int);

   /* check for  SIGNED LONG LONG INT*/
   if ( (no_short==0) && (no_long==2) && (no_signed==1) && (no_unsigned==0) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_signed_long_long_int);



   /* check for UNSIGNED */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==1) &&
        (no_int==0) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_unsigned_int);

   /* check for UNSIGNED INT */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==1) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_unsigned_int);

   /* check for UNSIGNED SHORT INT */
   if ( (no_short==1) && (no_long==0) && (no_signed==0) && (no_unsigned==1) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_unsigned_short_int);

   /* check for UNSIGNED LONG INT */
   if ( (no_short==0) && (no_long==1) && (no_signed==0) && (no_unsigned==1) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_unsigned_long_int);

   /* check for  UNSIGNED LONG LONG INT*/
   if ( (no_short==0) && (no_long==2) && (no_signed==0) && (no_unsigned==1) &&
        (no_int==1) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_unsigned_long_long_int);





   /* check for CHAR */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==0) && (no_char==1) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_char);

   /* check for UNSIGNED CHAR */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==1) &&
        (no_int==0) && (no_char==1) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_char);

   /* check for SIGNED CHAR */
   if ( (no_short==0) && (no_long==0) && (no_signed==1) && (no_unsigned==0) &&
        (no_int==0) && (no_char==1) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_char);

   /* check for FLOAT */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==0) && (no_char==0) && (no_float==1) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_float);

   /* check for DOUBLE */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==0) && (no_char==0) && (no_float==0) && (no_double==1) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_double);

   /* check for TYPEDEF - ignored */

   /* check for STRUCT/UNION */
 
   /* check special case:  "struct <unknown typename>" */
   /*if  (no_struct_u == 1) && (unknown typename) */

   if  (no_struct_u > 0) 
       { if (SEARCH_FOR_NODE_CASE(struct_or_union, 1, tree) != NULL) return(C_struct);
	     else return(C_union); }

   /* check for ENUM */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==0) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==0) && (no_struct_u==0) && (no_enum==1) && (no_typename==0)
      ) return(C_enum);

   /* check for TYPENAME and unwrap. */
   if (no_typename==1)
   {
      if (unwrap)  return(TYPE_CATEGORY(TRUE, typedef_type_info[LEAF_VALUE(NODE_PTR(SEARCH_FOR_NODE_CASE(type_specifier, 12, tree),1))]));
      else return(C_typename);
   }

   /* check for VOID */
   if ( (no_short==0) && (no_long==0) && (no_signed==0) && (no_unsigned==0) &&
        (no_int==0) && (no_char==0) && (no_float==0) && (no_double==0) &&
        (no_void==1) && (no_struct_u==0) && (no_enum==0) && (no_typename==0)
      ) return(C_void);

   /* check for FUNCTION */
   if (no_functions > 0) return (C_function);

   /* Unrecognised type */
   return(C_UNKNOWN);
}


/*  ENDIAN_MANIPULATION
 *  -------------------
 *    
 *    Returns TRUE if type parse tree requires endian manipulation.
 *    FALSE otherwise.
 *
 */
#ifdef ANSI_FUNC

BOOLEAN      ENDIAN_MANIPULATION(struct NODE *tree)
#else

BOOLEAN 
ENDIAN_MANIPULATION (tree)
struct NODE *tree;
#endif
{
  return(Endian_Manipulation[TYPE_CATEGORY(TRUE, tree)]);
}



/*  IS_STRUCTURE_TYPEDEF
 *  --------------------
 *    
 *    Returns TRUE if typedef is a structure.
 *    FALSE otherwise.
 *
 */
#ifdef ANSI_FUNC

BOOLEAN IS_STRUCTURE_TYPEDEF(int index)
#else

BOOLEAN 
IS_STRUCTURE_TYPEDEF (index)
int index;
#endif
{
    return(TYPE_CATEGORY(TRUE, typedef_type_info[index]) == C_struct);
}



/*  TRANSLATE_C
 *  -----------
 *    
 *    For those routines which can be translated, this routine
 *    generates the C interface file.
 *
 */

#ifdef ANSI_FUNC

void 
TRANSLATE_C (void)
#else

void  TRANSLATE_C ()
#endif
{
  int index;

  TRANSLATE_C_TYPE_declarations();

  TRANSLATE_C_include();

  for (index = 1; index <= A_no_prototypes; index++)
  { 
    if (prototypes_check_status_passed[index])
      { GET_prototype_info(index);
        TRANSLATE_C_prototype();
/*        PROGRESS(index, A_no_prototypes);*/
      }
  }

}


/*  TRANSLATE_OCC
 *  -------------
 *    
 *    For those routines which can be translated, this routine
 *    generates the Occam interface file.
 *    
 *
 */

#ifdef ANSI_FUNC

void 
TRANSLATE_OCC (void)
#else

void TRANSLATE_OCC ()
#endif
{
  int index;


  if (A_no_typedefs)
    TRANSLATE_OCC_typedef_sizes();

  for (index = 1; index <= A_no_prototypes; index++)
  { if (prototypes_check_status_passed[index])
      {
        GET_prototype_info(index);
        TRANSLATE_OCC_prototype();
/*        PROGRESS(index, A_no_prototypes);*/
      }
  }

}


/*  GET_prototype_info
 *  ------------------
 *    
 *    Extracts the following information ready for processing:
 *      
 *      proto_name                              - pointer to name of prototype.
 *      proto_no_params                         - number of parameters.
 *      actual_proto_no_params                  - actual parameters (excluding void parameters).
 *      proto_arrays                            - number of array parameters.
 *      proto_return_type                       - pointer to parse tree (declaration_specifiers) for return type.
 *      proto_return_type_name                  - pointer to the return type name.
 *      P_type[1]  .. P_type[MAX_PARAMETERS]    - pointer to parse tree (declaration_specifiers) for each parameter.
 *      P_name[1]  .. P_name[MAX_PARAMETERS]    - pointer to name of parameter (defaults to Pn).
 *      P_type_name[1] .. [MAX_PARAMETERS]      - pointer to name of parameter types (defaults to null).
 *      P_pointer_level[1] .. [MAX_PARAMETERS]  - pointer level for parameters.
 *      P_param_size[1] .. [MAX_PARAMETERS]     - number of actual values needed to pass each formal parameter.
 *
 *      P_is_ptr[1] .. P_is_ptr[MAX_PARAMETERS] - flags set if parameters are pointers to value.
 *      proto_returns_pointer                   - flag set if prototype returns a pointer to its result.
 *      proto_void_return_value                 - flag set if prototype return type is void.
 *      proto_endian_manipulation               - flag set if prototype requires endian manipulation.
 *      proto_return_typename_is_pointer        - flag set if typename return is itself a pointer.
 *      proto_uses_floating_pt                  - flag set if the routine needs to use floating point.
 *      proto_return_pointer_level              - pointer level of return value.
 */
#ifdef ANSI_FUNC

void  GET_prototype_info(int index)
#else

void 
GET_prototype_info (index)
int index;
#endif
{
  int count;

  ENTRY__("GET_prototype_info")
  proto_name                       = prototype_names[index];
  proto_no_params                  = parameter_count[index];
  proto_return_type                = prototype_type_info[index];
  proto_return_type_name           = NULL;
  proto_param_ptr                  = prototype_parameter_ptr[index];
  proto_returns_pointer            = prototype_returns_pointer[index];
  proto_endian_manipulation        = FALSE;
  proto_return_typename_is_pointer = FALSE;
  proto_uses_floating_pt           = FALSE;
  proto_return_pointer_level       = prototype_return_pointer_level[index];
  proto_arrays                     = 0;

  /* Extract the return type name if present. */
  if ( SEARCH_FOR_NODE_CASE(type_specifier, 12, proto_return_type) != NULL) 
  {
    proto_return_type_name = typedef_names[LEAF_VALUE(NODE_PTR(SEARCH_FOR_NODE_CASE(type_specifier, 12, proto_return_type),1))];
    proto_return_typename_is_pointer = typedef_type_pointer[LEAF_VALUE(NODE_PTR(SEARCH_FOR_NODE_CASE(type_specifier, 12, proto_return_type),1))];
  }

  
  /* flag indicating if prototype returns void */
  proto_void_return_value = (SEARCH_FOR_NODE_CASE(type_specifier, 1, proto_return_type) != NULL);
  proto_endian_manipulation =  proto_endian_manipulation || (ENDIAN_MANIPULATION(proto_return_type));

  /* ... GET parameter types & names ... */
  ASSERT((COUNT_NODE_CASE_MATCHES(parameter_declaration, 0, proto_param_ptr) == proto_no_params), "GET_prototype_info: Unexpected number of parameters.");

  /* Flatten and extract parameter details into an array */
  EXTRACT_NODE_CASE_MATCHES (parameter_declaration, 0, proto_param_ptr);

  for (count = 1; count <= Node_Matches_Count; count++)
      {
        P_type[count] = GET_param_type(Node_Matches[count]);
        proto_endian_manipulation =  proto_endian_manipulation || (ENDIAN_MANIPULATION(P_type[count]));


        P_name[count] = GET_param_name(Node_Matches[count]);
        if (P_name[count] == NULL) P_name[count] = (char*)P_default_names[count];

        /* flag indicating if parameter is a pointer to a value */
        P_is_ptr[count] = is_ptr;

        /* Set the parameter pointer level */
        P_pointer_level[count] = TYPE_LEVEL(P_type[count]) + T_pointer_level;

        /* Keep track of the number of actuals occam needs for each formal parameter */     
        P_param_size[count] = OCC_param_size[TYPE_CATEGORY(TRUE, P_type[count])];
        if (P_pointer_level[count] > 1) P_param_size[count] = 1;                    /*  FIX for char**  */
        if (P_param_size[count] > 1) proto_arrays++;

        /* Fill in the typename for this parameter */
        P_type_name[count] =  NULL;

        if ( SEARCH_FOR_NODE_CASE(type_specifier, 12, P_type[count]) != NULL) 
        {
           P_type_name[count] = typedef_names[LEAF_VALUE(NODE_PTR(SEARCH_FOR_NODE_CASE(type_specifier, 12, P_type[count]),1))];
        }


      }

  /* Count the number of actual parameters (excluding void parameters) but allow (void *) pointers. */
  actual_proto_no_params = 0;
  for (count = 1; count <= Node_Matches_Count; count++)
      {
      if  (SEARCH_FOR_NODE_CASE(type_specifier, 1, P_type[count]) == NULL) actual_proto_no_params++;
      else if (P_pointer_level[count] > 0) actual_proto_no_params++;
      }

  /* determine if the prototype uses floating point. */
  proto_uses_floating_pt = ((TYPE_CATEGORY(TRUE, proto_return_type) == C_float) || 
                            (TYPE_CATEGORY(TRUE, proto_return_type) == C_double));

  for (count = 1 ; count <= proto_no_params; count ++)
      proto_uses_floating_pt = (proto_uses_floating_pt || ((TYPE_CATEGORY(TRUE, P_type[count]) == C_float) || 
                                                           (TYPE_CATEGORY(TRUE, P_type[count]) == C_double)));
}

#ifdef ANSI_FUNC

void
SHOW_proto_info(int index)
#else

void 
SHOW_proto_info (index)
int index;
#endif
{
  int i;
  GET_prototype_info(index);
  printf("\tP_levels: %d -  ", proto_return_pointer_level);
  for (i=1; i <= proto_no_params ; i++) printf("%d  ", P_pointer_level[i]);
  printf("\n");
}


/*  GET_param_type
 *  --------------
 *    
 *    Given a pointer to a parse tree for (parameter_declaration)
 *    this routine will return a pointer to the enclosed parse tree
 *    which details the paramater type information (declaration_specifiers).
 *
 */
#ifdef ANSI_FUNC

struct NODE *GET_param_type(struct NODE *tree)
#else

struct NODE *
GET_param_type (tree)
struct NODE *tree;
#endif
{
   ENTRY__("GET_param_type")
   ASSERT (tree != NULL, "GET_param_type: given null tree.");
   ASSERT((NODE_TYPE(tree)) == parameter_declaration, "GET_param_type: Incorrect node type.")

   return (NODE_PTR(tree,1));
}


/*  GET_param_name
 *  --------------
 *
 *    Given a pointer to a parse tree for (parameter_declaration)
 *    this routine will search for the parameter name.
 *    
 *    if present a pointer to the name in heap space will be returned.
 *    otherwise NULL is returned if the name is not present.
 *
 */
#ifdef ANSI_FUNC

char *GET_param_name(struct NODE *tree)
#else

char *
GET_param_name (tree)
struct NODE *tree;
#endif
{
   char *name = NULL;

   ENTRY__("GET_param_name")
   ASSERT (tree != NULL, "GET_param_name: given null tree.");
   ASSERT((NODE_TYPE(tree)) == parameter_declaration, "GET_param_name: Incorrect node type.")

   is_ptr = FALSE;  /* initially indicate that parameter is not a pointer */
   T_pointer_level = 0;

   switch (NODE_CASE(tree))
       {
       case 1:  if (  (SEARCH_FOR_NODE_CASE(direct_declarator, 2, NODE_PTR(tree,2)) != NULL) || 
                      (SEARCH_FOR_NODE_CASE(direct_declarator, 3, NODE_PTR(tree,2)) != NULL) ||
                      (SEARCH_FOR_NODE_CASE(direct_declarator, 4, NODE_PTR(tree,2)) != NULL) ||
                      (SEARCH_FOR_NODE_CASE(direct_declarator, 5, NODE_PTR(tree,2)) != NULL) ||
                      (SEARCH_FOR_NODE_CASE(direct_declarator, 6, NODE_PTR(tree,2)) != NULL) ||
                      (SEARCH_FOR_NODE_CASE(direct_declarator, 7, NODE_PTR(tree,2)) != NULL)    )
   	           break;

                name = identifier_symbol_table_ptr(LEAF_VALUE(NODE_PTR(SEARCH_FOR_NODE_CASE(direct_declarator, 1, tree), 1)));

                /* determine if prototype returns a pointer to its return type, and set flag accordingly
                   look at node case of (declarator) to determine if a pointer is returned. 
                   Also record the pointer level for this parameter. 
                 */
                T_pointer_level = 0;
                is_ptr = (NODE_CASE(NODE_PTR(tree,2)) == 1);
                if (is_ptr) T_pointer_level = COUNT_NODE_CASE_MATCHES(pointer, 0, NODE_PTR(tree,2));
                break;

       case 2:  name = NULL;  
                T_pointer_level = 0;
                is_ptr = (NODE_CASE(NODE_PTR(tree,2)) == 1);
                if (is_ptr) T_pointer_level = COUNT_NODE_CASE_MATCHES(pointer, 0, NODE_PTR(tree,2));
                break;

       case 3:  name = NULL;  break;

       default: ILLEGAL("GET_param_name: Unexpected case.");  break;
       }

   return (name);
}


#ifdef ANSI_FUNC

BOOLEAN  DISALLOW(node_types ntype, int ncase, struct NODE *tree)
#else

BOOLEAN 
DISALLOW (ntype, ncase, tree)
node_types ntype;
int ncase;
struct NODE *tree;
#endif
{
   return (SEARCH_FOR_NODE_CASE(ntype, ncase, tree) != NULL);
}


#ifdef ANSI_FUNC

void SUBSTITUTE (char *str)
#else

void 
SUBSTITUTE (str)
char *str;
#endif
{
  char *temp_ptr;
  
  ASSERT((str != NULL), "SUBSTITUTE: null pointer.");

   temp_ptr   = str;
   while ((*temp_ptr) != '\0')
       { if (*temp_ptr == '_') (*temp_ptr) = '.'; 
         temp_ptr++;
       }
}


#ifdef ANSI_FUNC

int TYPENAME_INDEX(char *name)
#else

int 
TYPENAME_INDEX (name)
char *name;
#endif
{
  int index=1;

  ENTRY__("TYPENAME_INDEX")
  while ( (index <= A_no_typedefs) && (strcmp(name, typedef_names[index]) != 0) )
     index++;

  if (strcmp(name, typedef_names[index]) != 0) index = 0;

  ASSERT (index != 0, "TYPENAME_INDEX: Can't find name in typedef symbol table.")
  return(index);
}


#ifdef ANSI_FUNC

int TYPENAME_SIZE(char *name)
#else

int 
TYPENAME_SIZE (name)
char *name;
#endif
{
  ENTRY__("TYPENAME_SIZE")

  return (typedef_type_sizes[TYPENAME_INDEX(name)]);
}



/*  POINTER_LEVEL:
 *  ------------- 
 *
 *  Given a type tree, returns its pointer level.
 *
 */
#ifdef ANSI_FUNC

int POINTER_LEVEL(BOOLEAN flag, struct NODE *tree)
#else

int 
POINTER_LEVEL (flag, tree)
BOOLEAN flag;
struct NODE *tree;
#endif
  
{

  ENTRY___("POINTER_LEVEL")
  if (tree == NULL) { WARNING("POINTER_LEVEL: Given null pointer"); return(0); }

  switch (TYPE_CATEGORY(flag, tree))
  {
     case C_typename:
        return(typedef_pointer_level[EXTRACT_TYPE_INDEX(tree)]);
        break;

     default:
	 /* Other types have zero level pointing within the type specification,
            the indirection level is found by looking at the (init_declarator) structure. */
        return (0);
        break;
  }
}


#ifdef ANSI_FUNC

int TYPE_LEVEL(struct NODE *tree)
#else

int 
TYPE_LEVEL (tree)
struct NODE *tree;
#endif
  
{

  ENTRY___("TYPE_LEVEL")
  if (tree == NULL) { WARNING("TYPE_LEVEL: Given null pointer"); return(0); }

  switch (TYPE_CATEGORY(FALSE, tree))
  {
     case C_typename:
        return(typedef_pointer_level[EXTRACT_TYPE_INDEX(tree)]);
        break;

     default:
	 /* Other types have zero level pointing within the type specification,
            the indirection level is found by looking at the (init_declarator) structure. */
        return (0);
        break;
  }
}



/*  ========================
 *  TRANSLATE_OCC   routines
 *  ========================
 *
 */






/*  TRANSLATE_OCC_prototype
 *  -----------------------
 *    
 *    Uses the information previously extracted for the current prototype
 *    to generate the Occam interface for the current prototype.
 *    
 *      proto_name                             - pointer to name of prototype.
 *      proto_no_params                        - number of parameters.
 *      proto_return_type                      - pointer to parse tree (declaration_specifiers) for return type.
 *      P_type[1]  .. P_type[MAX_PARAMETERS]   - pointer to parse tree (declaration_specifiers) for each parameter.
 *      P_name[1]  .. P_name[MAX_PARAMETERS]   - pointer to name of parameter (defaults to Pn).
 *
 *      P_is_ptr[1] .. P_is_ptr[MAX_PARAMETERS] - flags set if parameters are pointers to value.
 *      proto_returns_pointer                   - flag set if prototype returns a pointer to result.
 */


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_prototype (void)
#else

void TRANSLATE_OCC_prototype ()
#endif
{
  /* Generate the Occam interface components */

  TRANSLATE_OCC_head();
  TRANSLATE_OCC_name();
  TRANSLATE_OCC_begin_parameters();
  TRANSLATE_OCC_return_value();
  TRANSLATE_OCC_parameters();
  TRANSLATE_OCC_end_parameters();
  TRANSLATE_OCC_tail();
}


/*  TRANSLATE_OCC_output
 *  ------------------
 *    
 *    Produces the Occam interface output.
 *    
 */
#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_output (const char *str)
#else

void TRANSLATE_OCC_output(str)
  const char *str;
#endif
{
  char *ptr;

   OCC_posn += fprintf(OCC_interface_file, "%s", str);
   fflush(OCC_interface_file);

   ptr = strrchr(str, '\n');
   if (ptr != NULL)
   {
     /* Keep track of output position on line */
     while ((*ptr) != '\0')
     {
       if (*ptr == '\n') OCC_posn=0;
       else if (*ptr == '\t') OCC_posn = OCC_posn + (8 - (OCC_posn % 8));
       else OCC_posn++;
       ptr++;
     }
   }
}

#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_output_wrap (const char *str)
#else

void TRANSLATE_OCC_output_wrap (str)
  const char *str;
#endif
{
  if ( (OCC_wrap) && (OCC_posn > 60) )
  {
    while (OCC_posn < 75) TRANSLATE_OCC_output(" ");
    TRANSLATE_OCC_output(str);
  }
}

#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_output_comment (const char *str)
#else

void TRANSLATE_OCC_output_comment(str)
  const char *str;
#endif
{
   TRANSLATE_OCC_output("-- ");
   TRANSLATE_OCC_output(str);
   TRANSLATE_OCC_output("\n");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_output_number (int value)
#else

void TRANSLATE_OCC_output_number (value)
 int value;
#endif
{
   OCC_posn = OCC_posn + fprintf(OCC_interface_file, "%d", value);
   fflush(OCC_interface_file);
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_head (void)
#else

void TRANSLATE_OCC_head ()
#endif
{
   TRANSLATE_OCC_output("#PRAGMA EXTERNAL \"");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_name (void)
#else

void TRANSLATE_OCC_name ()
#endif
{
   char *occam_name;

   TRANSLATE_OCC_output("PROC C.");

   /* Substitute '_' for '.' in name. */
   occam_name = strdup(proto_name);
   SUBSTITUTE (occam_name);

   TRANSLATE_OCC_output(occam_name);
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_begin_parameters (void)
#else

void TRANSLATE_OCC_begin_parameters ()
#endif
{
   TRANSLATE_OCC_output(" (");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_return_value (void)
#else

void TRANSLATE_OCC_return_value ()
#endif
{  
  C_TYPES category_found;
  int size;

   if (!proto_void_return_value) 
   { category_found = TYPE_CATEGORY(TRUE, proto_return_type);

     /* setup size info if typename present, only used when structure/union. */
     size = 0;
     if (TYPE_CATEGORY(FALSE, proto_return_type) == C_typename) size = TYPENAME_SIZE(proto_return_type_name);

     switch(proto_return_pointer_level)
     {
       case 0:  
               TRANSLATE_OCC_output(REPLACE_HASH(OCC_pattern[category_found], size));
               break;

       case 1:  
               TRANSLATE_OCC_output(REPLACE_HASH(OCC_pattern[category_found], size));
               break;

       default:
   	       /* Mapping for multi level pointers (** *** ...) */
               TRANSLATE_OCC_output(OCC_pattern_ptr_ptr);
               break;
     }
     TRANSLATE_OCC_output(" result");
   }
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_parameters (void)
#else

void TRANSLATE_OCC_parameters ()
#endif
{
  int index;

    /* seperate (return parameter) if neccesary */
   if ((!proto_void_return_value) && (actual_proto_no_params > 0)) TRANSLATE_OCC_output(", ");

   for (index=1; index<=proto_no_params; index++) 
       /* Ignore parameter if void, but allow (void *)  */
       if (  (TYPE_CATEGORY(TRUE, P_type[index]) != C_void)  ||
             ( (TYPE_CATEGORY(TRUE, P_type[index]) == C_void ) && (P_pointer_level[index] > 0) )
          )
	     /* if (SEARCH_FOR_NODE_CASE(type_specifier, 1, P_type[index]) == NULL) */
          {
            TRANSLATE_OCC_parameter(index);
            /* seperate if neccesary */
            if (index < proto_no_params) 
            {
               TRANSLATE_OCC_output(", ");
               TRANSLATE_OCC_output_wrap("*\n\t\t\t*");
            }
          }
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_parameter (int index)
#else

void TRANSLATE_OCC_parameter(index)
  int index;
#endif
{
  char *occam_name;
  C_TYPES category_found;
  int size;

   /* generate the Occam type */
   category_found = TYPE_CATEGORY(TRUE, P_type[index]);

   /* setup size info if typename present, only used when structure/union. */
   size = 0;
   if (TYPE_CATEGORY(FALSE, P_type[index]) == C_typename) size = TYPENAME_SIZE(P_type_name[index]);

   switch(P_pointer_level[index])
   {
     case 0:
             if (category_found != C_struct)  TRANSLATE_OCC_output("VAL ");
             TRANSLATE_OCC_output(REPLACE_HASH(OCC_pattern[category_found], size));
             break;

     case 1:
             TRANSLATE_OCC_output(REPLACE_HASH(OCC_pattern[category_found], size));
             break;

     default:
   	     /* Mapping for multi level pointers (** *** ...) */
             TRANSLATE_OCC_output(OCC_pattern_ptr_ptr);
             break;
   }

      TRANSLATE_OCC_output(" ");

      /* generate the parameter name */
      occam_name = strdup(P_name[index]);
      SUBSTITUTE(occam_name);

   TRANSLATE_OCC_output(occam_name);
   free(occam_name);
}




#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_end_parameters (void)
#else

void TRANSLATE_OCC_end_parameters ()
#endif
{
   TRANSLATE_OCC_output(")");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_tail (void)
#else

void TRANSLATE_OCC_tail ()
#endif
{
   TRANSLATE_OCC_output("  = 0 \" \n");
}



#ifdef ANSI_FUNC

void 
TRANSLATE_OCC_typedef_sizes (void)
#else

void TRANSLATE_OCC_typedef_sizes ()
#endif
{
  int index;
  char *occam_name;
  
  TRANSLATE_OCC_output("\n\n");
  TRANSLATE_OCC_output_comment("Predefines for C typedef sizes");

  for(index = 1; index <= A_no_typedefs; index++)
  {
     TRANSLATE_OCC_output("VAL INT ");
     TRANSLATE_OCC_output("C.");

     /* Map '_' to '.' in C typedef name. */
     occam_name = strdup(typedef_names[index]);
     SUBSTITUTE(occam_name);
     TRANSLATE_OCC_output(occam_name);

     TRANSLATE_OCC_output(" \tIS ");
     TRANSLATE_OCC_output_number(typedef_type_sizes[index]);
     TRANSLATE_OCC_output(":\n");
  }

  TRANSLATE_OCC_output("\n\n");
}





/*  ======================
 *  TRANSLATE_C   routines
 *  ======================
 *
 */

BOOLEAN  cast_needed;
BOOLEAN  return_cast_needed;
BOOLEAN  value_needed;


/*  TRANSLATE_C_prototype
 *  ---------------------
 *    
 *    Uses the information previously extracted for the current prototype
 *    to generate the C interface for the current prototype.
 *    
 *      proto_name                             - pointer to name of prototype.
 *      proto_no_params                        - number of parameters.
 *      proto_return_type                      - pointer to parse tree (declaration_specifiers) for return type.
 *      P_type[1]  .. P_type[MAX_PARAMETERS]   - pointer to parse tree (declaration_specifiers) for each parameter.
 *      P_name[1]  .. P_name[MAX_PARAMETERS]   - pointer to name of parameter (defaults to Pn).
 *
 *      P_is_ptr[1] .. P_is_ptr[MAX_PARAMETERS] - flags set if parameters are pointers to there value.
 *      proto_returns_pointer                   - flag set if prototype returns a pointer to its result.
 *      proto_uses_floating_pt                  - flag set if the routine needs to use floating point.
 */

void TRANSLATE_C_return_value ();
void TRANSLATE_C_name ();
void TRANSLATE_C_begin_parameters ();
void TRANSLATE_C_parameters ();
void TRANSLATE_C_end_parameters ();
void TRANSLATE_C_workspace ();
void TRANSLATE_C_body ();

#ifdef ANSI_FUNC

void 
TRANSLATE_C_prototype (void)
#else

void TRANSLATE_C_prototype ()
#endif
{
  /* Generate the C interface components */

  TRANSLATE_C_return_value();
  TRANSLATE_C_name();
  TRANSLATE_C_begin_parameters();
  TRANSLATE_C_parameters();
  TRANSLATE_C_end_parameters();
  TRANSLATE_C_workspace();
  TRANSLATE_C_body();

}


/*  TRANSLATE_C_output
 *  ------------------
 *    
 *    Produces the C interface output.
 *    
 */

#ifdef ANSI_FUNC

void TRANSLATE_C_output(const char *str)
#else

void 
TRANSLATE_C_output (str)
const char *str;
#endif
{
  char *ptr;

   C_posn += fprintf(C_interface_file, "%s", str);
   fflush(C_interface_file);

   ptr = strrchr(str, '\n');
   if (ptr != NULL)
   {
     /* Keep track of output position on line */
     while ((*ptr) != '\0')
     {
       if (*ptr == '\n') C_posn=0;
       else if (*ptr == '\t') C_posn = C_posn + (8 - (C_posn % 8));
       else C_posn++;
       ptr++;
     }
   }
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_output_wrap (const char *str)
#else

void TRANSLATE_C_output_wrap(str)
  const char *str;
#endif
{
  if ( (C_wrap) && (C_posn > 60) )
  {
    TRANSLATE_C_output(str);
  }
}



#ifdef ANSI_FUNC

void 
TRANSLATE_C_output_comment (const char *str)
#else

void TRANSLATE_C_output_comment(str)
  const char *str;
#endif
{
   TRANSLATE_C_output("/* ");
   TRANSLATE_C_output(str);
   TRANSLATE_C_output(" */ \n");
}


/*  TRANSLATE_C_output_number
 *  -------------------------
 *    
 *    Produces the C interface output.
 *    
 */
#ifdef ANSI_FUNC

void TRANSLATE_C_output_number(int value)
#else

void 
TRANSLATE_C_output_number (value)
int value;
#endif
{
   C_posn = C_posn + fprintf(C_interface_file, "%d", value);
   fflush(C_interface_file);
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_TYPE_declarations (void)
#else

void TRANSLATE_C_TYPE_declarations()
#endif
{
  int index;
  int lines;

  lines = sizeof(TYPE_declarations) / sizeof (char *);

  for (index=0; index < lines; index++)
      TRANSLATE_C_output(TYPE_declarations[index]);
}

#ifdef ANSI_FUNC

void 
TRANSLATE_C_include (void)
#else

void TRANSLATE_C_include ()
#endif
{
   TRANSLATE_C_output_comment("include original file for prototypes.");
   TRANSLATE_C_output("#include \"");
   TRANSLATE_C_output(original_input_base_name);
   TRANSLATE_C_output("\"\n\n");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_return_value (void)
#else

void TRANSLATE_C_return_value ()
#endif
{
   TRANSLATE_C_output("\nvoid  ");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_name (void)
#else

void TRANSLATE_C_name ()
#endif
{
   TRANSLATE_C_output("_");
   TRANSLATE_C_output(proto_name);
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_begin_parameters (void)
#else

void TRANSLATE_C_begin_parameters ()
#endif
{
   TRANSLATE_C_output(" (");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_parameters (void)
#else

void TRANSLATE_C_parameters ()
#endif
{

   if ((proto_void_return_value) && (actual_proto_no_params == 0)) TRANSLATE_C_output("void");
   else TRANSLATE_C_output("w");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_end_parameters (void)
#else

void TRANSLATE_C_end_parameters ()
#endif
{
   TRANSLATE_C_output(")\n");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_workspace (void)
#else

void TRANSLATE_C_workspace ()
#endif
{
  int workspace_size;

   workspace_size = (actual_proto_no_params + proto_arrays);
   if (!proto_void_return_value) workspace_size++;  /* add 1 for w[0] as a return parameter */

   if (workspace_size > 0)
   {
     TRANSLATE_C_output("word w[");
     TRANSLATE_C_output_number(workspace_size);
     TRANSLATE_C_output("];\n");
   }
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_body (void)
#else

void TRANSLATE_C_body ()
#endif
{
  int count, start=0, finish;

   TRANSLATE_C_output("{\n");

   if (proto_endian_manipulation) TRANSLATE_C_Endian_declarations();
   if (proto_endian_manipulation) TRANSLATE_C_Pre_Endian();

   TRANSLATE_C_output("\t");


   /* generate return assignment if needed */
   if (!proto_void_return_value) 
   { 
      start=1; 
      switch (proto_return_pointer_level)
      { 
	  case 0:
             TRANSLATE_C_output(REPLACE_HASH(RETURN_pattern[TYPE_CATEGORY(TRUE, proto_return_type)],0));
             break;

          case 1:
             TRANSLATE_C_output(REPLACE_HASH(RETURN_pattern_p[TYPE_CATEGORY(TRUE, proto_return_type)],0));
             break;

          default:
             /* Treat pointer pointers as integers */
             TRANSLATE_C_output(REPLACE_HASH(RETURN_pattern[C_int],0));
             break;
      }

      TRANSLATE_C_output(" = ");  

      /* Insert pointer code to reference value if needed */
      BEGIN_REFERENCE_VALUE();

      /* Mechanism for casting the return type if needed */ 
      BEGIN_CAST_RETURN();
   
   }

   TRANSLATE_C_output(proto_name);
   TRANSLATE_C_output("(");

   /* Generate call arguments */

   finish = actual_proto_no_params;
   if (proto_void_return_value) finish--;

   if (actual_proto_no_params > 0) 
      {
      for (count=1; count <= proto_no_params; count++)
          { /* Ignore parameter if void, but allow (VOID *)  */
            if (  (TYPE_CATEGORY(TRUE, P_type[count]) != C_void)  ||
                  ( (TYPE_CATEGORY(TRUE, P_type[count]) == C_void ) && (P_pointer_level[count] > 0) )
               )
               {
                 BEGIN_CAST(count);
                 TRANSLATE_C_call_argument(count);
                 END_CAST(count);

                 /* seperate if neccesary */
                 if (count < proto_no_params) 
		 {
                    TRANSLATE_C_output(", ");
                    TRANSLATE_C_output_wrap("\n\t\t");
		 }
               }
          }
      }

   TRANSLATE_C_output(")");

   if (!proto_void_return_value)
   {
     END_CAST_RETURN();
     END_REFERENCE_VALUE();
   }

   TRANSLATE_C_output(";\n");

   if (proto_endian_manipulation) TRANSLATE_C_Post_Endian();

   if (proto_uses_floating_pt) TRANSLATE_C_Restore_fp();

   TRANSLATE_C_output("}\n");
}



#ifdef ANSI_FUNC

void TRANSLATE_C_call_argument(int index)
#else

void 
TRANSLATE_C_call_argument (index)
int index;
#endif
{
  int w_no, i;

   /* determine the w[] index value for this parameter (take account of occam array parameters!)  */
   w_no = 1;
   for (i=1; i<index; i++) w_no += P_param_size[i];

   if (proto_void_return_value) w_no--;

   /* generate the call type */
   switch(P_pointer_level[index])
   {
     case 0:
             TRANSLATE_C_output(REPLACE_HASH(CALL_pattern[TYPE_CATEGORY(TRUE, P_type[index])],w_no));
             break;

     case 1:
             TRANSLATE_C_output(REPLACE_HASH(CALL_pattern_p[TYPE_CATEGORY(TRUE, P_type[index])],w_no));
             break;

     default:
   	     /* Treat pointer pointers as integers */
             TRANSLATE_C_output(REPLACE_HASH(CALL_pattern[C_int],w_no));
             break;
   }
}

#ifdef ANSI_FUNC

void 
TRANSLATE_C_Declare_Double (int no)
#else

void TRANSLATE_C_Declare_Double(no)
  int no;
#endif
{
  TRANSLATE_C_output(REPLACE_HASH("  pair D##;\n", no));
}

#ifdef ANSI_FUNC

void 
TRANSLATE_C_Declare_longlong (int no)
#else

void TRANSLATE_C_Declare_longlong(no)
  int no;
#endif
{ 
  TRANSLATE_C_output(REPLACE_HASH("  pair L##;\n", no));
}

#ifdef ANSI_FUNC

void 
TRANSLATE_C_Endian_declarations (void)
#else

void TRANSLATE_C_Endian_declarations ()
#endif
{
  int index;
  
  /* Define local variables for endian manipulation of ground types DOUBLE */

  /* for return type manipulation */
  if (TYPE_CATEGORY(TRUE, proto_return_type) == C_double) TRANSLATE_C_Declare_Double(0);
  else if ( (TYPE_CATEGORY(TRUE, proto_return_type) == C_long_long_int)          || 
            (TYPE_CATEGORY(TRUE, proto_return_type) == C_signed_long_long_int)   || 
            (TYPE_CATEGORY(TRUE, proto_return_type) == C_unsigned_long_long_int) 
          )
          TRANSLATE_C_Declare_longlong(0);
  
  

  /* for parameter manipulation */
  for (index=1; index <= proto_no_params; index++)
  {
      if (TYPE_CATEGORY(TRUE, P_type[index]) == C_double) 
      {  if (proto_void_return_value ) TRANSLATE_C_Declare_Double(index-1);
         else TRANSLATE_C_Declare_Double(index); 
      }
      if ( (TYPE_CATEGORY(TRUE, P_type[index]) == C_long_long_int)          ||
           (TYPE_CATEGORY(TRUE, P_type[index]) == C_signed_long_long_int)   || 
           (TYPE_CATEGORY(TRUE, P_type[index]) == C_unsigned_long_long_int) 
         )
      {  if (proto_void_return_value ) TRANSLATE_C_Declare_longlong(index-1);
         else TRANSLATE_C_Declare_longlong(index); 
      }

  }

   TRANSLATE_C_output("\n");
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_Pre_Endian_Double (int no)
#else

void TRANSLATE_C_Pre_Endian_Double(no)
  int no;
#endif
{
  TRANSLATE_C_output(REPLACE_HASH("\tD##.i[0] = w[##].pp->i[1];\n", no));
  TRANSLATE_C_output(REPLACE_HASH("\tD##.i[1] = w[##].pp->i[0];\n\n", no));
}

#ifdef ANSI_FUNC

void 
TRANSLATE_C_Pre_Endian_longlong (int no)
#else

void TRANSLATE_C_Pre_Endian_longlong(no)
  int no;
#endif
{
  TRANSLATE_C_output(REPLACE_HASH("\tL##.i[0] = w[##].pp->i[1];\n", no));
  TRANSLATE_C_output(REPLACE_HASH("\tL##.i[1] = w[##].pp->i[0];\n\n", no));
}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_Pre_Endian (void)
#else

void TRANSLATE_C_Pre_Endian ()
#endif
{
  int index;
  
  /* NO PRE-MANIPULATION for return value!  */

  /* pre-endian parameter manipulation */
  for (index=1; index <= proto_no_params; index++)
  {
      if (TYPE_CATEGORY(TRUE, P_type[index]) == C_double)
      {  if (proto_void_return_value ) TRANSLATE_C_Pre_Endian_Double(index-1);
         else TRANSLATE_C_Pre_Endian_Double(index); 
      }

      if ( (TYPE_CATEGORY(TRUE, P_type[index]) == C_long_long_int)          ||
           (TYPE_CATEGORY(TRUE, P_type[index]) == C_signed_long_long_int)   || 
           (TYPE_CATEGORY(TRUE, P_type[index]) == C_unsigned_long_long_int) 
         )
      {  if (proto_void_return_value ) TRANSLATE_C_Pre_Endian_longlong(index-1);
         else TRANSLATE_C_Pre_Endian_longlong(index); 
      }
  }


}


#ifdef ANSI_FUNC

void 
TRANSLATE_C_Post_Endian_Double (int no)
#else

void TRANSLATE_C_Post_Endian_Double(no)
  int no;
#endif
{
  TRANSLATE_C_output(REPLACE_HASH("\tw[##].pp->i[0] = D##.i[1];\n", no));
  TRANSLATE_C_output(REPLACE_HASH("\tw[##].pp->i[1] = D##.i[0];\n\n", no));
}

#ifdef ANSI_FUNC

void 
TRANSLATE_C_Post_Endian_longlong (int no)
#else

void TRANSLATE_C_Post_Endian_longlong(no)
  int no;
#endif
{
  TRANSLATE_C_output(REPLACE_HASH("\tw[##].pp->i[0] = L##.i[1];\n", no));
  TRANSLATE_C_output(REPLACE_HASH("\tw[##].pp->i[1] = L##.i[0];\n\n", no));
}

#ifdef ANSI_FUNC

void TRANSLATE_C_Post_Endian(void)
#else

void 
TRANSLATE_C_Post_Endian ()
#endif
{
  int index;
  
  TRANSLATE_C_output("\n");

  /* for return type manipulation */
  if (TYPE_CATEGORY(TRUE, proto_return_type) == C_double) TRANSLATE_C_Post_Endian_Double(0);
  else if ( (TYPE_CATEGORY(TRUE, proto_return_type) == C_long_long_int)          || 
            (TYPE_CATEGORY(TRUE, proto_return_type) == C_signed_long_long_int)   || 
            (TYPE_CATEGORY(TRUE, proto_return_type) == C_unsigned_long_long_int) 
          )
          TRANSLATE_C_Post_Endian_longlong(0);

  /* for parameter manipulation (POINTERS) */
  for (index=1; index <= proto_no_params; index++)
  {
      if ((TYPE_CATEGORY(TRUE, P_type[index]) == C_double) && (P_is_ptr[index]))
      {  if (proto_void_return_value ) TRANSLATE_C_Post_Endian_Double(index-1);
          else TRANSLATE_C_Post_Endian_Double(index); 
      }

      if ( (P_is_ptr[index]) &&
           ( (TYPE_CATEGORY(TRUE, proto_return_type) == C_long_long_int)          || 
             (TYPE_CATEGORY(TRUE, proto_return_type) == C_signed_long_long_int)   || 
             (TYPE_CATEGORY(TRUE, proto_return_type) == C_unsigned_long_long_int) 
           )
         )
      {  if (proto_void_return_value ) TRANSLATE_C_Post_Endian_longlong(index-1);
          else TRANSLATE_C_Post_Endian_longlong(index); 
      }


  }

}


#ifdef ANSI_FUNC

void TRANSLATE_C_Restore_fp(void)
#else

void 
TRANSLATE_C_Restore_fp ()
#endif
{
   TRANSLATE_C_output("\tfpconst();\n");
}


#ifdef ANSI_FUNC

char *
inttostr (int no)
#else

char *inttostr(no)
  int no;
#endif
{
  char *ptr;
  int val, d;
 
   ASSERT ( ((no <= 9999) && (no >= 0)), "inttostr: Value out of range.");

   ptr = strdup("0000");
   val = no;

   /* point to end of string. */
   ptr = ptr + 4;

   while (val > 0)
   {
      d = val % 10;
      ptr--;
      (*ptr) =  ('0' + d);     
      val = val / 10;
   }

   if (no == 0) ptr--;

   return (ptr);
}



/*  REPLACE_HASH
 *
 *   Generates a new string with the "##" replaced by the 
 *   number (no).  - Used to complete the CALL_pattern string.
 */
#ifdef ANSI_FUNC

char *REPLACE_HASH(const char *str, int no)
#else

char *
REPLACE_HASH (str, no)
const char *str;
int no;
#endif
{
  char *temp_str;
  const char *ptr0;
  char *ptr1, *ptr2;

  temp_str = (char*) malloc(strlen(str)+1);
  ASSERT((temp_str != NULL), "REPLACE_HASH: out of heap space.");

  if (strstr(str, "##") == NULL) return((char*)str);

  ptr0 = str;
  ptr1 = temp_str;
  ptr2 = inttostr(no);

  /* Copy head of str to temp_str */
  while (*ptr0 != '#')  { (*ptr1) = (*ptr0); ptr0++; ptr1++; }

 
  /* Insert (no) into temp_str */
  while (*ptr2 != '\0') { (*ptr1) = (*ptr2); ptr2++; ptr1++; ptr0++; }

  free(ptr2);

  while ((*ptr0) == '#') ptr0++;

  /* Copy tail of str to temp_str */
  while (*ptr0 != '\0')  { (*ptr1) = (*ptr0); ptr0++; ptr1++; }
 
  /* make sure temp_str is terminated with \0. */
  *ptr1 = '\0';

  /* Substitute remaining "##" substrings if present */
  /* FIXME: memory leak here - DJB */
  if (strstr(temp_str, "##") != NULL) return (REPLACE_HASH(temp_str, no));
  else return(temp_str);
}



#ifdef ANSI_FUNC

void BEGIN_CAST(int param)
#else

void 
BEGIN_CAST (param)
int param;
#endif
{
   cast_needed = (TYPE_CATEGORY(FALSE, P_type[param]) == C_typename);

   if (cast_needed)  
   {
      TRANSLATE_C_output("(");
      TRANSLATE_C_output(P_type_name[param]);
      if (P_pointer_level[param] > 0) TRANSLATE_C_output(" *");
      TRANSLATE_C_output(") (");
   }
}


#ifdef ANSI_FUNC

void BEGIN_CAST_RETURN(void)
#else

void 
BEGIN_CAST_RETURN ()
#endif
{
   return_cast_needed = (  (TYPE_CATEGORY(FALSE, proto_return_type) == C_typename) || 
                           (proto_return_pointer_level == 2)   );

   if (return_cast_needed)  
   {
      switch (proto_return_pointer_level)
      { 
	  case 0:

             TRANSLATE_C_output(CAST_RETURN_pattern[TYPE_CATEGORY(TRUE, proto_return_type)]);
             break;

          case 1:
             
             TRANSLATE_C_output(CAST_RETURN_pattern_p[TYPE_CATEGORY(TRUE, proto_return_type)]);
             break;

          default:
             /* Treat pointer pointers as integers */
             TRANSLATE_C_output(CAST_RETURN_pattern[C_int]);
             break;
      }

      TRANSLATE_C_output(" (");
   }
}


#ifdef ANSI_FUNC

void END_CAST(int param)
#else

void 
END_CAST (param)
int param;
#endif
{
   if (cast_needed)  
   {
      TRANSLATE_C_output(")");
   }
}


#ifdef ANSI_FUNC

void END_CAST_RETURN(void)
#else

void 
END_CAST_RETURN ()
#endif
{
   if (return_cast_needed)  
   {
      TRANSLATE_C_output(")");
   }
}


#ifdef ANSI_FUNC

void BEGIN_REFERENCE_VALUE(void)
#else

void 
BEGIN_REFERENCE_VALUE ()
#endif
{
   switch(TYPE_CATEGORY(TRUE, proto_return_type))
       {
       case C_double:
       case C_long_long_int:
       case C_signed_long_long_int:
       case C_unsigned_long_long_int:

         value_needed = TRUE;
         break;

       default:

         value_needed = FALSE;
         break;
       }

   /* we only need to extract the value from functions returning pointers. */
   if (proto_return_pointer_level < 1) value_needed = FALSE;

   if (value_needed)  
   {
      TRANSLATE_C_output("(* ( ");
   }
}


#ifdef ANSI_FUNC

void END_REFERENCE_VALUE(void)
#else

void 
END_REFERENCE_VALUE ()
#endif
{
   if (value_needed)  
   {
      TRANSLATE_C_output(" ))");
   }
}




/*  ==================
 *  SUPPORT   routines
 *  ==================
 *
 *  These Routines provide useful functionality.
 *     
 */


#ifdef ANSI_FUNC

BOOLEAN  IS_LEAF(struct NODE *tree)
#else

BOOLEAN 
IS_LEAF (tree)
struct NODE *tree;
#endif
{
    ENTRY___("IS_LEAF")
    return (tree->leaf);
}


#ifdef ANSI_FUNC

leaf_types   LEAF_TYPE(struct NODE *tree)
#else

leaf_types 
LEAF_TYPE (tree)
struct NODE *tree;
#endif
{
    ENTRY___("LEAF_TYPE")
    ASSERT (tree != NULL, "LEAF_TYPE")
    return (tree->ltype);
}


#ifdef ANSI_FUNC

leaf_value   LEAF_VALUE(struct NODE *tree)
#else

leaf_value 
LEAF_VALUE (tree)
struct NODE *tree;
#endif
{
    ENTRY___("LEAF_VALUE")
    ASSERT (tree != NULL, "LEAF_VALUE")
    return (tree->lvalue);
}


#ifdef ANSI_FUNC

leaf_types   LEFTMOST_LEAF_TYPE(struct NODE *tree)
#else

leaf_types 
LEFTMOST_LEAF_TYPE (tree)
struct NODE *tree;
#endif
{
    ENTRY___("LEFTMOST_LEAF_TYPE")
    ASSERT (tree != NULL, "LEFTMOST_LEAF_TYPE")

    if (IS_LEAF(tree)) {
        return LEAF_TYPE(tree);
    }
    else {
        return LEFTMOST_LEAF_TYPE(NODE_PTR(tree,1));
    }
}


#ifdef ANSI_FUNC

leaf_value   LEFTMOST_LEAF_VALUE(struct NODE *tree)
#else

leaf_value 
LEFTMOST_LEAF_VALUE (tree)
struct NODE *tree;
#endif
{
    ENTRY___("LEFTMOST_LEAF_VALUE")
    ASSERT (tree != NULL, "LEFTMOST_LEAF_VALUE")

    if (IS_LEAF(tree)) {
        return LEAF_VALUE(tree);
    }
    else {
        return LEFTMOST_LEAF_VALUE(NODE_PTR(tree,1));
    }
}


#ifdef ANSI_FUNC

leaf_types   RIGHTMOST_LEAF_TYPE(struct NODE *tree)
#else

leaf_types 
RIGHTMOST_LEAF_TYPE (tree)
struct NODE *tree;
#endif
{
    ENTRY___("RIGHTMOST_LEAF_TYPE")
    ASSERT (tree != NULL, "RIGHTMOST_LEAF_TYPE")

    if (IS_LEAF(tree)) {
        return LEAF_TYPE(tree);
    }
    else {
        return RIGHTMOST_LEAF_TYPE(RIGHTMOST_PTR(tree));
    }
}


#ifdef ANSI_FUNC

leaf_value   RIGHTMOST_LEAF_VALUE(struct NODE *tree)
#else

leaf_value 
RIGHTMOST_LEAF_VALUE (tree)
struct NODE *tree;
#endif
{
    ENTRY___("RIGHTMOST_LEAF_VALUE")
    ASSERT (tree != NULL, "RIGHTMOST_LEAF_VALUE")

    if (IS_LEAF(tree)) {
        return LEAF_VALUE(tree);
    }
    else {
        return RIGHTMOST_LEAF_VALUE(RIGHTMOST_PTR(tree));
    }
}


/*  SEARCH_FOR_NODE_CASE
 *  --------------------
 *
 *     Performs a leftmost outermost search of the given (tree)
 *     for the specified node type (grule) and case (gcase).
 * 
 *     Returning:  a pointer to the matching node if found, otherwise NULL.
 * 
 *     (gcase == 0) is a wildcard case match.
 * 
 */

#ifdef ANSI_FUNC

struct NODE *SEARCH_FOR_NODE_CASE(node_types grule, int gcase, struct NODE *tree)
#else

struct NODE *
SEARCH_FOR_NODE_CASE (grule, gcase, tree)
node_types grule;
int gcase;
struct NODE *tree;
#endif
{
  struct NODE *temp;
  int index;

    ENTRY__("SEARCH_FOR_NODE_CASE")

    if (tree == NULL)  return (NULL);

    if (IS_LEAF(tree)) return (NULL);

    if ((NODE_TYPE(tree) == grule) && (gcase == 0)) return (tree);

    if ((NODE_TYPE(tree) == grule) && (NODE_CASE(tree) == gcase)) return (tree);

    temp = NULL;
    index = 1;
    while ((temp == NULL) && (index < 4)) {
        temp = SEARCH_FOR_NODE_CASE(grule, gcase, NODE_PTR(tree,index));
        index++;
    }

    return (temp);
}


/*  SEARCH_FOR_LEAF_TYPE
 *  --------------------
 *
 *     Performs a leftmost outermost search of the given (tree)
 *     for the specified leaf (type).
 * 
 *     Returning:  a pointer to the matching leaf if found, otherwise NULL.
 * 
 *     (case == 0) is a wildcard case match.
 * 
 */

#ifdef ANSI_FUNC

struct NODE *SEARCH_FOR_LEAF_TYPE(leaf_types ltype, struct NODE *tree)
#else

struct NODE *
SEARCH_FOR_LEAF_TYPE (ltype, tree)
leaf_types ltype;
struct NODE *tree;
#endif
{
  struct NODE *temp;
  int index;

    ENTRY__("SEARCH_FOR_LEAF_TYPE")

    if (tree == NULL)  return (NULL);

    if (IS_LEAF(tree)) { 
         if (LEAF_TYPE(tree) == ltype) return (tree); 
         else return (NULL);
    }


    temp = NULL;
    index = 1;
    while ((temp == NULL) && (index < 4)) {
        temp = SEARCH_FOR_LEAF_TYPE(ltype, NODE_PTR(tree,index));
        index++;
    }

    return (temp);
}






/*   COUNT_NODE_CASE_MATCHES:
 *   -----------------------
 *
 *      Counts the number of nodes matching the given pattern in the given (tree).
 *
 *
 */

#ifdef ANSI_FUNC

int COUNT_NODE_CASE_MATCHES (node_types grule, int gcase, struct NODE *tree)
#else

int 
COUNT_NODE_CASE_MATCHES (grule, gcase, tree)
node_types grule;
int gcase;
struct NODE *tree;
#endif
{
  int index, count=0;

    ENTRY__("COUNT_NODE_CASE_MATCHES")

    if (tree == NULL)  return (0);

    if (IS_LEAF(tree)) return (0);

    if ((NODE_TYPE(tree) == grule) && (gcase == 0)) count = 1;

    if ((NODE_TYPE(tree) == grule) && (NODE_CASE(tree) == gcase)) count = 1;

    for (index=1; index<4; index++) count = count + COUNT_NODE_CASE_MATCHES(grule, gcase, NODE_PTR(tree,index));
     
    return (count);

}



/*   EXTRACT_NODE_CASE_MATCHES:
 *   -------------------------
 *
 *      Finds all nodes matching the given pattern in the given (tree).
 *      Filling the global array (Node_Matches) with pointers to matched nodes.
 *      (Node_Matches_Count) is set to the number of node matches found.
 */


#ifdef ANSI_FUNC

void ADD_MATCH (struct NODE *tree)
#else

void 
ADD_MATCH (tree)
struct NODE *tree;
#endif
{
  ASSERT(Node_Matches_Count < MAX_NODE_MATCHES, "ADD_MATCH: Overflow.");

  Node_Matches_Count++;
  Node_Matches[Node_Matches_Count] = tree; 
}

#ifdef ANSI_FUNC

void ADD_NODE_MATCHES (node_types grule, int gcase, struct NODE *tree)
#else

void 
ADD_NODE_MATCHES (grule, gcase, tree)
node_types grule;
int gcase;
struct NODE *tree;
#endif
  
{
  ENTRY__("EXTRACT_NODE_CASE_MATCHES")

  if (tree == NULL)  return;

  if (IS_LEAF(tree)) return;

  if ((NODE_TYPE(tree) == grule) && (gcase == 0)) ADD_MATCH(tree);

  if ((NODE_TYPE(tree) == grule) && (NODE_CASE(tree) == gcase)) ADD_MATCH(tree);

  ADD_NODE_MATCHES (grule, gcase, NODE_PTR(tree,1));
  ADD_NODE_MATCHES (grule, gcase, NODE_PTR(tree,2));
  ADD_NODE_MATCHES (grule, gcase, NODE_PTR(tree,3));
 
  return;
}



#ifdef ANSI_FUNC

void EXTRACT_NODE_CASE_MATCHES (node_types grule, int gcase, struct NODE *tree)
#else

void 
EXTRACT_NODE_CASE_MATCHES (grule, gcase, tree)
node_types grule;
int gcase;
struct NODE *tree;
#endif
{
  int count=0;

  count = COUNT_NODE_CASE_MATCHES(grule, gcase, tree);
  ASSERT (count < MAX_NODE_MATCHES, "EXTRACT_NODE_CASE_MATCHES: too many matches for array size.");

  Node_Matches_Count = 0;
  ADD_NODE_MATCHES (grule, gcase, tree);    
}



/*
void PROGRESS (int n, int end)
{
  static int pcounter;

  if (n==1) pcounter=0;

  if (end > 10)
  {
    if ((n % (end / 10)) == 0) 
    {
       pcounter += 10;
       printf("%3d%%\r", pcounter);
       fflush(stdout);
    }
  }
}
*/
