/*
 *	Constants for system dependance
 *	Copyright (C) 1989, 1990 Inmos Limited
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* host_os.h -- Define the constants for system dependence */
/* Copyright Inmos 1989, 1990 */
/* CMSIDENTIFIER */
/* ARG_AHP:HOST_OS_H@535.S4-FILE;1(30-APR-92)[UNDER-DEVELOPMENT] */
/* Version 1.0 -- 19900129 */
/* History */
/* ahp: First version written 19900129 */
/* ahp: Converted for CMS 19910823 */

/* Define the possible hosts for execution */

#define SERVER   0   /* Transputer hosted, running under iserver */
#define MS_DOS   1   /* Hosted by MS-DOS                         */
#define HELIOS   2   /* Hosted by Helios                         */
#define    VMS   3   /* Hosted by VMS                            */
#define SUN_OS   4   /* Hosted by SunOs                          */
#define UNIX     4   /* SunOS or OSF1 */

/* Define the expected host at execution time */

#ifndef __alpha
#define HOST -1
#endif

#ifdef SUN3
#undef HOST
#define HOST SUN_OS
#endif

#ifdef SUN4
#undef HOST
#define HOST SUN_OS
#endif

#ifdef PC
#undef HOST
#define HOST MS_DOS
#endif

#ifdef VAX
#undef HOST
#define HOST VMS
#endif

#ifdef TP
#undef HOST
#define HOST SERVER
#endif
