/* $Id: predefhd.h,v 1.1 1996/04/15 10:52:18 djb1 Exp $ */

/*
 *	predefined routine numbers
 *	Copyright (C) 1987 Inmos Limited
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*{{{  Predefined routines defns. */

/********************
*   The order of these matters because there are tables built up
*   in the same order
*********************/

#define PD_LONGADD                    0
#define PD_LONGSUM                    1
#define PD_LONGSUB                    2
#define PD_LONGDIFF                   3
#define PD_LONGPROD                   4
#define PD_LONGDIV                    5
#define PD_SHIFTRIGHT                 6
#define PD_SHIFTLEFT                  7
#define PD_NORMALISE                  8
#define PD_FRACMUL                    9
#define PD_ASHIFTRIGHT                10
#define PD_ASHIFTLEFT                 11
#define PD_ROTATERIGHT                12
#define PD_ROTATELEFT                 13
#define PD_CAUSEERROR                 14
#define PD_KERNELRUN                  15
#define PD_LOADINPUTCHANNEL           16
#define PD_LOADOUTPUTCHANNEL          17
#define PD_LOADINPUTCHANNELVECTOR     18
#define PD_LOADOUTPUTCHANNELVECTOR    19
#define PD_LOADBYTEVECTOR             20
#define PD_UNPACKSN                   21
#define PD_ROUNDSN                    22
#define PD_DRAW2D                     23
#define PD_CLIP2D                     24
#define PD_MOVE2D                     25
#define PD_CRCWORD                    26
#define PD_CRCBYTE                    27
#define PD_BITCOUNT                   28
#define PD_BITREVWORD                 29
#define PD_BITREVNBITS                30
#define PD_ABS                        31
#define PD_ISNAN                      32
#define PD_NOTFINITE                  33
#define PD_ORDERED                    34
#define PD_MINUSX                     35
#define PD_MULBY2                     36
#define PD_DIVBY2                     37
#define PD_SQRT                       38
#define PD_FPINT                      39
#define PD_DABS                       40
#define PD_DISNAN                     41
#define PD_DNOTFINITE                 42
#define PD_DORDERED                   43
#define PD_DMINUSX                    44
#define PD_DMULBY2                    45
#define PD_DDIVBY2                    46
#define PD_DSQRT                      47
#define PD_DFPINT                     48
#define PD_SCALEB                     49
#define PD_DSCALEB                    50
#define PD_COPYSIGN                   51
#define PD_DCOPYSIGN                  52
#define PD_NEXTAFTER                  53
#define PD_DNEXTAFTER                 54
#define PD_LOGB                       55
#define PD_DLOGB                      56
#define PD_FLOATINGUNPACK             57
#define PD_DFLOATINGUNPACK            58
#define PD_ARGUMENTREDUCE             59
#define PD_DARGUMENTREDUCE            60
#define PD_REAL32OP                   61
#define PD_REAL64OP                   62
#define PD_IEEE32OP                   63
#define PD_IEEE64OP                   64
#define PD_REAL32REM                  65
#define PD_REAL64REM                  66
#define PD_REAL32EQ                   67
#define PD_REAL64EQ                   68
#define PD_REAL32GT                   69
#define PD_REAL64GT                   70
#define PD_IEEECOMPARE                71
#define PD_DIEEECOMPARE               72
#define PD_IEEE32REM                  73
#define PD_IEEE64REM                  74
#define PD_RESCHEDULE                 75
#define PD_ASSERT                     76 /* added 25/9/90 */
#define PD_WSSIZEOF                   77 /* bug TS/1797 18/08/92 */
#define PD_VSSIZEOF                   78 /* bug TS/1797 18/08/92 */
#define PD_UPDATE_PROFCOUNT           79 /* It is introduced and inlined by the
                                            compiler */
#define PD_IMS_GET_PDATA              80 /* bug TS/1039 05/02/93 */
/*}}}*/

/*{{{  Predefines for the configuration stuff */
/*{{{  Predefines for the configurer */
/* Validity flags: T=Txxx, H=T9000, C=C104, P=Partition,
                   U=Unknown, E=ControlPort, R=Route, S=Software
 */
#define PD_ATTR_LINK                 100 /* []EDGE     THCP.... */ /* NETWORK */
#define PD_ATTR_TYPE                 101 /* []BYTE     THCP.... */ /* NETWORK */
#define PD_ATTR_MEMSIZE              102 /* INT        T....... */ /* NETWORK */
#define PD_ATTR_ROMSIZE              103 /* INT        T....... */ /* NETWORK */
#define PD_ATTR_ROOT                 104 /* BOOL       TH...... */ /* NETWORK */

/* I have added 2 new entries for T450 attributes , memstart and num.links at the end of the list - NICK */

#define PD_ATTR_ORDER_CODE           105 /* INT        .......S */ /* MAPPING */
#define PD_ATTR_ORDER_VS             106 /* INT        .......S */ /* MAPPING */
#define PD_ATTR_LOCATION_CODE        107 /* INT        .......S */ /* MAPPING */
#define PD_ATTR_LOCATION_WS          108 /* INT        .......S */ /* MAPPING */
#define PD_ATTR_LOCATION_VS          109 /* INT        .......S */ /* MAPPING */
#define PD_ATTR_RESERVED             110 /* INT        T....... */ /* MAPPING */
#define PD_ATTR_TOLERANCE            111 /* INT        .......S */ /* MAPPING */ /* ONLY applicable to non-NDL configurer */
#define PD_ATTR_LINKQUOTA            112 /* INT        .......S */ /* MAPPING */ /* ONLY applicable to non-NDL configurer */
#define PD_ATTR_ROUTECOST            113 /* INT        .......S */ /* MAPPING */ /* ONLY applicable to non-NDL configurer */
#define PD_ATTR_ORDER_WS             114 /* INT        .......S */ /* MAPPING */
#define PD_ATTR_NODEBUG              115 /* BOOL       .......S */ /* MAPPING */
#define PD_ATTR_NOPROFILE            116 /* BOOL       .......S */ /* MAPPING */

/* The following are ONLY declared by the non-NDL configurer */

#define PD_HOSTEDGE                  118 /* EDGE       ........ */ /* Pre-declared EDGE (HOST) */
#define PD_DEFAULTNODE               119 /* NODE       ........ */ /* Pre-declared NODE (DEFAULT) */
/*}}}*/
/*{{{  Predefines for the NDL reader */
/* Validity flags: T=Txxx, H=T9000, C=C104, P=Partition,
                   U=Unknown, E=ControlPort, R=Route, S=Software, L=C100
 */
#define PD_ATTR_LINK_SPEED_MULTIPLY  120 /* INT        .HC.....L */ /* NETWORK */
#define PD_ATTR_LINK_SPEED_DIVIDE    121 /* []INT      .HC.....L */ /* NETWORK */
#define PD_ATTR_CONTROL_UP           122 /* EDGE       .HC.U...L */ /* NETWORK */
#define PD_ATTR_CONTROL_SPEED_DIVIDE 123 /* [2]INT     .HC.....L */ /* NETWORK */
#define PD_ATTR_MEMCONFIG            124 /* []BYTE     .H....... */ /* NETWORK */
#define PD_ATTR_PREAMBLE             125 /* []BYTE     .H....... */ /* NETWORK */
#define PD_ATTR_BOOTSTRAP            126 /* []BYTE     .H....... */ /* NETWORK */
#define PD_ATTR_MEMORY               127 /* [][3]INT   .H....... */ /* NETWORK */
#define PD_ATTR_CACHESIZE            128 /* INT        .H....... */ /* NETWORK */
#if 0
#define PD_ATTR_LINK_TXMODE          129 /* [4]BOOL    .H....... */ /* NETWORK */
#endif
#define PD_ATTR_LINK_BYTE_MODE       129 /* [4]BOOL    .H....... */ /* NETWORK */
#define PD_ATTR_EVENT_OUT            130 /* [4]BOOL    .H....... */ /* NETWORK */
#define PD_ATTR_LOCAL_ROM            131 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_SYSTEM_ROM           132 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_PMI_CONFIG_INROM     133 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_LINKSET_INROM        134 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_BOOTSTRAP_INROM      135 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_CACHE_CONFIG_INROM   136 /* BOOL       .H....... */ /* NETWORK */
#if 0
#define PD_ATTR_INTERVAL             136 /* [][2]INT   ..CP..... */ /* NETWORK */
#endif
#define PD_ATTR_LINK_SELECT          137 /* []INT      ..CP..... */ /* NETWORK */
#define PD_ATTR_DISCARD              138 /* []BOOL     ..CP..... */ /* NETWORK */
#define PD_ATTR_DELETE               139 /* []BOOL     ..CP..... */ /* NETWORK */
#define PD_ATTR_RANDOM               140 /* []BOOL     ..CP..... */ /* NETWORK */
#if 0
#define PD_ATTR_RANDOMSEED           141 /* INT        ..CP..... */ /* NETWORK */
#endif
#define PD_ATTR_RANDOM_INTERVAL      142 /* [2]INT     ..CP..... */ /* NETWORK */
#define PD_ATTR_NODE                 143 /* NODE       ...P..... */ /* NETWORK */
#define PD_ATTR_LINKS                144 /* [][2]INT   ...P..... */ /* NETWORK */
#define PD_ATTR_START_CODE           145 /* BYTE       ....U.... */ /* NETWORK */
#define PD_ATTR_IDENTIFY_CODE        146 /* BYTE       ....U.... */ /* NETWORK */
#define PD_ATTR_IDENTIFY_RESPONSE    147 /* BYTE       ....U.... */ /* NETWORK */
#define PD_ATTR_EXPECTED_IDENTITY    148 /* INT        ....U.... */ /* NETWORK */
#define PD_ATTR_ERROR_RESPONSE       149 /* BYTE       ....U.... */ /* NETWORK */
#define PD_ATTR_ERROR_HANDSHAKE      150 /* BYTE       ....U.... */ /* NETWORK */
#define PD_ATTR_INITIALISATION       151 /* []INT      ....U.... */ /* NETWORK */
#define PD_ATTR_DATA                 152 /* EDGE       .....E... */ /* NETWORK */
#define PD_ATTR_CONTROL              153 /* EDGE       .....E... */ /* NETWORK */
#define PD_ATTR_CONTROL_DOWN         154 /* EDGE       .HC.U...L */ /* NETWORK */
#define PD_ATTR_OUTWARD              155 /* ARC        ......R.. */ /* NETWORK */
#define PD_ATTR_RETURN               156 /* ARC        ......R.. */ /* NETWORK */
#define PD_ATTR_LINK_GROUPS          157 /* [][2]INT   ..C...... */ /* NETWORK */
#define PD_ATTR_INTERVAL_SEPARATOR   158 /* []INT      ..CP..... */ /* NETWORK */
#define PD_ATTR_ROM_FILE             159 /* []BYTE     TH....... */ /* NETWORK */
#define PD_ATTR_REBOOT_FROM_LINK     160 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_BOOT_FROM_ROM        161 /* BOOL       .H....... */ /* NETWORK */
#define PD_ATTR_MODE                 162 /* INT        ........L */ /* NETWORK */
#define PD_ATTR_DS_LINK              163 /* []EDGE     ........L */ /* NETWORK */
/*}}}*/
/*{{{  Further additions for the configurer and NDL reader added late for the T450 */
#define PD_ATTR_MEMSTART             164 /* INT        T....... */ /* NETWORK */
#define PD_ATTR_NUM_LINKS            165 /* INT        T....... */ /* NETWORK */
/*}}}*/
/*}}}*/

/*{{{  Pragma details */
typedef enum
  {
    pragma_name_translate,
    pragma_name_linkage,
    pragma_name_external,
    pragma_name_shared,
    pragma_name_comment,
    pragma_name_aliased,
    pragma_name_hardware,
    pragma_name_nestedtimer,
    pragma_name_nestedplace,
    pragma_name_nestedport,
    pragma_name_badlybehaved,
    pragma_name_assumeconst
  } pragma_name_tag_t;

/*}}}*/
