/*
 * KROC ALPHA translator - Input and output on channels
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/f_comm.c,v $
 *
 * $Id: f_comm.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * ALPHA target only.
 */

static char f_comm_c_rcsid[] = "$Id: f_comm.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

/*
 *  IN:
 *  --
 *   Ref: (T9000 ISM  Page 342)
 *
 *     ...synchronise, and input Areg bytes from channel Breg to address Creg
 *
 */
void IN ()
{       CALL_KRN(K_IN);
	istackp = 0;
	ishuff = 0;
}

/*
 *  OUT:
 *  ---
 *   Ref: (T9000 ISM  Page 395)
 *
 *     ...synchronise, and output Areg bytes to channel Breg from address Creg
 *     
 */
void OUT ()
{       CALL_KRN(K_OUT);
	istackp = 0;
	ishuff = 0;
}

/*
 *  OUTBYTE:
 *  -------
 *   Ref: (T9000 ISM  Page 396)
 *
 *     ...synchronise, and output least significant byte of Areg to channel Breg
 *     
 */
void OUTBYTE () 
{       shufflecount += shuffle (istackp, 2);   /* requires TWO items on stack */
	CALL_KRN(K_OUTBYTE);
	istackp = 0;
	ishuff = 0;
}

/*
 *  OUTWORD:
 *  -------
 *   Ref: (T9000 ISM  Page 397)
 *
 *     ...synchronise, and output Areg to channel Breg
 *     
 */
void OUTWORD ()
{       shufflecount += shuffle (istackp, 2);   /* requires TWO items on stack */
	CALL_KRN(K_OUTWORD);
	istackp = 0;
	ishuff = 0;
}
