/*
 * KROC ALPHA translator support for floating-point instructions
 *
 * $Source: /extra/play/cvs/kroc/src/target/alpha/float.c,v $
 *
 * $Id: float.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk> and 
 *                    P.H. Welch <P.H.Welch@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 */

static char float_c_rcsid[] = "$Id: float.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

const char *fname (r)		/* f.p. register name */
int r;
{	static const char *fnames[4] =
	{ "...", "$f0", "$f1", "$f2" };

	if (r < 1)
	{	fputs ("\n*** Floating stack underflow", stderr);
		error ();
	}
	if (r > 3)
	{	fputs ("\n*** floating stack overflow", stderr);
		error ();
	}
	return fnames[r];
}

void fround_modifier()
{
   switch(sround)
       {
       case R_N:  break;

       case R_Z:  posn += fprintf (out, "c"); comma=0; break;

       case R_P:  posn += fprintf (out, "d"); comma=0; break;

       case R_M:  posn += fprintf (out, "m"); comma=0; break;

       default:  break;
       }
}


void fmnem (op)			/* generate f.p. SPARC mnemonic */
const char *op;
{	mnem(op);
        fround_modifier();
        fround(R_N);
	comma = 0;
}

void fround (tround)		/* set f.p. rounding mode */
int tround;
{	static char rnm[5] = "NZPM";
	if (sround != tround)
	{
		if (o_verbose)
		{	fprintf (stderr, "\n... Floating-point rounding mode R%c to R%c",
				rnm[sround], rnm[tround]);
			where ();
		}
		sround = tround;
	}
}

void fscheck (s)
int s;
{	static const char *typename[2] =
	{	"REAL32", "REAL64" };
	int ss = FAtype;
	if (ss != s)
	{	fputs ("\n*** Inconsistent floating-point types\n", stderr);
		fprintf (stderr, "    %s : %s", typename[ss], typename[s]);
		error ();
	}
}
