/*
 * KROC translator - Input and output on channels
 *
 * $Source: /extra/play/cvs/kroc/src/target/arm/f_comm.c,v $
 *
 * $Id: f_comm.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * arm/f_arith.c:
 * (C) Copyright 1998 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 * Derived from alpha/f_arith.c:
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *   /u3/proj/kroc/develop/src/alpha/RCS/f_comm.c,v
 *   f_comm.c,v 1.9 1996/01/08 17:32:02 mdp2 Exp
 *
 */

static char f_comm_c_rcsid[] = "$Id: f_comm.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

/*
 *  IN:
 *  --
 *   Ref: (T9000 ISM  Page 342)
 *
 *     ...synchronise, and input Areg bytes from channel Breg to address Creg
 *
 */
void ArmIN ()
{
    CALL_KRN(K_IN);
    StackReset();
}

/*
 *  OUT:
 *  ---
 *   Ref: (T9000 ISM  Page 395)
 *
 *     ...synchronise, and output Areg bytes to channel Breg from address Creg
 *     
 */
void ArmOUT ()
{
    CALL_KRN(K_OUT);
    StackReset();
}

/*
 *  OUTBYTE:
 *  -------
 *   Ref: (T9000 ISM  Page 396)
 *
 *     ...synchronise, and output least significant byte of Areg to channel Breg
 *     
 */
void ArmOUTBYTE () 
{
    // shufflecount += shuffle (istackp, 2);   /* requires TWO items on stack */
    CALL_KRN(K_OUTBYTE);
    StackReset();
}

/*
 *  OUTWORD:
 *  -------
 *   Ref: (T9000 ISM  Page 397)
 *
 *     ...synchronise, and output Areg to channel Breg
 *     
 */
void ArmOUTWORD ()
{
    // shufflecount += shuffle (istackp, 2);   /* requires TWO items on stack */
    CALL_KRN(K_OUTWORD);
    StackReset();
}

