/*
 * KROC ARM translator - Instructions concerned with processes
 *
 * $Source: /extra/play/cvs/kroc/src/target/arm/f_proc.c,v $
 *
 * $Id: f_proc.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 *
 * arm/f_move2d.c:
 * (C) Copyright 1998 R. Ivimey-Cook <ruthc@sharra.demon.co.uk>
 *
 * Derived from alpha/f_move2d.c:
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *   /u3/proj/kroc/develop/src/alpha/RCS/f_proc.c,v
 *   f_proc.c,v 1.14 1996/11/06 17:15:06 mdp2 Exp
 * 
 */

static char f_proc_c_rcsid[] = "$Id: f_proc.c,v 1.1 1999/09/27 21:10:12 rivimey Exp $";

#include "octran.h"

/*
 *  ENDP:
 *  ----
 *   Ref: (T9000 ISM  Page 276)
 *
 *     word'[Areg @ pp.Count] <- word[Areg @ pp.Count] - 1
 *     if (word'[Areg @ pp.Count] = 0)
 *     {
 *       Iptr' <- word[Areg @ pp.Iptrsucc]
 *       Wptr' <- Areg
 *     }
 *     else
 *       ... start next process
 */
void ArmENDP ()
{
    /* word'[Areg @ pp.Count] <- word[Areg @ pp.Count] - 1 */
    op2("ldr", Temp0, indexByN(Areg, 1));
    op2("subs", Temp0, Temp0, immdec(1));
    op2("str", Temp0, indexByN(Areg, 1));
    
    /* if (word'[Areg @ pp.Count] = 0) */
    op2("beq", f(1));
    CALL_RTN("scheduler",  /* CALL_RTN("$scheduler") */
    lab(1);
    
    /*  Iptr' <- word[Areg @ pp.Iptrsucc] */
    /*  Wptr' <- Areg */
    op2("ldr", Temp0, indexByN(Areg, 0));
    op2("mov", Wptr, Areg);
    op2("mov", PCreg, Temp0, COMMENT("should combine with ldr above..."));
    
    istackp = 0;
    fstackp = 0;
    ishuff = 0;
    BREAK;
}

/*
 *  STARTP:
 *  ------
 *   Ref: (T9000 ISM  Page 418)
 *
 *     word'[Areg @ pw.Iptr] <- next .t instruction + Breg
 *     ... put process Areg onto the back of the queue.
 *     
 *     
 */
void ArmSTARTP ()
{
    /* word'[Areg @ pw.Iptr] <- next instruction + Breg */
    op2("adr", Temp0, f(4), COMMENT("get PC of next .t instruction"));
    lab(1), op3("add), Temp0, Temp0, Breg);
    op2("str", Temp0, indexByN(Areg, -1));

	/* ... put process Areg onto the back of the queue. */
    op2("ldr", Temp0, ldrcon(MOSTNEG_INT32));
    op2("cmp", FP, Temp0);
    op2("bne", f(2));
    op2("str", Areg, indexByN(Bptr, -2));
    op2("b",   f(3));
    lab(2), op2("mov", FP, Areg);
    lab(3), op2("mov", BP, Areg);
    lab(4);
    istackp = 0;
    fstackp = 0;
    ishuff = 0;
}

/*
 *  STOPP:
 *  -----
 *   Ref: (T9000 ISM  Page 425)
 *
 *      word'[Wptr @ pw.Iptr] <- next instruction
 *     
 *     
 *     
 */
void ArmSTOPP ()
{
    CALL_KRN(K_STOPP);
    istackp = 0;
    fstackp = 0;
    ishuff = 0;
}

/*
 *  STHF:
 *  ----
 *   Ref: (T800 ITT  Page 198)
 *
 *     HPBP' <- A
 *     Areg' <- B
 *     Breg' <- C
 *     
 */
void ArmSTHF ()
{
    unimp ();
/*  op2("mov", Areg, FP, */
    StackPop(1);
}

/*
 *  STLB:
 *  ----
 *   Ref: (T800 ITT  Page 201)
 *
 *     BP'   <- A
 *     Areg' <- B
 *     Breg' <- C
 *     
 */
void ArmSTLB ()
{
    op2("mov", BP, A;);
    StackPop(1);
}

/*
 *  STLF:
 *  ----
 *   Ref: (T800 ITT  Page 202)
 *
 *     FP'   <- A
 *     Areg' <- B
 *     Breg' <- C
 *
 */
void ArmSTLF ()
{
    op2("mov", FP, Areg);
    StackPop(1);
}

/*
 *  RUNP:
 *  ----
 *   Ref: (T9000 ISM  Page 407)
 *
 *     ... put process Areg onto back of process list
 *     
 *     
 *     
 */
void ArmRUNP ()
{
    /* ... put process Areg onto the back of the queue. */
    op2("bic", Areg, immdec(3), Areg);
    op2("mov", Temp0, immdec(MOSTNEG_INT32));
    op2("cmp", FP, Temp0);
    op2("bne", f(1));
    op2("str", Areg, indexByN(Bptr, -2));
    op2("b",   f(2));
    lab(1), op2("mov", FP, Areg);
    lab(2), op2("mov", BP, Areg);

    istackp = 0;
    fstackp = 0;
    ishuff = 0;
}

/*
 *  SAVEH:
 *  -----
 *   Ref: (T800 ITT  Page 189)
 *
 *     
 *     
 *     
 *     
 */
void ArmSAVEH ()
{
    unimp ();
/*      op2("stl", BP, indexByN(Areg, 1),   */
/*      op2("stl", FP, indexByN(Areg, 0),   */
}

/*
 *  SAVEL:
 *  -----
 *   Ref: (T800 ITT  Page 190)
 *
 *     word'[Areg @ 1]  <- lpBP
 *     word'[Areg @ 0]  <- lpFP
 *     A' <- B
 *     B' <- C
 *     
 */
void ArmSAVEL ()
{
    op2("str", BP, indexByN(Areg, 1));
    op2("str", FP, indexByN(Areg, 0));
}

/*
 *  STHB:
 *  ----
 *   Ref: (T800 ITT  Page 198)
 *
 *     
 *     
 *     
 *     
 */
void ArmSTHB ()
{
    unimp ();
/*  op2("mov", Areg, BP, */
    StackPop(1);
}
