/*
 * KROC translator: Function definitions and prototypes
 *
 * $Source: /extra/play/cvs/kroc/src/host/octran.h,v $
 *
 * $Id: octran.h,v 1.1 1999/09/27 21:10:12 rivimey Exp $
 *
 * (C) Copyright 2000 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * 	University of Kent at Canterbury
 * (C) Copyright 2000 R. Ivimey-Cook <ruth@ivimey.org>
 */

#ifndef TARGET_TRAN_H
#define TARGET_TRAN_H

/*      Transputer definitions.                 */

/*      Many depend on machine word size -      */
/*      32 bits (T800 etc.) or 16 bits (T200)   */

#define MostNeg         (1 << (BitsPerWord - 1))

#define ByteSelectMask  (BytesPerWord - 1)
					/* for inverting byte addresses */
#define ShortSelectMask (BytesPerWord - 2)
					/* for inverting short addresses */

/*      Offsets in local workspace      */

#define pw_Temp         0
#define pw_Iptr         (-1)
#define pw_Link         (-2)
#define pw_Pointer      (-3)
#define pw_State        (-3)
#define pw_TLink        (-4)
#define pw_Length       (-4)
#define pw_Time         (-5)

/*      Loop end data structure         */

#define le_Index        0
#define le_Count        1

/*      Parallel process data structure */

#define pp_IptrSucc     0
#define pp_Count        1

/*      Magic values                    */

#define Enabling_d      1               /* differences from MostNeg */
#define Waiting_d       2
#define Ready_d         3

#define TimeSet_d       1
#define TimeNotSet_d    2

#define NotProcess_p    MostNeg

#define Enabling_p      (MostNeg + Enabling_d)
#define Waiting_p       (MostNeg + Waiting_d)
#define Ready_p         (MostNeg + Ready_d)

#define TimeSet_p       (MostNeg + TimeSet_d)
#define TimeNotSet_p    (MostNeg + TimeNotSet_d)

#define NoneSelected_o  (-1)

#define LengthError_p   (-1)


#include "regs.h"

#endif /* TARGET_TRAN_H */

