/*
 * KROC SPARC debugging: Register dump.
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/cdump.c,v $
 *
 * $Id: cdump.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 *
 * Pseudo-directives .dump and .fdump generate calls to
 * $$dump and $$fdump, which in turn call these.
 *
 * The names (a, b, c, etc.) are only correct if the stack is full.
 */

static char cdump_c_rcsid[] = "$Id: cdump.c,v 1.1 1999/09/27 21:10:13 rivimey Exp $";

#include "rts.h"

void dump (n, iptr, wptr, a, b, c)		/* integer stack etc. */
int n, iptr, wptr, a, b, c;
{	static char name[4] = "ABC";
	fprintf (stderr, "Iptr = 0x%08x  Wptr = 0x%08x  ", iptr, wptr);
	switch (n)
	{
	case 3:
		fprintf (stderr, "%c = 0x%08x  ", name[n - 3], a);
	case 2:
		fprintf (stderr, "%c = 0x%08x  ", name[n - 2], b);
	case 1:
		fprintf (stderr, "%c = 0x%08x\n", name[n - 1], c);
		break;
	case 0:
		fputs ("(empty)\n", stderr);
	}
	fflush (stderr);
}

/*	Not enough registers to pass fa_p by value	*/
/*	Printed in big-endian order			*/

void fdump (code, fa_p, fb_h, fb_l, fc_h, fc_l)	/* floating-point stack */
int code, *fa_p, fb_l, fb_h, fc_l, fc_h;
{	static char name[4] = "ABC";
	int fa_h = fa_p[0];
	int fa_l = fa_p[1];
	int n = code & 3;	/* fstackp */
	code >>= 2;		/* ftypes */
	switch (n)
	{
	case 3:
		fprintf (stderr, "F%c = 0x%08x", name[n - 3], fa_h);
		if (code & 4)
			fprintf (stderr, ":0x%08x", fa_l);
		fputs ("  ", stderr);
	case 2:
		fprintf (stderr, "F%c = 0x%08x", name[n - 2], fb_h);
		if (code & 2)
			fprintf (stderr, ":0x%08x", fb_l);
		fputs ("  ", stderr);
	case 1:
		fprintf (stderr, "F%c = 0x%08x", name[n - 1], fc_h);
		if (code & 1)
			fprintf (stderr, ":0x%08x", fc_l);
		fputc ('\n', stderr);
		break;
	case 0:
		fputs ("(empty)\n", stderr);
	}
	fflush (stderr);
}
