!
! KRoC SPARC assembly-language initialization.
!
! $Source: /extra/play/cvs/kroc/src/target/sparc/occamentry.s,v $
!
! $Id: occamentry.s,v 1.1 1999/09/27 21:10:13 rivimey Exp $
!
! (C) Copyright 1996 D.C. Wood <D.C.Wood@ukc.ac.uk>
! University of Kent at Canterbury
!

#include "sched.h"

	.text
MAKENAME(occamentry_s_rcsid):
	.ascii	"$Id: occamentry.s,v 1.1 1999/09/27 21:10:13 rivimey Exp $\0"

! Set up constants in floating-point registers.
! Called in initialization.
! Also needed after calling floating-point C functions.

	.align	8			!  For "ldd"
					!  Floating-point constants
1:	.word	0x0,0x0			!  0.0 double and single
	.word	0x3fe00000,0x0		!  0.5		 8
	.word	0x41f00000,0x0		!  2^32		16
	.word	0x3df00000,0x0		!  2^(-32)	24
	.word	0x43300000,0x0		!  2^52		32
	.word	0x3f000000		!  0.5		40
	.word	0x4f800000		!  2^32		44
	.word	0x2f800000		!  2^(-32)	48
	.word	0x4b000000		!  2^23		52

	.global	MAKENAME(fpconst)
MAKENAME(fpconst):			!  Called from C ...
	.global	$$fpconst
$$fpconst:				!  ... and from occam
	set	1b,T0			!  Set up floating-point constants
	ldd	[T0+0],%f8		!  zero
	ldd	[T0+8],%f10		!  halfd
	ldd	[T0+16],%f12		!  two32d
	ldd	[T0+24],%f14		!  twom32d
	ldd	[T0+32],%f16		!  two52d
	ld	[T0+40],%f18		!  halfs
	ld	[T0+44],%f19		!  two32s
	ld	[T0+48],%f20		!  twom32s
	retl
	ld	[T0+52],%f21		!* two23s
!	------------------------

! Entry point from C.
!
! Use "$$space" generated by translator to allocate workspace on stack,
! and "$$fsr" to initialize the Floating-point State Register.
! Set up hard channels and vector space as pseudo-parameters.
! Initialize registers and enter occam program at label "$$entry".
! Return error flag to calling code.

	.global	MAKENAME(enter)
MAKENAME(enter):
	set	$$space,T0		!  Total space required
	save	%sp,T0,%sp		!  SPARC stack frame
	sub	%fp,Frame,Wptr		!  Fake Transputer stack frame
	set	variables,Vptr		!  Point to variables
	add	Vptr,kc,T0		!  stdin as pseudo-parameter
	st	T0,[Wptr+4]
	add	Vptr,sc,T0		!  stdout as pseudo-parameter
	st	T0,[Wptr+8]
	add	Vptr,ec,T0		!  stderr as pseudo-parameter
	st	T0,[Wptr+12]
	add	%sp,System,T0		!  System space
	st	T0,[Wptr+16]		!  Vector space as pseudo-parameter
	set	MostNeg,MIN		!  Used here and in user's program
	mov	MIN,Fptr
	mov	MIN,Bptr
	mov	MIN,Tptr

#ifdef VPTR

	ld	[Vptr],%fsr		!  Floating-point State Register

#else

	set	$$fsr,T0
	st	T0,[%fp+FPtemp]
	ld	[%fp+FPtemp],%fsr
	set	R_N<<30|TEM,T0		!  Floating-point rounding modes
	st	T0,[%fp+RN]
	set	R_Z<<30|TEM,T0
	st	T0,[%fp+RZ]
	set	R_P<<30|TEM,T0
	st	T0,[%fp+RP]
	set	R_M<<30|TEM,T0
	st	T0,[%fp+RM]
	set	AEXC,T0
	st	T0,[%fp+Aexc]		!  Accrued exceptions
	clr	[%fp+Zero]

#endif /* VPTR */

	call	$$fpconst		!  Floating-point constants
	clr	STATUS			!*
	sethi	%hi(MAKENAME(kroc_out)),T0
					!  stdout
	ld	[T0+%lo(MAKENAME(kroc_out))],T0
	st	T0,[Vptr+sw+Device]
	sethi	%hi(MAKENAME(kroc_err)),T0
					!  stderr
	ld	[T0+%lo(MAKENAME(kroc_err))],T0
	st	T0,[Vptr+ew+Device]
	call	$$entry			!  Run user's program
	st	L,[Wptr]		!*
	and	STATUS,1,%i0		!  Result
	ret
	restore				!*
!	------------------------
