/*
 * KROC SPARC translator: register, assembler and FPU definitions
 *
 * $Source: /extra/play/cvs/kroc/src/target/sparc/regs.h,v $
 *
 * $Id: regs.h,v 1.1 1999/09/27 21:10:13 rivimey Exp $
 *
 * (C) Copyright 1995 D.C. Wood <D.C.Wood@ukc.ac.uk>
 * University of Kent at Canterbury
 */

/*	Registers			*/

#define Areg		rgname(istackp)	/* Transputer evaluation stack */
#define Breg		rgname(istackp - 1)
#define Creg		rgname(istackp - 2)
#define Wptr		"%l3"		/* Workspace pointer */
#define Fptr		"%l4"		/* Front pointer */
#define Bptr		"%l5"		/* Back pointer */
#define Tptr		"%l6"		/* Timer pointer */
#define Vptr		"%l7"		/* Pointer to variables */
#define Temp		"%i0"		/* Temporary */
#define Fp		"%fp"		/* Frame pointer */

#define A		str(Areg)	/* Transputer registers */
#define B		str(Breg)
#define C		str(Creg)
#define W		str(Wptr)
#define FP		str(Fptr)
#define BP		str(Bptr)

#define P0		str("%o0")	/* Parameters/results for C functions */
#define P1		str("%o1")
#define P2		str("%o2")
#define P3		str("%o3")
#define P4		str("%o4")
#define P5		str("%o5")
#define L		str("%o7")
#define T0		str(Temp)	/* Temporaries */
#define T1		str("%i1")
#define T2		str("%i2")
#define T3		str("%i3")
#define MIN		str("%i4")
#define STATUS		str("%i5")	/* Error Flag etc. */
#define Z		str("%g0")	/* Source of all zeros */
#define G1		str("%g1")	/* For MOVE2D */
#define G2		str("%g2")
#define G3		str("%g3")
#define Y		str("%y")


/*	Assembler-dependent stuff	*/

#define CCHAR1		'!'		/* Line comment character */
#define CCHAR2		'!'		/* End of Line comment character */
#define CCHAR		'!'		/* Introduces comment */
#define DCCHAR		'!'		/* Introduces dummy opcodes */
#define HERE		"."		/* location counter */
#define LINEUP		32		/* output comment */
#define SCHEDNAME	"$$"		/* prefix for scheduler entries */
#ifdef HAVE_C_NO_LEADING_UNDERSCORE
#define CPREFIX		""		/* no prefix for C names */
#else
#define CPREFIX		"_"		/* prefix for C names */
#endif


#ifdef FLOAT

/*	Floating-point registers	*/

#define FAH		str(fname(fstackp, 0))
#define FAL		str(fname(fstackp, 1))
#define FBH		str(fname(fstackp - 1, 0))
#define FBL		str(fname(fstackp - 1, 1))
#define FCH		str(fname(fstackp - 2, 0))
#define FCL		str(fname(fstackp - 2, 1))

#define FTH		str("%f6")	/* temporary */
#define FTL		str("%f7")

#define ZERO		str("%f8")	/* useful constants */
#define HALFD		str("%f10")
#define TWO32D		str("%f12")
#define TWOM32D		str("%f14")
#define TWO52D		str("%f16")
#define HALFS		str("%f18")
#define TWO32S		str("%f19")
#define TWOM32S		str("%f20")
#define TWO23S		str("%f21")

/*	etc.?	*/

#define FSR		str("%fsr")

/*	Local stack frame		*/

#define	Aexc		(o_vptr ? vindex("fpaexc") : sindex(Fp, -8))
#define Zero		(o_vptr ? vindex("fpzero") : sindex(Fp, -7))
#define	Round(R)	(o_vptr ? vindex(rnm[R][1]) : sindex(Fp, (R) - 6))
					/* -5, -4, -3 */
#define FPtemp		(o_vptr ? vindex("fptemp") : sindex(Fp, -2))
#endif
