--
--	cod386.inc - intel instruction encodings and occam kernel entry points
--	Copyright (C) 1997 M.D. Poole
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

-- Copyright M D Poole 1997
DATA TYPE REG IS INT:
--{{{  DATA TYPES for 386 instructions
DATA TYPE OP386 IS INT:
DATA TYPE PREFIX IS BYTE:
DATA TYPE MDISP IS INT:
DATA TYPE BDISP IS INT:
--}}}  
--{{{  I86 condition flags
VAL INT CC.NONE     IS -1:

VAL INT CC.O        IS 0:
VAL INT CC.NO       IS 1:
VAL INT CC.B        IS 2:
VAL INT CC.C        IS 2:
VAL INT CC.AE       IS 3:
VAL INT CC.Z        IS 4:
VAL INT CC.E        IS 4:
VAL INT CC.NZ       IS 5:
VAL INT CC.NE       IS 5:
VAL INT CC.BE       IS 6:
VAL INT CC.A        IS 7:
VAL INT CC.S        IS 8:
VAL INT CC.NS       IS 9:
VAL INT CC.PE      IS 10:
VAL INT CC.PO      IS 11:
VAL INT CC.LT      IS 12:
VAL INT CC.GE      IS 13:
VAL INT CC.LE      IS 14:
VAL INT CC.GT      IS 15:

VAL INT CC.FPNAN    IS 10:
VAL INT CC.FPINFNAN IS 2:
VAL INT CC.FPORD    IS 11:

--}}}  
--{{{  register numbers
VAL REG REG.AX     IS 0:
VAL REG REG.CX     IS 1:
VAL REG REG.DX     IS 2:
VAL REG REG.BX     IS 3:
VAL REG REG.SP     IS 4:
VAL REG REG.BP     IS 5:
VAL REG REG.SI     IS 6:
VAL REG REG.DI     IS 7:
VAL REG REG.AL     IS 0:
VAL REG REG.CL     IS 1:
VAL REG REG.DL     IS 2:
VAL REG REG.BL     IS 3:
VAL REG REG.AH     IS 4:
VAL REG REG.CH     IS 5:
VAL REG REG.DH     IS 6:
VAL REG REG.BH     IS 7:
VAL REG REG.EAX     IS 0:
VAL REG REG.ECX     IS 1:
VAL REG REG.EDX     IS 2:
VAL REG REG.EBX     IS 3:
VAL REG REG.ESP     IS 4:
VAL REG REG.EBP     IS 5:
VAL REG REG.ESI     IS 6:
VAL REG REG.EDI     IS 7:
VAL REG REG.UNDEF   IS 8:
VAL REG REG.ACC     IS 0:
VAL REG REG.ES      IS 0:
VAL REG REG.CS      IS 1:
VAL REG REG.SS      IS 2:
VAL REG REG.DS      IS 3:

VAL REG REGW IS REG.EBP:
--}}}  
DATA TYPE PREFIX IS BYTE:
--{{{  prefixes
VAL PREFIX I86.REP   IS #F3:
VAL PREFIX I86.DS   IS #3E:
VAL PREFIX I86.ES   IS #26:
VAL PREFIX I86.FS   IS #64:
VAL PREFIX I86.GS   IS #65:
VAL PREFIX I86.OPSIZ   IS #66:
VAL PREFIX I86.ADRSIZ   IS #67:
--}}}  
--{{{  modifiers
VAL INT MOD.IND     IS #00:
VAL INT MOD.D8      IS #40:
VAL INT MOD.D32     IS #80:
VAL INT MOD.D16     IS #80:
VAL INT MOD.REG     IS #C0:
VAL INT RM.SIB      IS #04:
VAL INT SIB.NOINDEX IS #20:
VAL INT SIB.SCALE1  IS #00:
VAL INT SIB.SCALE2  IS #40:
VAL INT SIB.SCALE4  IS #80:
VAL INT SIB.SCALE8  IS #C0:
VAL INT WNB.WORD       IS #1:
VAL INT DIR.TOREG      IS #2:
VAL INT SIG.EXT        IS #2:
VAL INT OP.IMM         IS #4:
VAL INT MF.R32         IS #0:
VAL INT MF.I32         IS #2:
VAL INT MF.R64         IS #4:
VAL INT MF.I16         IS #6:
VAL INT I87.TNAN       IS #2:
VAL INT I87.TINF       IS #6:
VAL INT I87.TORD       IS #10:
VAL INT RM.BX.SI       IS 0:
VAL INT RM.BX.DI       IS 1:
VAL INT RM.BP.SI       IS 2:
VAL INT RM.BP.DI       IS 3:
VAL INT RM.SI          IS #4:
VAL INT RM.DI          IS #5:
VAL INT RM.BP          IS #6:
VAL INT RM.IMM         IS #6:
VAL INT RM.BX          IS #7:
--}}}  
--{{{  VALs for 386 opcodes
VAL OP386 I86.ADD   IS #00:
VAL OP386 I86.ADDMEM   IS #8100:
VAL OP386 I86.OR    IS #08:
VAL OP386 I86.ORMEM   IS #8108:
VAL OP386 I86.ADC   IS #10:
VAL OP386 I86.SBB   IS #18:
VAL OP386 I86.AND   IS #20:
VAL OP386 I86.ANDMEM   IS #8120:
VAL OP386 I86.SUB   IS #28:
VAL OP386 I86.SUBMEM   IS #8128:
VAL OP386 I86.XOR   IS #30:
VAL OP386 I86.XORMEM   IS #8130:
VAL OP386 I86.CMP   IS #38:
VAL OP386 I86.CMPMEM IS #8138:
VAL OP386 I86.CMPACC IS #3C:
VAL OP386 I86.CMPEAX IS #3D:
VAL OP386 I86.CMPR32I8 IS #83F8:
VAL OP386 I86.CALL  IS #E8:
VAL OP386 I86.CWDE  IS #98:
VAL OP386 I86.CDQ   IS #99:
VAL OP386 I86.SAHF  IS #9E:
VAL OP386 I86.MUL   IS #F720:
VAL OP386 I86.IMUL  IS #F728:
VAL OP386 I86.DIV   IS #F730:
VAL OP386 I86.IDIV  IS #F738:
VAL OP386 I86.IMULRR IS #0FAF:
VAL OP386 I86.IMULRRI IS #6B:
VAL OP386 I86.NOT   IS #F610:
VAL OP386 I86.LOOP  IS #E2:
VAL OP386 I86.J8    IS #EB:
VAL OP386 I86.J32   IS #E9:
VAL OP386 I86.Jcc8  IS #70:
VAL OP386 I86.Jcc32 IS #0F80:
VAL OP386 I86.SETcc IS #0F90:
VAL OP386 I86.INT3  IS #CC:
VAL OP386 I86.INTO  IS #CE:
VAL OP386 I86.MOV   IS #88:
VAL OP386 I86.MOVMEM  IS #8B:
VAL OP386 I86.MOVIMMS IS #B8:
VAL OP386 I86.MOVIMMB IS #B0:
VAL OP386 I86.MOVIMML IS #C6:
VAL OP386 I86.MOVSG   IS #8C:
VAL OP386 I86.LEA     IS #8D:
VAL OP386 I86.PUSHREG IS #50:
VAL OP386 I86.PUSHMEM IS #FF30:
VAL OP386 I86.INCMEM  IS #FF00:
VAL OP386 I86.DECMEM  IS #FF08:
VAL OP386 I86.INCREG  IS #40:
VAL OP386 I86.DECREG  IS #48:
VAL OP386 I86.INCREG8  IS #FE00:
VAL OP386 I86.CALLIND IS #FF10:
VAL OP386 I86.JIND    IS #FF20:
VAL OP386 I86.PUSHIMM IS #68:
VAL OP386 I86.POPREG  IS #58:
VAL OP386 I86.POPMEM  IS #8F00:
VAL OP386 I86.RET     IS #C3:
VAL OP386 I86.SHLREG  IS #D220:
VAL OP386 I86.SHRREG  IS #D228:
VAL OP386 I86.SHLIMM  IS #C020:
VAL OP386 I86.SHRIMM  IS #C028:
VAL OP386 I86.TEST    IS #A9:
VAL OP386 I86.SHL1    IS #D020:
VAL OP386 I86.RCL1    IS #D010:
VAL OP386 I86.SHR1    IS #D028:
VAL OP386 I86.RCR1    IS #D018:
VAL OP386 I86.SHLDREG  IS #0FA5:
VAL OP386 I86.SHRDREG  IS #0FAD:
VAL OP386 I86.SHLDIMM  IS #0FA4:
VAL OP386 I86.SHRDIMM  IS #0FAC:
VAL OP386 I86.XCHG    IS #86:
VAL OP386 I86.XCHGACC IS #90:
VAL OP386 I86.MOVZX   IS #0FB6:
VAL OP386 I86.MOVSX   IS #0FBE:
VAL OP386 I86.MOVSB   IS #A4:
VAL OP386 I86.GRP1    IS #80:
VAL OP386 I86.NOP     IS #90:
VAL OP386 I86.WAIT    IS #9B:
VAL OP386 I87.ESC     IS #D8:
VAL OP386 I86.FINIT   IS #DBE3:
VAL OP386 I86.FCOMPP  IS #DED9:
VAL OP386 I86.FUCOM   IS #DDE1:
VAL OP386 I86.FUCOMPP IS #DAE9:
VAL OP386 I86.FSTCW   IS #D938:
VAL OP386 I86.FLDCW   IS #D928:
VAL OP386 I86.FSTSWAX IS #DFE0:
VAL OP386 I86.FDECSTP IS #D9F6:
VAL OP386 I86.FINCSTP IS #D9F7:
VAL OP386 I86.FILD16  IS #DF00:
VAL OP386 I86.FILD32  IS #DB00:
VAL OP386 I86.FILD64  IS #DF00:
VAL OP386 I86.FRND    IS #DDD0:
VAL OP386 I86.FPOP    IS #DDD8:
VAL OP386 I86.FREVPOP IS #DDD9:
VAL OP386 I86.FDUP    IS #D9C0:
VAL OP386 I86.FLDZ    IS #D9EE:
VAL OP386 I86.FLD1    IS #D9E8:
VAL OP386 I86.FCHS    IS #D9E0:
VAL OP386 I86.FXCH    IS #D9C9:
VAL OP386 I86.FPREM1  IS #D9F5:
VAL OP386 I86.FSCALE  IS #D9FD:
VAL OP386 I86.FABS    IS #D9E1:
VAL OP386 I86.FSQRT   IS #D9FA:
VAL OP386 I86.FRNDINT IS #D9FC:
VAL OP386 I86.FTST    IS #D9E4:
VAL OP386 I86.FXAM    IS #D9E5:
VAL OP386 I86.FADDP   IS #DEC1:
VAL OP386 I86.FSUBP   IS #DEE9:
VAL OP386 I86.FMULP   IS #DEC9:
VAL OP386 I86.FDIVP   IS #DEF9:
--}}}  
--{{{  extra instruction codes
VAL I87.FILD64 IS #CB: -- value not used by transputer! needed by gen12
VAL I87.FPOP   IS #CE: -- value not used by transputer! needed by gen8
--}}}  
--{{{  pseudo-transputer instructions (used in old PC occam)
VAL I.CJI86      IS (17*16):
VAL I.CMPLE      IS (18*16):
VAL I.CMPNE      IS (19*16):
VAL I.CMPEQ      IS (20*16):
VAL I.CWD        IS (21*16):
VAL I.BNOT       IS (22*16):
VAL I.CMPI86     IS (23*16):
VAL I.LOOP       IS (24*16):
--}}}  
VAL [4]REG reg.abcd IS [REG.EAX, REG.EBX, REG.ECX, REG.EDX]:
--{{{  kernel entries (386 sched.s version)
-- code segment address of kernel jump table
VAL INT K.IN        IS 1:
VAL INT K.OUT       IS 2:
VAL INT K.OUTWORD   IS 3:
VAL INT K.OUTBYTE   IS 4:
VAL INT K.RUNP      IS 5:
VAL INT K.STARTP    IS 6:
VAL INT K.ENDP      IS 7:
VAL INT K.STOPP     IS 8:
VAL INT K.PAUSE     IS 9:
VAL INT K.LDTIMER   IS 10:
VAL INT K.TIN       IS 11:
VAL INT K.ALTWT     IS 12:
VAL INT K.TALTWT    IS 13:
VAL INT K.ENBC      IS 14:
VAL INT K.ENBT      IS 15:
VAL INT K.DISS      IS 16:
VAL INT K.DISC      IS 17:
VAL INT K.DIST      IS 18:
VAL INT K.RANGERR   IS 19:
VAL INT K.SETERR    IS 20:
VAL INT K.NORM      IS 21:
VAL INT K.UNPACKSN  IS 22:
VAL INT K.POSTNORMSN IS 23:
VAL INT K.ROUNDSN   IS 24:

VAL INT K.SAVEL     IS 25:
VAL INT K.STLB      IS 26:
VAL INT K.STLF      IS 27:
VAL INT K.OVERFLOW  IS 28:
VAL INT K.TRAP      IS 29:
VAL INT K.BRANGERR  IS 30:
VAL INT K.BSETERR   IS 31:

--{{{  These need a special calling sequence..
VAL INT KL.ZERODIV  IS 36:
--}}}  

VAL [][12]BYTE kentry.names IS ["            ",
                                "in          ",
                                "out         ",
                                "outword     ",
                                "outbyte     ",
                                "runp        ",
                                "startp      ",
                                "endp        ",
                                "stopp       ",
                                "pause       ",
                                "ldtimer     ",
                                "tin         ",
                                "altwt       ",
                                "taltwt      ",
                                "enbc        ",
                                "enbt        ",
                                "diss        ",
                                "disc        ",
                                "dist        ",
                                "rangerr     ",
                                "seterr      ",
                                "norm        ",
                                "unpacksn    ",
                                "postnormsn  ",
                                "roundsn     ",
                                "savel       ",
                                "stlb        ",
                                "stlf        ",
                                "overflow    ",
                                "trap        ",
                                "brangerr    ",
                                "bseterr     ",
                                "b.dispatch  ",
                                "bx.dispatch ",
                                "res.release ",
                                "res.claim   ",
                                "zerodiv     "]:
--}}}  


