#
#	Makefile
#	for compiling tranpc
#

CC = gcc
CFLAGS = -Wall
OC = kroc
OFLAGS = -v -c -d
OUTPUT = tranpc
OBJ = dis386.o elf386.o dis386at.o readtce.o tcoff386.o etcdump.o tranetcp.o optimiser.o
LIBS = -lhostio -lstring -lconvert

default:
			${MAKE} ${OUTPUT}

clean:
			rm -f *.o *.tce


${OUTPUT}:		${OBJ} tranpc.occ
			${OC} -v --octran-opts=-w -d tranpc ${OBJ} ${LIBS} -o ${OUTPUT}

static_${OUTPUT}:	${OBJ} tranpc.occ
			${OC} -v --cc-opts -static --octran-opts -w -d tranpc ${OBJ} ${LIBS} -o ${OUTPUT}

dis386.o:		dis386.occ
			${OC} ${OFLAGS} dis386

elf386.o:		elf386.occ
			${OC} ${OFLAGS} elf386

dis386at.o:		dis386at.occ
			${OC} ${OFLAGS} dis386at

readtce.o:		readtce.occ
			${OC} ${OFLAGS} readtce

tcoff386.o:		tcoff386.occ
			${OC} ${OFLAGS} tcoff386

tranetcp.o:		tranetcp.occ
			${OC} ${OFLAGS} tranetcp

etcdump.o:		etcdump.occ
			${OC} ${OFLAGS} etcdump

optimiser.o:		optimiser.occ
			${OC} ${OFLAGS} optimiser

