--
--	trancomm.inc - values, types and protocols for asm-to-asm translator independant of target
--	Copyright (C) 1997  M.D. Poole
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

-- values, types and protocols for asm-to-asm translator independent of target

VAL F.S IS 0:                -- single length = REAL32
VAL F.D IS 1:                -- double length = REAL64
--{{{  PROTOCOL ETC.INST
DATA TYPE T.OP IS INT:
PROTOCOL ETC.INST IS T.OP; INT:
--}}}  
--{{{  PROTOCOL TCOFF
PROTOCOL TCOFF IS INT; INT::[]BYTE:
--}}}  
--{{{  binary operators
DATA TYPE OP IS INT:
VAL OP OP.ADD IS 0:
VAL OP OP.SUB IS 1:
VAL OP OP.MUL IS 2:
VAL OP OP.DIV IS 3:
VAL OP OP.AND IS 4:
VAL OP OP.OR IS 5:
VAL OP OP.XOR IS 6:
VAL OP OP.EQV IS 7:
VAL OP OP.SRA IS 8:
VAL OP OP.SRL IS 9:
VAL OP OP.SLL IS 10:
VAL OP OP.PLUS IS 12:
VAL OP OP.MINUS IS 13:
VAL OP OP.TIMES IS 14:
VAL OP OP.REM IS 15:
VAL OP OP.EQ IS 16:
VAL OP OP.GT IS 17:
VAL OP OP.LT IS 18:
VAL OP OP.FEQ IS 19:
VAL OP OP.FGT IS 20:
--}}}  
--{{{  definition of ETC specials
-- These are introduced by OPR instructions with negative prefixes
-- 6D F0 flags a following J, CJ or CALL to have numeric label operand
--          or 2 LDCs with operands L1, L2 to signify LDC L1-L2
-- 6D F1 flags a following LDLP to introduce a pair of LOOPEND labels
--          [end, top] encoded in LDC instructions. LDLP defines control block.
-- 6E F1 flags a following LDC to be a name length followed by that number
--       of bytes as a STUBNAME for calling a #USE'd PROC
-- 6E F2 flags a following LDC to be a name length followed by that number
--       of bytes as a GLOBNAME for making a PROC name exportable
-- 6E F3 flags a following LDC to be a name length followed by that number
--       of bytes as a JUMPENTRY name for a jump to that entrypoint
-- 6E F4 flags a following LDC to be a name length followed by that number
--       of bytes as the name of a PROC/FUNCTION being entered
-- 6E F5 flags a following LDC to be a name length followed by that number
--       of bytes as the name of a source file
-- 6E F8 flags a following LDC to be for a data length followed by that number
--       of data bytes
-- 6F F0 flags a following LDC to define a magic message number
-- 6F F1 flags a following LDC to define a TSDEPTH
-- 6F F2 flags a following LDC to define FUNCRESULTS expected in registers
-- 6F F3 flags a following LDC to define FUNCRETURN with register results
-- 6F F4 flags a following LDC to define ENDWS increment
-- 6F F5 flags a following LDC to define REALRESULT (s,d)
-- 6F F6 flags a following LDC to define SETLAB label number setting
-- 6F F7 flags a following LDC to define SECTIONLAB label number setting
-- 6F F8 flags a following LDC to define ALIGN requirement
-- 6F F9 flags a following LDC to define a source line number
-- 6F FA flags a following LDC to define a DEBUGLINE reference
-- 6F FB flags a following LDC to define SETWS workspace size
-- 6F FC flags a following LDC to define SETVS vectorspace size
-- 6F FD flags a following LDC as right operand of a SLL operation
-- 6F FE flags a following LDC as right operand of a SRL operation

VAL INT ETC0 IS #FFFFFF00:
VAL INT ETC1 IS #FFFFFF01:
VAL INT ETC2 IS #FFFFFF02:
VAL INT ETC3 IS #FFFFFF03:
VAL INT ETC4 IS #FFFFFF04:
VAL INT ETC5 IS #FFFFFF05:
VAL INT ETC6 IS #FFFFFF06:
VAL INT ETC7 IS #FFFFFF07:
VAL INT ETC8 IS #FFFFFF08:
VAL INT ETC9 IS #FFFFFF09:
VAL INT ETC10 IS  #FFFFFF0A:
VAL INT ETC11 IS  #FFFFFF0B:
VAL INT ETC12 IS  #FFFFFF0C:
VAL INT ETC13 IS  #FFFFFF0D:
VAL INT ETC14 IS  #FFFFFF0E:
VAL INT ETC15 IS  #FFFFFF0F:
VAL INT ETCS1 IS  #FFFFFF11:
VAL INT ETCS2 IS  #FFFFFF12:
VAL INT ETCS3 IS  #FFFFFF13:
VAL INT ETCS4 IS  #FFFFFF14:
VAL INT ETCS5 IS  #FFFFFF15:
VAL INT ETCS8 IS  #FFFFFF18:
VAL INT ETCS9 IS  #FFFFFF19:
VAL INT ETCL0 IS  #FFFFFF20:
VAL INT ETCL1 IS  #FFFFFF21:
VAL INT ETC.MAX IS #FFFFFF30:  -- no transputer instruction > ETC.MAX

VAL INT TSDEPTH IS 1:
VAL INT FUNCRESULTS IS 2:
VAL INT FUNCRETURN IS 3:
VAL INT ENDWS IS 4:
VAL INT REALRESULT IS 5:
VAL INT SETLAB IS 6:
VAL INT SECTIONLAB IS 7:
VAL INT ALIGN IS 8:
VAL INT LINENUM IS 9:
VAL INT DEBUGLINE IS 10:
VAL INT SETWS IS 11:
VAL INT SETVS IS 12:
VAL INT SLLIMM IS 13:
VAL INT SRLIMM IS 14:
VAL INT LOOPHEADTOP IS 15:

VAL INT STUBNAME IS 64:
VAL INT GLOBNAME IS 65:
VAL INT JUMPENTRY IS 66:
VAL INT PROCNAME IS 67:
VAL INT SOURCEFILE IS 68:

VAL INT BOOLINVERT IS 1:
VAL INT STARTTABLE IS 2:
VAL INT WIDENSHORT IS 3:
VAL INT LOOPHEADBOT IS 4:
VAL INT CONTRSPLIT IS 5:
VAL INT CONTRJOIN IS 6:
VAL INT I64TOREAL IS 7:
VAL INT NOTPROCESS IS 8:
VAL INT FPPOP IS 9:

VAL INT finish.op IS -1:
--}}}  
--{{{  program sizing constants
VAL MAX.LABELS IS 10000:
VAL MAX.ID.SIZE IS 255:
VAL MAX.MESSAGE.SIZE IS 80:
VAL MAX.CONSTDATA.SIZE IS 256:          -- packetised in code1e
--}}}  
