--
--	transput.inc - transputer constants
--	Copyright (C) 1997  M.D. Poole
--
--	This program is free software; you can redistribute it and/or modify
--	it under the terms of the GNU General Public License as published by
--	the Free Software Foundation; either version 2 of the License, or
--	(at your option) any later version.
--
--	This program is distributed in the hope that it will be useful,
--	but WITHOUT ANY WARRANTY; without even the implied warranty of
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--	GNU General Public License for more details.
--
--	You should have received a copy of the GNU General Public License
--	along with this program; if not, write to the Free Software
--	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--

--{{{  transputer constants
--{{{  bytes per word etc
VAL INT WSH IS 2: -- shift to make byte address from wspace unit size
VAL INT BytesPerWord IS 1<<WSH:
VAL INT BitsPerWord IS BytesPerWord*8:
VAL INT ByteSelectMask IS ~((-1)<<WSH):
--}}}  
--{{{  primary instructions 
VAL T.OP I.J       IS #0:
VAL T.OP I.LDLP    IS #1:
VAL T.OP I.PFIX    IS #2:
VAL T.OP I.LDNL    IS #3:
VAL T.OP I.LDC     IS #4:
VAL T.OP I.LDNLP   IS #5:
VAL T.OP I.NFIX    IS #6:
VAL T.OP I.LDL     IS #7:
VAL T.OP I.ADC     IS #8:
VAL T.OP I.CALL    IS #9:
VAL T.OP I.CJ      IS #A:
VAL T.OP I.AJW     IS #B:
VAL T.OP I.EQC     IS #C:
VAL T.OP I.STL     IS #D:
VAL T.OP I.STNL    IS #E:
VAL T.OP I.OPR     IS #F:
--}}}  
--{{{  secondary.instructions
--{{{  0x 
VAL INT I.REV         IS #00:
VAL INT I.LB          IS #01:
VAL INT I.BSUB        IS #02:
VAL INT I.ENDP        IS #03:
VAL INT I.DIFF        IS #04:
VAL INT I.ADD         IS #05:
VAL INT I.GCALL       IS #06:
VAL INT I.IN          IS #07:
VAL INT I.PROD        IS #08:
VAL INT I.GT          IS #09:
VAL INT I.WSUB        IS #0A:
VAL INT I.OUT         IS #0B:
VAL INT I.SUB         IS #0C:
VAL INT I.STARTP      IS #0D:
VAL INT I.OUTBYTE     IS #0E:
VAL INT I.OUTWORD     IS #0F:

--}}}  
--{{{  1x 
VAL INT I.SETERR      IS #10:
VAL INT I.RESETCH     IS #12:
VAL INT I.CSUB0       IS #13:
VAL INT I.STOPP       IS #15:
VAL INT I.LADD        IS #16:
VAL INT I.STLB        IS #17:
VAL INT I.STHF        IS #18:
VAL INT I.NORM        IS #19:
VAL INT I.LDIV        IS #1A:
VAL INT I.LDPI        IS #1B:
VAL INT I.STLF        IS #1C:
VAL INT I.XDBLE       IS #1D:
VAL INT I.LDPRI       IS #1E:
VAL INT I.REM         IS #1F:

--}}}  
--{{{  2x 
VAL INT I.RET         IS #20:
VAL INT I.LEND        IS #21:
VAL INT I.LDTIMER     IS #22:
VAL INT I.TESTLDS     IS #23:
VAL INT I.TESTLDE     IS #24:
VAL INT I.TESTLDD     IS #25:
VAL INT I.TESTSTS     IS #26:
VAL INT I.TESTSTE     IS #27:
VAL INT I.TESTSTD     IS #28:
VAL INT I.TESTERR     IS #29:
VAL INT I.TESTPRANAL  IS #2A:
VAL INT I.TIN         IS #2B:
VAL INT I.DIV         IS #2C:
VAL INT I.TESTHARDCHAN IS #2D:
VAL INT I.DIST        IS #2E:
VAL INT I.DISC        IS #2F:

--}}}  
--{{{  3x 
VAL INT I.DISS        IS #30:
VAL INT I.LMUL        IS #31:
VAL INT I.NOT         IS #32:
VAL INT I.XOR         IS #33:
VAL INT I.BCNT        IS #34:
VAL INT I.LSHR        IS #35:
VAL INT I.LSHL        IS #36:
VAL INT I.LSUM        IS #37:
VAL INT I.LSUB        IS #38:
VAL INT I.RUNP        IS #39:
VAL INT I.XWORD       IS #3A:
VAL INT I.SB          IS #3B:
VAL INT I.GAJW        IS #3C:
VAL INT I.SAVEL       IS #3D:
VAL INT I.SAVEH       IS #3E:
VAL INT I.WCNT        IS #3F:

--}}}  
--{{{  4x 
VAL INT I.SHR         IS #40:
VAL INT I.SHL         IS #41:
VAL INT I.MINT        IS #42:
VAL INT I.ALT         IS #43:
VAL INT I.ALTWT       IS #44:
VAL INT I.ALTEND      IS #45:
VAL INT I.AND         IS #46:
VAL INT I.ENBT        IS #47:
VAL INT I.ENBC        IS #48:
VAL INT I.ENBS        IS #49:
VAL INT I.MOVE        IS #4A:
VAL INT I.OR          IS #4B:
VAL INT I.CSNGL       IS #4C:
VAL INT I.CCNT1       IS #4D:
VAL INT I.TALT        IS #4E:
VAL INT I.LDIFF       IS #4F:

--}}}  
--{{{  5x 
VAL INT I.STHB        IS #50:
VAL INT I.TALTWT      IS #51:
VAL INT I.SUM         IS #52:
VAL INT I.MUL         IS #53:
VAL INT I.STTIMER     IS #54:
VAL INT I.STOPERR     IS #55:
VAL INT I.CWORD       IS #56:
VAL INT I.CLRHALTERR  IS #57:
VAL INT I.SETHALTERR  IS #58:
VAL INT I.TESTHALTERR IS #59:
VAL INT I.DUP         IS #5A:
VAL INT I.MOVE2DINIT  IS #5B:
VAL INT I.MOVE2DALL   IS #5C:
VAL INT I.MOVE2DNONZERO IS #5D:
VAL INT I.MOVE2DZERO  IS #5E:
VAL INT I.GTU         IS #5F:

--}}}  
--{{{  6x 
VAL INT I.UNPACKSN    IS #63:
VAL INT I.SLMUL       IS #64:
VAL INT I.SULMUL      IS #65:
VAL INT I.SATADD      IS #68:
VAL INT I.SATSUB      IS #69:
VAL INT I.SATMUL      IS #6A:
VAL INT I.POSTNORMSN  IS #6C:
VAL INT I.ROUNDSN     IS #6D:
VAL INT I.LDTRAPH     IS #6E:
VAL INT I.STTRAPH     IS #6F:

--}}}  
--{{{  7x 
VAL INT I.LDINF       IS #71:
VAL INT I.FMUL        IS #72:
VAL INT I.CFLERR      IS #73:
VAL INT I.CRCWORD     IS #74:
VAL INT I.CRCBYTE     IS #75:
VAL INT I.BITCNT      IS #76:
VAL INT I.BITREVWORD  IS #77:
VAL INT I.BITREVNBITS IS #78:
VAL INT I.POP          IS #79:
VAL INT I.TIMERDISABLEH IS #7A:
VAL INT I.TIMERDISABLEL IS #7B:
VAL INT I.TIMERENABLEH  IS #7C:
VAL INT I.TIMERENABLEL  IS #7D:
VAL INT I.LDMEMSTARTVAL IS #7E:

--}}}  IS #:
--{{{  8x 
VAL INT I.FPSTTEST    IS #80:
VAL INT I.WSUBDB      IS #81:
VAL INT I.FPLDNLDBI   IS #82:
VAL INT I.FPCHKERR    IS #83:
VAL INT I.FPSTNLDB    IS #84:
VAL INT I.FPLDTEST    IS #85:
VAL INT I.FPLDNLSNI   IS #86:
VAL INT I.FPADD       IS #87:
VAL INT I.FPSTNLSN    IS #88:
VAL INT I.FPSUB       IS #89:
VAL INT I.FPLDNLDB    IS #8A:
VAL INT I.FPMUL       IS #8B:
VAL INT I.FPDIV       IS #8C:
VAL INT I.FPRANGE     IS #8D:
VAL INT I.FPLDNLSN    IS #8E:
VAL INT I.FPREMFIRST  IS #8F:

--}}}  
--{{{  9x 
VAL INT I.FPREMSTEP   IS #90:
VAL INT I.FPNAN       IS #91:
VAL INT I.FPORDERED   IS #92:
VAL INT I.FPNOTFINITE IS #93:
VAL INT I.FPGT        IS #94:
VAL INT I.FPEQ        IS #95:
VAL INT I.FPI32TOR32  IS #96:
VAL INT I.FPGE        IS #97:
VAL INT I.FPI32TOR64  IS #98:
VAL INT I.FPB32TOR64  IS #9A:
VAL INT I.FPLG        IS #9B:
VAL INT I.FPTESTERR   IS #9C:
VAL INT I.FPRTOI32    IS #9D:
VAL INT I.FPSTNLI32   IS #9E:
VAL INT I.FPLDZEROSN  IS #9F:

--}}}  
--{{{  Ax 
VAL INT I.FPLDZERODB  IS #A0:
VAL INT I.FPINT       IS #A1:
VAL INT I.FPDUP       IS #A3:
VAL INT I.FPREV       IS #A4:
VAL INT I.FPLDNLADDDB IS #A6:
VAL INT I.FPENTRY3    IS #A7:
VAL INT I.FPLDNLMULDB IS #A8:
VAL INT I.FPENTRY2    IS #A9:
VAL INT I.FPLDNLADDSN IS #AA:
VAL INT I.FPENTRY     IS #AB:
VAL INT I.FPLDNLMULSN IS #AC:

--}}}  
--{{{  Bx 
VAL INT I.SETTIMESLICE IS #B0:
VAL INT I.BREAK       IS #B1:
VAL INT I.CLRJ0BREAK  IS #B2:
VAL INT I.SETJ0BREAK  IS #B3:
VAL INT I.TESTJ0BREAK IS #B4:
VAL INT I.LDFLAGS     IS #B6:
VAL INT I.STFLAGS     IS #B7:
VAL INT I.XBWORD      IS #B8:
VAL INT I.LBX         IS #B9:
VAL INT I.CB          IS #BA:
VAL INT I.CBU         IS #BB:
VAL INT I.INSPHDR     IS #BC:
VAL INT I.READBFR     IS #BD:
VAL INT I.LDCONF      IS #BE:
VAL INT I.STCONF      IS #BF:

--}}}  
--{{{  Cx 
VAL INT I.LDCNT       IS #C0:
VAL INT I.SSUB        IS #C1:
VAL INT I.LDTH        IS #C2:
VAL INT I.LDCHSTATUS  IS #C3:
VAL INT I.INTDIS      IS #C4:
VAL INT I.INTENB      IS #C5:
VAL INT I.LDTRAPPED   IS #C6:
VAL INT I.CIR         IS #C7:
VAL INT I.SS          IS #C8:
VAL INT I.CHANTYPE    IS #C9:
VAL INT I.LS          IS #CA:
VAL INT I.STTRAPPED   IS #CB:
VAL INT I.CIRU        IS #CC:
VAL INT I.GINTDIS     IS #CD:
VAL INT I.GINTENB     IS #CE:
VAL INT I.FPREM       IS #CF:

--}}}  
--{{{  Dx 
VAL INT I.FPRN        IS #D0:
VAL INT I.FPDIVBY2    IS #D1:
VAL INT I.FPMULBY2    IS #D2:
VAL INT I.FPSQRT      IS #D3:
VAL INT I.FPRP        IS #D4:
VAL INT I.FPRM        IS #D5:
VAL INT I.FPRZ        IS #D6:
VAL INT I.FPR32TOR64  IS #D7:
VAL INT I.FPR64TOR32  IS #D8:
VAL INT I.FPEXPDEC32  IS #D9:
VAL INT I.FPEXPINC32  IS #DA:
VAL INT I.FPABS       IS #DB:
VAL INT I.FPADDDBSN   IS #DD:
VAL INT I.FPCHKI32    IS #DE:
VAL INT I.FPCHKI64    IS #DF:

--}}}  
--{{{  Ex 

--}}}  
--{{{  Fx 
VAL INT I.DEVLB       IS #F0:
VAL INT I.DEVSB       IS #F1:
VAL INT I.DEVLS       IS #F2:
VAL INT I.DEVSS       IS #F3:
VAL INT I.DEVLW       IS #F4:
VAL INT I.DEVSW       IS #F5:
VAL INT I.XSWORD      IS #F8:
VAL INT I.LSX         IS #F9:
VAL INT I.CS          IS #FA:
VAL INT I.CSU         IS #FB:
VAL INT I.TRAP        IS #FC:
VAL INT I.NULL        IS #FD:

--}}}  
--{{{  1xx 
VAL INT I.START        IS #1FF:
VAL INT I.LDDEVID      IS #17C:
--}}}  
--{{{  negatives 
VAL INT I.NEGATIVE    IS #08000:
VAL INT I.FPSTALL     IS ( #01 \/ I.NEGATIVE):
VAL INT I.FPLDALL     IS ( #02 \/ I.NEGATIVE):
VAL INT I.STSHADOW    IS ( #03 \/ I.NEGATIVE):
VAL INT I.LDSHADOW    IS ( #04 \/ I.NEGATIVE):
VAL INT I.TRET        IS ( #05 \/ I.NEGATIVE):
VAL INT I.GOPROT      IS ( #06 \/ I.NEGATIVE):
VAL INT I.SELTH       IS ( #07 \/ I.NEGATIVE):
VAL INT I.SYSCALL     IS ( #08 \/ I.NEGATIVE):
VAL INT I.TRAPENB     IS ( #09 \/ I.NEGATIVE):
VAL INT I.TRAPDIS     IS ( #0A \/ I.NEGATIVE):
VAL INT I.WAIT        IS ( #0B \/ I.NEGATIVE):
VAL INT I.SIGNAL      IS ( #0C \/ I.NEGATIVE):
VAL INT I.TIMESLICE   IS ( #0D \/ I.NEGATIVE):
VAL INT I.INSERTQUEUE IS ( #0E \/ I.NEGATIVE):
VAL INT I.SWAPTIMER   IS ( #0F \/ I.NEGATIVE):
VAL INT I.SWAPQUEUE   IS ( #10 \/ I.NEGATIVE):
VAL INT I.IRET        IS ( #11 \/ I.NEGATIVE):
VAL INT I.STOPCH      IS ( #12 \/ I.NEGATIVE):
VAL INT I.VOUT        IS ( #13 \/ I.NEGATIVE):
VAL INT I.VIN         IS ( #14 \/ I.NEGATIVE):
VAL INT I.STVLCB      IS ( #15 \/ I.NEGATIVE):
VAL INT I.LDVLCB      IS ( #16 \/ I.NEGATIVE):
VAL INT I.SWAPBFR     IS ( #17 \/ I.NEGATIVE):
VAL INT I.SETHDR      IS ( #18 \/ I.NEGATIVE):
VAL INT I.SETCHMODE   IS ( #19 \/ I.NEGATIVE):
VAL INT I.INITVLCB    IS ( #1A \/ I.NEGATIVE):
VAL INT I.WRITEHDR    IS ( #1B \/ I.NEGATIVE):
VAL INT I.READHDR     IS ( #1C \/ I.NEGATIVE):
VAL INT I.DISG        IS ( #1D \/ I.NEGATIVE):
VAL INT I.ENBG        IS ( #1E \/ I.NEGATIVE):
VAL INT I.GRANT       IS ( #1F \/ I.NEGATIVE):
VAL INT I.STMOVE2DINIT IS (#20 \/ I.NEGATIVE):
VAL INT I.CAUSEERROR  IS ( #21 \/ I.NEGATIVE):
VAL INT I.RESTART     IS ( #22 \/ I.NEGATIVE):
VAL INT I.UNMKRC      IS ( #23 \/ I.NEGATIVE):
VAL INT I.MKRC        IS ( #24 \/ I.NEGATIVE):
VAL INT I.IRDSQ       IS ( #25 \/ I.NEGATIVE):
VAL INT I.ERDSQ       IS ( #26 \/ I.NEGATIVE):
VAL INT I.STRESPTR    IS ( #27 \/ I.NEGATIVE):
VAL INT I.LDRESPTR    IS ( #28 \/ I.NEGATIVE):
VAL INT I.DEVMOVE     IS ( #2C \/ I.NEGATIVE):
VAL INT I.ICL         IS ( #2D \/ I.NEGATIVE):
VAL INT I.FDCL        IS ( #2E \/ I.NEGATIVE):
VAL INT I.ICA         IS ( #2F \/ I.NEGATIVE):
VAL INT I.FDCA        IS ( #30 \/ I.NEGATIVE):
VAL INT I.NOP         IS ( #40 \/ I.NEGATIVE):
VAL INT I.CLOCKENB    IS ( #41 \/ I.NEGATIVE):
VAL INT I.CLOCKDIS    IS ( #42 \/ I.NEGATIVE):
VAL INT I.LDCLOCK     IS ( #43 \/ I.NEGATIVE):
VAL INT I.STCLOCK     IS ( #44 \/ I.NEGATIVE):
VAL INT I.LDPRODID    IS ( #84 \/ I.NEGATIVE):
--}}}  

--}}}  
--}}}  
--{{{  transputer instructions - their effect on tstack
-- a value between -3,3 is the change in depth of tstack
-- a value >= 16 is 16 more than the new ts.depth to be set
--{{{  primaries
VAL [16]INT tsdiff.prim  IS [16, 1, 0, 0,         -- 00 j, ldlp, pfix, ldnl
                              1, 0, 0, 1,         -- 04 ldc, ldnlp, nfix, ldl
                              0, 16, -1, 0,       -- 08 adc, call, cj, ajw
                              0, -1, -2, 0]:       -- 0C eqc, stl, stnl, opr
--}}}  
--{{{  secondaries
VAL [#B0]INT tsdiff.sec    IS [0, 0, -1, 16,      -- 00 rev, lb, bsub, endp
                              -1, -1, 0, 16,      -- 04 diff, add, gcall, in
                              -1, -1, -1, 16,     -- 08 prod, gt, wsub, out
                              -1, 16, 16, 16,     -- 0C sub, startp, outbyte, outword
                              0, 0, 0, -1,        -- 10 seterr, ., resetch, csub0
                              0, 16, -2, -1,      -- 14 ., stopp, ladd, stlb
                              -1, 1, -1, 0,       -- 18 sthf, norm, ldiv, ldpi
                              -1, 1, 1, -1,       -- 1C stlf, xdble, ldpri, rem
                              16, 16, 1, 0,       -- 20 ret, lend, ldtimer, .
                              0, 0, 0, 0,         -- 24 ., ., ., .
                              0, 1, 1, 16,        -- 28 ., testerr, testpranal, tin
                              -1, 0, -2, -2,      -- 2C div, ., dist, disc
                              -1, -1, 0, -1,      -- 30 diss, lmul, not, xor
                              0, -1, -1, -1,      -- 34 bcnt, lshr, lshl, lsum
                              -2, 0, -1, -2,      -- 38 lsub, runp, xword, sb
                              0, -1, -1, 1,       -- 3C gajw, savel, saveh, wcnt
                              -1, -1, 1, 0,       -- 40 shr, shl, mint, alt
                              16, 0, -1, -1,      -- 44 altwt, altend, and, enbt
                              -1, 0, -3, -1,      -- 48 enbc, enbs, move, or
                              -1, -1, 0, -1,      -- 4C csngl, ccnt1, talt, ldiff
                              -1, 16, -1, -1,     -- 50 sthb, taltwt, sum, mul
                              -1, 0, -1, 0,       -- 54 sttimer, stoperr, cword, clrhalterr
                              0, 1, 1, 16,        -- 58 sethalterr, testhalterr, dup, move2dinit
                              16, 16, 16, 0,      -- 5C move2dall, move2dnonzero, move2dzero, .
                              0, 0, 0, 19,        -- 60 ., ., ., unpacksn
                              0, 0, 0, 0,         -- 64 ., ., ., .
                              0, 0, 0, 0,         -- 68 ., ., ., .
                              19, -2, 0, 0,       -- 6C postnormsn, roundsn, ., .
                              1, 0, -1, 0,        -- 70 ., ldinf, fmul, cflerr
                              -1, -1, -1, 0,      -- 74 crcword, crcbyte, bitcnt, bitrevword
                              -1, -1, 0, 0,       -- 78 bitrevnbits, pop, ., .
                              0, 0, 0, 0,         -- 7C ., ., ., .
                              0, -1, -2, 0,       -- 80 ., wsubdb, fpldnldbi, fpchkerr
                              -1, 0, -2, 0,       -- 84 fpstnldb, ., fpldnlsni, fpadd
                              -1, 0, -1, 0,       -- 88 fpstnlsn, fpsub, fpldnldb, fpmul
                              0, 0, -1, 1,        -- 8C fpdiv, ., fpldnlsn, fpremfirst
                              1, 1, 1, 1,         -- 90 fpremstep, fpnan, fpordered, fpnotfinite
                              1, 1, -1, 0,        -- 94 fpgt, fpeq, fpi32tor32, .
                              -1, 0, -1, 0,       -- 98 fpi32tor64, ., fpb32tor64, .
                              1, 0, -1, 0,        -- 9C fptesterr, fprtoi32, fpstnli32, fpldzerosn
                              0, 0, 0, 0,         -- A0 fpldzerodb, fpint, ., fpdup
                              0, 0, -1, 0,        -- A4 fprev, ., fpldnladddb, .
                              -1, 0, -1, -1,      -- A8 fpldnlmuldb, ., fpldnladdsn, fpentry
                              -1, 0, 0, 0]:       -- AC fpldnlmulsn, ., ., .
--}}}  
--}}}  
--{{{  constants defined by transputer instruction set and kernel
--{{{  ieee floating point
VAL INT32 INFINITY IS #7F800000:
VAL INT FPU.NONE IS -1:
-- are these the same on all processors - maybe not?
VAL INT FPU.N     IS 0:
VAL INT FPU.P     IS 1:
VAL INT FPU.M     IS 2:
VAL INT FPU.Z     IS 3:
--}}}  

-- offsets from Wptr with special uses
VAL LIT W.TIME     IS (-5)<<WSH:
VAL LIT W.TLINK    IS (-4)<<WSH:
VAL LIT W.STATUS   IS (-3)<<WSH:
VAL LIT W.LINK     IS (-2)<<WSH:
VAL LIT W.IPTR     IS (-1)<<WSH:
VAL LIT W.TEMP     IS 0:

-- loop control packet indexing
VAL LIT le.Index IS 0:
VAL LIT le.Count IS 1<<WSH:
VAL LIT pp.IptrSucc IS 0:
VAL LIT pp.Count IS 1<<WSH:

-- values used in some of these slots

VAL INT32 Z.ENABLING   IS NOT.PROCESS + 1:
VAL LIT ZZ.ENABLING  IS 1:
VAL INT32 Z.WAITING    IS NOT.PROCESS + 2:
VAL LIT ZZ.WAITING   IS 2:
VAL INT32 Z.READY      IS NOT.PROCESS + 3:
VAL LIT ZZ.READY     IS 3:

VAL INT32 Z.TIMESET     IS NOT.PROCESS + 1:
VAL LIT ZZ.TIMESET    IS 1:
VAL INT32 Z.TIMENOTSET  IS NOT.PROCESS + 2:
VAL LIT ZZ.TIMENOTSET IS 2:

VAL NoneSelected.o IS (-1):

--}}}  
